Package: XDE
Title: XDE: a Bayesian hierarchical model for cross-study analysis of
        differential gene expression
Version: 2.58.0
Date: 2020-09-01
Author: R.B. Scharpf, G. Parmigiani, A.B. Nobel, and H. Tjelmeland
Description: Multi-level model for cross-study detection of
        differential gene expression.
Depends: R (>= 2.10.0), Biobase (>= 2.5.5)
Imports: BiocGenerics, genefilter, graphics, grDevices, gtools,
        methods, stats, utils, mvtnorm, RColorBrewer, GeneMeta,
        siggenes
Suggests: MASS, RUnit
Maintainer: Robert Scharpf <rscharpf@jhsph.edu>
Enhances: coda
License: LGPL-2
Collate: functions.R AllClasses.R AllGenerics.R RUpdates.R
        methods-XdeParameter.R methods-matrix.R methods-data.frame.R
        methods-ExpressionSet.R methods-ExpressionSetList.R
        methods-mergeExpressionSet.R methods-Parameters.R
        methods-XdeMcmc.R xde.R zzz.R
LazyLoad: yes
biocViews: Microarray, DifferentialExpression
RoxygenNote: 7.1.1
git_url: https://git.bioconductor.org/packages/XDE
git_branch: RELEASE_3_23
git_last_commit: 2b99e82
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-29 01:28:05 UTC; biocbuild

Package: Test
Type: Package
Title: Testing R interface for MRF
Version: 1.0.7
Date: 2012-06-10
Author: HT, RS, MF
Maintainer:  <yourfault@somewhere.net>
Description: Testing R interface for MRF - I have tried to modify the clique part (Not working yet)
License: GPL
Packaged: 2012-10-02 18:13:27 UTC; rscharpf

##setMethod("chain.initialize", "XdeSet",
.chainInitialize <- function(object,
                             chain.length,
                             verbose){
              names(chain.length) <- c("potential",
                                        "acceptance",
                                        "nu",
                                        "deltaDelta",
                                        "a",
                                        "b",
                                        "c2",
                                        "gamma2",
                                        "r",
                                        "rho",
                                        "delta",
                                        "xi",
                                        "sigma2",
                                        "t",
                                        "l",
                                        "phi",
                                        "theta",
                                        "lambda",
                                        "tau2R",
				       "tau2Rho",
                                        "probDelta",
                                        "diffExpressed")

            ##These values are placeholders to create a chain of the
            ##right dimension.  If called, it is assumed that default
            ##starting values for the chain will be used.
            G <- nrow(object)
            QQ <- length(object)
            potential <- rep(0, 20*chain.length[["potential"]])
	      ##acceptance <- rep(0, 17*chain.length[["acceptance"]])
	      acceptance <- rep(0, 18*chain.length[["acceptance"]])
            Nu <- rep(0, G*QQ*chain.length[["nu"]])
            DDelta <- rep(0, G*QQ*chain.length[["deltaDelta"]])
            A <- rep(0, QQ*chain.length[["a"]])
            B <- rep(0, QQ*chain.length[["b"]])
            C2 <- rep(0, chain.length[["c2"]])
            Gamma2 <- rep(0, chain.length[["gamma2"]])
            Rho <- rep(0, QQ*(QQ-1)/2*chain.length[["rho"]])
            R <- rep(0, QQ*(QQ-1)/2*chain.length[["r"]])
            Delta <- rep(0, G*QQ*chain.length[["delta"]])
            Xi <- rep(0, QQ*chain.length[["xi"]])
            Sigma2 <- rep(0, QQ * G*chain.length[["sigma2"]])
            T <- rep(0, QQ*chain.length[["t"]])
            L <- rep(0, QQ*chain.length[["l"]])
            Phi <- rep(0, QQ * G*chain.length[["phi"]])
            Theta <- rep(0, QQ*chain.length[["theta"]])
            Lambda <- rep(0, QQ*chain.length[["lambda"]])
	      Tau2R <- Tau2Rho <- rep(0, QQ*chain.length[["tau2R"]])
            ProbDelta <- rep(0, G*QQ*chain.length[["probDelta"]])
            Diffexpressed <- rep(0, 3*G)
            eenv <- new.env()
            x <- list(Potential=potential,
                      Acceptance=acceptance,
                      Nu=Nu,
                      DDelta=DDelta,
                      A=A,
                      B=B,
                      C2=C2,
                      Gamma2=Gamma2,
                      R=R,
                      Rho=Rho,
                      Delta=Delta,
                      Xi=Xi,
                      Sigma2=Sigma2,
                      T=T,
                      L=L,
                      Phi=Phi,
                      Theta=Theta,
                      Lambda=Lambda,
                      Tau2R=Tau2R,
		      Tau2Rho=Tau2Rho,
                      ProbDelta=ProbDelta,
                      Diffexpressed=Diffexpressed)
              assign("vars", x, eenv)
              eenv
      }

calculatePosteriorAvg <- function(object, NCONC=2, NDIFF=1, burnin=0){
	if(class(object) != "XdeMcmc") stop("object must be of class XdeMcmc")
	if(iterations(object) < 10) stop("Too few iterations to compute posterior means")
	ii <- which((1:iterations(object)) > burnin)
	if(length(ii) < 1) stop("Not enough iterations after burnin to compute the posterior means")
	D <- object$DDelta
	d <- object$delta
	dD <- sign(d*D)
	##For each mcmc iteration, assess concordance, discordance
	myf <- function(x){
		##define an indicator for concordance
		##indicator for discordance
		tmp <- cbind(rowSums(x>0), rowSums(x < 0))
		##tmp <- t(rbind(colSums(x > 0), colSums(x < 0)))
		colnames(tmp) <- c("#up", "#down")
		discordant <- (tmp[, 1] * tmp[, 2]) != 0

		##1) no discordant signs
		concordant <- (tmp[, 1] * tmp[, 2]) == 0
		##2) let the number of concordant studies be user-specified
		concordant <- concordant * (rowSums(tmp) >= NCONC)
		diffExpr <- rowSums(abs(tmp)) >= NDIFF
		indicators <- matrix(c(concordant,
				       discordant,
				       diffExpr), ncol=3, byrow=FALSE)
	}
##	I <- array(NA, dim=dim(dD)
	I <- array(NA, c(dim(dD)[2], 3, dim(dD)[1]),
		   dimnames=list(featureNames(object),
		   c("concordant", "discordant", "diffExpressed"),
		   paste("iter", 1:dim(dD)[1], sep="_")))
	IT <- dim(dD)[1]
	for(i in 1:IT){
		I[, , i] <- myf(dD[i, , ])
	}
	concordant.avg <- rowMeans(I[, "concordant", ])
	discordant.avg <- rowMeans(I[, "discordant", ])
	diffExpressed.avg <- rowMeans(I[, "diffExpressed", ])
	X <- cbind(concordant.avg, discordant.avg, diffExpressed.avg)
	colnames(X) <- c("concordant", "discordant", "diffExpressed")
	rownames(X) <- featureNames(object)
	X
}


.parameterNames <- function(){
	c("thin",
	  "potential",
	  "acceptance",
	  "nu",
	  "DDelta",
	  "a",
	  "b",
	  "c2",
	  "gamma2",
	  "r",
	  "rho",
	  "delta",
	  "xi",
	  "sigma2",
	  "t",
	  "l",
	  "phi",
	  "theta",
	  "lambda",
	  "tau2R",
	  "tau2Rho",
	  "probDelta",
	  "diffExpressed")
}

.permutePhenotype <- function(object, seed, ...){
	if(missing(seed)){
		seed <- sample(0:100000, 1)
		set.seed(seed)
		print(paste("Seed", seed))
	}
	print(paste("permuting phenotypeLabel", phenotypeLabel(object)))
	object@data <- lapply(object, .permuteClassLabels, phenotype=phenotypeLabel(object))
	object
}

.permuteClassLabels <- function(object, phenotype, ...){
	pData(object)[, phenotype] <- permute(pData(object)[, phenotype])
	object
}

ssStatistic <- function(statistic=c("t", "sam", "z")[1],
                        phenotypeLabel,
                        esetList, ...){
	if(!(statistic == "t" | statistic == "sam" | statistic == "z")){
		stop("only t and sam study-specific statistics provided")
	}

	##-----------------------------------------------------------
	##Wrapper for Welch t-statistic
##	multtestWrapper <- function(eset, classlabel, ...){
##		require(multtest) || stop("Package multtest not available")
##		column <- grep(classlabel, colnames(pData(eset)))
##		if(length(column) == 0) { warning("Invalid classlabel.  Using the first column in phenoData"); classlabel <- pData(eset)[, 1]}
##		if(length(column) > 1)  {warning("More than 1 phenotype has the class label.  Using the first"); classlabel <- pData(eset)[, column[1]]}
##		if(length(column) == 1) classlabel <- pData(eset)[, column]
##		X <- exprs(eset)
##		stat <- mt.teststat(X=X, classlabel=classlabel, test="t",
##				    nonpara="n")
##		stat
##	}
	tt <- rowttests(esetList, phenotypeLabel)

	sam.wrapper <- function(eset, classlabel, method, returnQ, gene.names){
		##require(siggenes) || stop("Package siggenes not available")
		column <- grep(classlabel, colnames(pData(eset)))
		if(length(column) == 0) {
      warning("Invalid classlabel.  Using the first column in phenoData"); classlabel <- pData(eset)[, 1]
    }
		if(length(column) > 1)  {
      warning("More than 1 phenotype has the class label.  Using the first"); classlabel <- pData(eset)[, column[1]]
    }
		if(length(column) == 1) classlabel <- pData(eset)[, column]
		X <- exprs(eset)
		stat <- sam(data=X, cl=classlabel, method=method,
			    gene.names=gene.names)
		if(returnQ) stat <- stat@q.value else stat <- stat@d
		stat
	}

	z.wrapper <- function(object, classlabel, useREM=TRUE){
		##object is a list of ExpressionSets
		##require(GeneMeta) || stop("Package GeneMeta is not available")
		pDataList <- function(eset, covariateName){
			1-(pData(eset)[, grep(covariateName, colnames(pData(eset)))])
		}
		classes <- lapply(object, pDataList, classlabel)
		z <- zScores(object, classes=classes, useREM=useREM)
		##    z <- data.frame(z[, grep("zSco", colnames(z))])
		z <- z[, grep("zSco", colnames(z))]
		return(z)
	}

	##---------------------------------------------------------------------------
	##Wrapper for SAM-statistic
	stat <- switch(statistic,
##		       t=sapply(esetList, multtestWrapper, classlabel=phenotypeLabel),
		       t=tt,
		       sam=sapply(esetList, sam.wrapper, classlabel=phenotypeLabel,
		       returnQ=FALSE, method="d.stat", gene.names=featureNames(esetList), ...),
		       z=z.wrapper(object=esetList, classlabel=phenotypeLabel, useREM=TRUE))
	rownames(stat) <- featureNames(esetList)
	return(stat)
}

symbolsInteresting <- function(rankingStatistic, percentile=0.9,
                               colors=c("grey50", "royalblue"),
                               symbols=c(".", "o"),
                               size=c(3, 1),
                               background=c("white", "grey70")){
  thr <- quantile(rankingStatistic, probs=percentile)
##  avgC <- postAvg[, "concordant"]
  i <- rankingStatistic > thr
  N <- length(rankingStatistic)
  pch <- rep(symbols[1], N)
  j <- i[order(i)]
  pch[j] <- symbols[2]
  col <- rep(colors[1], N)
  col[j] <- colors[2]
  cex <- rep(size[1], N)
  cex[j] <- size[2]
  bg <- rep(background[1], N)
  bg[j] <- background[2]
  list(order=order(i), pch=pch, col=col, bg=bg, cex=cex)
}


##statistic should be the standardized Delta
xsScores <- function(statistic, N){
	if(class(statistic)[[1]] != "matrix") stop("study-specific statistics must be provided as a matrix")
	if(missing(N)) stop("Must specify the sample size of each study")

	scores <- matrix(NA, nrow(statistic), ncol=3)
	if(!is.null(rownames(statistic))) rownames(scores) <- rownames(statistic)
	colnames(scores) <- c("diffExpressed", "concordant", "discordant")

	##------------------------------------------------
	##Differential expression
	scores[, 1] <- .pca(abs(statistic), N=N)

	##------------------------------------------------
	##Concordance
	scores[, 2] <- abs(.pca(statistic, N=N))

	##------------------------------------------------
	##Discordance
	tmp <- cbind(rowSums(statistic > 0), rowSums(statistic < 0))
	I <- which((tmp[, 1] * tmp[, 2]) == 0)  ##concordant signs
##	I <- abs(rowSums(sign(statistic))) < ncol(statistic)
##	I[!I] <- -1
	scores[, 3] <- .pca(abs(statistic), N)
	##penalize concordance
	scores[I, 3] <- scores[I, 3] * -1
	return(scores)
}


.outputDefault <- function(thin=1, burnin=FALSE){
##  if(!burnin) out <- rep(1, 22) else out <- rep(0, 22)
	out <- rep(1, 23)
	out[1] <- thin
	out[23] <- 1  ##by default, keep a running average of the posterior statistics attached to the object (do not write to file)
	names(out) <- .parameterNames()
	return(out)
}
##Number of platforms (P)
.hyperparametersDefault <- function(P){
  ##Setting p_a^0, p_a^1, p_b^0, and p_b^1 = 0.1 (instead of 0) allows
  ##a and b to be identical to zero and 1 (10/23/2006 HT)
  hyperparameters <- c(1.0, 1.0, 0.1, 0.1,
                       1.0, 1.0, 0.1, 0.1,
                       P+1,
                       P+1,
                       1.0, 1.0,
                       50.0)
  names(hyperparameters) <- c("alpha.a", "beta.a", "p0.a", "p1.a",
                              "alpha.b", "beta.b", "p0.b", "p1.b",
                              "nu.r",
                              "nu.rho",
                              "alpha.xi", "beta.xi",
                              "c2max")
  hyperparameters
}



##.getPar <- function(object, ...){
##  as.list(...)
##}




###########################################################################
##Number of updates per iterations set as per Haakon's 10/23/2006 e-mail
###########################################################################
.updatesDefault <- function(){
  updates <- c(1, # nu Gibbs
                          1, # Delta Gibbs
                          3, # a
                          3, # b
                          1, # c2 Gibbs
                          1, # gamma2 Gibbs
                          3, # r and c2
                          3, # rho and gamma2
                          1, # delta
                          1, # xi Gibbs
                          1, # sigma2
                          1, # t and l
                          1, # l
                          1, # phi
                          1, # theta and lambda
                          1, # lambda
                          1, # tau2R
	       1) #tau2Rho
  names(updates) <- c("nu",
                      "Delta",
                      "a",
                      "b",
                      "c2",
                      "gamma2",
                      "rAndC2",
                      "rhoAndGamma2",
                      "delta",
                      "xi",
                      "sigma2",
                      "tAndL",
                      "l",
                      "phi",
                      "thetaAndLambda",
                      "lambda",
                      "tau2R",
		      "tau2Rho")
  updates
}

###########################################################################
##Tuning parameters set as per Haakon's 10/23/2006 e-mail
###########################################################################
.tuningDefault <- function(){
	##10/23/2006: HT
	tuning <- c(0.01,  #1. nu Gibbs
		    0.01,  #2. Delta Gibbs
		    0.04,  #3. a
		    0.04,  #4. b
		    0.01,  #5. c2 Gibbs
		    0.01,  #6. gamma2 Gibbs
		    0.01,  #7. r and c2
		    0.01,  #8. rho and gamma2
		    0.01,  #9. delta
		    0.01,  #10. xi Gibbs
		    0.50,  #11. sigma2
		    0.10,  #12. t and l
		    0.04,  #13. l
		    0.40,  #14. phi
		    0.10,  #15. theta and lambda
		    0.02,  #16. lambda
		    0.04,  #17. tau2R
		    0.04) #18. tau2Rho
  names(tuning) <- c("nu", "Delta",  "a", "b", "c2", "gamma2",
                     "rAndC2", "rhoAndGamma2", "delta", "xi", "sigma2",
                     "tAndL", "l", "phi", "thetaAndLambda", "lambda", "tau2R", "tau2Rho")
  return(tuning)
}



empiricalStart <- function(object, zeroNu=FALSE,
			   phenotypeLabel, one.delta=FALSE, T_THRESH=4){
	if(length(grep(phenotypeLabel, varLabels(object[[1]]))) < 1) stop("phenotypeLabel must be in varLabels")
	potential <- rep(0, 19)
	acceptance <- rep(0, 17)

	##order should be platforms, genes for nu, phi, sigma2, delta, and DDelta
	if(!zeroNu){
		meanExpression <- function(eset) rowMeans(exprs(eset))
		Nu <- sapply(object, meanExpression)
		Rho <- cor(Nu)
		##order should be 1_2, 1_3, ..., 1_P, 2_3, ..., 2_P, ...
		##R <- R[upper.tri(R)]  ##Not in the right order!
		cors <- list()
		if(nrow(Rho) > 1){
			for(i in 1:(nrow(Rho)-1)) cors[[i]] <- Rho[i, -(1:i)]
		} else cors[[1]] <- Rho
		Rho <- unlist(cors)

		NuVars <- apply(Nu, 2, "var")
		Gamma2 <- mean(NuVars)
		S <- length(NuVars)
		tau2Rho <- NuVars/(prod(NuVars))^(1/S)
		Nu <- as.vector(t(Nu))
		##the prior for gamma2 is an improper uniform distribution on (0, Inf)
	} else{
		Nu <- as.vector(matrix(0, nrow(object), length(object)))
		Rho <- rep(0, choose(length(object), 2))
		tau2Rho <- rep(0, length(object))
		Gamma2 <- 0
	}
	averageDifference <- function(eset, classLabel){
		## limma would be an easy way to fit a linear model to each gene
		phenoColumn <- grep(classLabel, names(pData(eset)))
		pheno <- pData(eset)[, phenoColumn]
		mn1 <- rowMeans(exprs(eset)[, pheno == 1])
		mn0 <- rowMeans(exprs(eset)[, pheno == 0])
		avdif <- mn1-mn0
		avdif
	}
	DDelta <- sapply(object, averageDifference, classLabel=phenotypeLabel)
	##require(genefilter)
	tt <- rowttests(object, phenotypeLabel)
	delta <- abs(tt) > T_THRESH
	if(one.delta){
		tmp <- ifelse(rowMeans(delta) > 0.5, 1, 0)
		delta <- matrix(tmp, nrow=length(tmp), ncol=length(object), byrow=FALSE)
	}
	if(any(colSums(delta) == 0)){
		##if none of the genes are differentially expressed in
		##some of the studies, set R at 0
		R <- rep(0, choose(S,2))
	} else 	{
		R <- cor(delta*DDelta)
		##order should be 1_2, 1_3, ..., 1_P, 2_3, ..., 2_P, ...
		##R <- R[upper.tri(R)]  ##Not in the right order!
		cors <- list()
		if(nrow(R) > 1){
			for(i in 1:(nrow(R)-1)) cors[[i]] <- R[i, -(1:i)]
		} else cors[[1]] <- R
		R <- unlist(cors)
	}
	DeltaVars <- apply(DDelta*delta, 2, "var")
	C2 <- mean(DeltaVars)
	S <- length(DeltaVars)
	if(any(colSums(delta)==0)){
		tau2R <- rep(1, S)
	} else {
		tau2R <- DeltaVars/(prod(DeltaVars))^(1/S)
	}
	##0.1 seems reasonable,  or the proportion of t-statistics > X
	Xi <- apply(delta, 2, "mean")
	Sigma2 <- sapply(lapply(object, exprs), rowVars)
	DDelta <- as.numeric(t(DDelta))
	delta <- as.numeric(t(delta))
	##Should we start at zero, 1, or somewhere in the middle?
	A <- rep(1, length(object))
	B <- rep(1, length(object))
	##Gamma with mean 1
	##L and T are mean and variance, respectively
	L <- as.numeric(colMeans(Sigma2))
	T <- as.numeric(apply(Sigma2, 2, var))
	Sigma2 <- as.numeric(t(Sigma2))
	##sigma2*phi is variance of expression values for patients with binary phenotype = 0
	##sigma2/phi is variance of expression values for patients with binary phenotype = 1
	Phi <- rep(1, (length(object) * nrow(object)))
	##Lambda and theta are the mean and variance for phi (study-specific)
	Lambda <- rep(1, length(object))
	Theta <- rep(0.05, length(object))
	##Tau2 is the relative scale of sigma across platforms
	##- the product is constrained to be one
	##- tau2 is shared by both nu and Delta
	##Tau2 <- rep(1, length(object))
	##Tau2 <- tau2.Delta * tau2.Nu
	linInitialValues <- list(Nu=Nu, DDelta=DDelta,
				 A=A, B=B, C2=C2, Gamma2=Gamma2,
				 R=R, Rho=Rho, Delta=delta,
				 Xi=Xi, Sigma2=Sigma2, T=T, L=L,
				 Phi=Phi, Theta=Theta, Lambda=Lambda,
				 Tau2R=tau2R,
				 Tau2Rho=tau2Rho)
	linInitialValues
}

computeGOF <- function(object,
                       nus,
                       Delta,
                       delta,
                       sigma2,
                       phi,
                       psi,
                       firstIteration,
                       lastIteration,
                       by=2){
	results <- list()
	avgM.k <- list()
	m.k <- 0
	##already thinned by 10
	I <- seq(firstIteration, lastIteration, by=by)
	NN <- length(I)
	for(p in seq(along=object)){
		cat("Study ", p, "\n")
		for(i in I){
			if(i %% 10 == 0) cat(i, " ")
			nus.1 <- nus[i, , ]
			Delta.1 <- Delta[i, , ]
			delta.1 <- delta[i, , ]
			sigma2.1 <- sigma2[i, , ]
			phi.1 <- phi[i, , ]
			sigma.1 <- sqrt(sigma2.1/phi.1)
			sigma.0 <- sqrt(sigma2.1*phi.1)
			##	trace(goodnessOfFit, browser)
			by <- 1/round(ncol(object[[p]])^0.4, 1)
			qtls <- qnorm(seq(0, 1, by=by), mean=0, sd=1)
			results[[p]] <- .goodnessOfFit(x=exprs(object[[p]]),
						      nus=nus.1[,p],
						      delta=delta.1[,p],
						      Delta=Delta.1[,p],
						      sigma.0=sigma.0[, p],
						      sigma.1=sigma.1[, p],
						      psi=psi[[p]],
						      qtls=qtls)
			m.k <- results[[p]]$m.k + m.k
		}
		m.k <- m.k/NN
		avgM.k[[p]] <- m.k
		m.k <- 0
		cat("\n")
	}
	pvals <- R.b <- list()
	for(p in 1:4){
		n.p.k <- ncol(object[[p]])*1/ncol(avgM.k[[p]])
		tmp <- ((avgM.k[[p]] - n.p.k)/sqrt(n.p.k))^2
		R.b[[p]] <- rowSums(tmp)
		pvals[[p]] <- -log10(1-pchisq(R.b[[p]], df=ncol(tmp)-1))
	}
	goodnessOfFit_results <- list(R.b, pvals)
	goodnessOfFit_results
}

.goodnessOfFit <- function(x, nus, delta, Delta, sigma.0, sigma.1, psi, qtls){
	Psi <- matrix(psi, nrow=nrow(x), ncol=ncol(x), byrow=TRUE)
	mus <- nus + delta * (2*Psi - 1)*Delta
	sigma <- sigma.0*(1-Psi) + sigma.1 * Psi
	m.k <- matrix(NA, nrow(x), length(qtls[-1]))

	##x <- exprs(object[[p]]) - mean(as.numeric(exprs(object[[p]])))
	x <- x-mean(as.numeric(x))
	z <- (x-mus)/sigma
	##determine bins by the inverse distribution function evaluated at theta.
	##
	##because we have a different mean and variance for psi=0,
	##psi=1, I standardized the x-values by theta and then
	##calculated the inverse quantiles
	R.b <- rep(NA, nrow(z))
	for(i in 1:nrow(z)){
		m.k[i, ] <- as.numeric(table(cut(as.numeric(z[i, ]), breaks=qtls, labels=seq(along=qtls[-1]))))
		n.p.k <- ncol(z)*1/length(qtls[-1])
		R.b[i] <- sum(((m.k[i, ] - n.p.k)/sqrt(n.p.k))^2)
	}
	pvals <- -log10(1-pchisq(R.b, df=ncol(m.k)-1))
	pvals[is.infinite(pvals)] <- 16
	##require(genefilter)
	sds0 <- rowSds(z[, psi==0])
	sds1 <- rowSds(z[, psi==1])
	n0 <- sum(psi==0)
	n1 <- sum(psi==1)
	sds <- (sds0*(n0-1) + sds1*(n1-1))/(n0+n1-2)
	return(list(pvals=pvals, R.b=R.b, sds=sds, z=z, m.k=m.k))
}

makeSigma <- function(G, Q, gamma2, tau2, a, sigma2, r){
	sigma <- sqrt(gamma2*tau2*exp(a*log(sigma2)))
	Sigma <- sigma %*% t(sigma)
	Sigma <- Sigma*r
	## check diagonals
	if(FALSE){
		correct.answer <- gamma2*tau2*exp(a*log(sigma2))
		answer2 <- diag(Sigma)
		all.equal(correct.answer, answer2)
	}
	return(Sigma)
}

##getParameters <- function(hyper.parameters, one.delta=FALSE, MRF=FALSE){
##Params <- function(hyper.parameters, one.delta=FALSE, MRF=FALSE){

##The chain in the initialization object always has length 1 for every parameter.
##The chain lengths of the output object has length iterations*output (if writeToFile is TRUE)
setMethod("initialize", "XdeParameter",
          function(.Object,
                   esetList,
                   updates=.updatesDefault(),
                   tuning=.tuningDefault(),
                   hyperparameters=.hyperparametersDefault(P=length(esetList)),
                   output=.outputDefault(),
                   iterations=as.integer(1000),
                   burnin=FALSE,
                   seed=runif(1, 0, 1e6), ##Default is NULL
                   genes=integer(0),
                   studies=integer(),
                   firstMcmc=new.env(),
                   specifiedInitialValues=FALSE,
                   directory=".",
                   phenotypeLabel="",
                   showIterations=TRUE,
                   verbose=FALSE,
		   one.delta=TRUE,
                   studyNames=names(esetList),
		   center=TRUE){
		  if(missing(esetList)) stop("Must provide an ExpressionSetList in order to set up default values for XDE")
		  if(class(esetList) != "ExpressionSetList"){
			  esetList <- as(esetList, "ExpressionSetList")
		  }
		  ##check that phenotypeLabel is in each ExpressionSet
		  if(!(all(sapply(esetList, function(x, label){ label %in% varLabels(x)}, label=phenotypeLabel)))){
			  stop("supplied phenotypeLabel must be present in all ExpressionSets")
		  } else{
			  .Object@phenotypeLabel <- phenotypeLabel
		  }
		  if(length(studyNames) != length(esetList)){
			  studyNames <- paste("study", 1:length(esetList), sep="")
		  }
		  .Object@studyNames <- studyNames
		  .Object@updates <- updates            
		  ##Directory to write files to must exist
		  if(!burnin){
			  if(!file.exists(directory)){
				  print(paste(directory, "does not exist. Creating new one"))
				  dir.create(directory, recursive=TRUE)
			  }
		  } else{
			  ##rep(0,22) if taus uncoupled; rep(0,21) otherwise
			  output <- c(1, rep(0, 22))
			  names(output) <- .parameterNames()              
		  }
		  .Object@tuning <- tuning
		  .Object@hyperparameters <- .hyperparametersDefault(length(esetList))
		  .Object@output <- output
		  .Object@seed <- as.integer(seed)
		  .Object@directory <- paste(directory, "/", sep="")
		  .Object@verbose <- verbose
		  .Object@one.delta <- one.delta
	    
		  ##if firstIteration is not supplied
		  if(length(firstMcmc) == 0){
			  .Object@specifiedInitialValues <- FALSE
			  .Object@iterations <- 1
			  .Object@showIterations <- FALSE
			  chain.length <- rep(1, length(2:length(output)))
			  ##only need to store the results from one iteration
			  ##Nothing will be written to file if burnin is TRUE
			  .Object@burnin <- TRUE
			  firstMcmc(.Object) <- .chainInitialize(object=esetList,
								 chain.length=chain.length,
								 verbose=verbose)
			  ##get starting values by simulating from the prior
			  firstMcmc(.Object) <- lastMcmc(xde(paramsMcmc=.Object, esetList=esetList, center=center))
		  } else{
			  firstMcmc(.Object) <- firstMcmc
		  }
		  .Object@specifiedInitialValues <- TRUE            
		  .Object@burnin <- burnin            
		  .Object@iterations <- iterations
		  .Object@showIterations <- showIterations
		  .Object
          })


setMethod("burnin", "XdeParameter", function(object) object@burnin)
setReplaceMethod("burnin", c("XdeParameter", "logical"), function(object, value){
	object@burnin <- value
	if(value) {
		##uncouple taus
		object@output[2:23] <- rep(0, 22)
	} else {
		##uncouple taus
		object@output[2:23] <- rep(1, 22)
	}
	names(object@output) <- .parameterNames()    
	object
})


setMethod("firstMcmc", "XdeParameter",  function(object) object@firstMcmc$vars)
setReplaceMethod("firstMcmc", c("XdeParameter", "environment"),
                 function(object, value){
                   object@firstMcmc <- value
                   object
                 })
setReplaceMethod("firstMcmc", c("XdeParameter", "list"),
                 function(object, value){
                   eenv <- new.env()
                   assign("vars", value, eenv)
                   names(eenv$vars) <- names(value)
                   object@firstMcmc <- eenv
                   object
                 })

setMethod("directory", "XdeParameter", function(object) object@directory)
setReplaceMethod("directory", "XdeParameter",
                 function(object, value){
			 fname <- paste(value, "/", sep="")
			 if(!file.exists(fname)){
				 print("Directory does not exist. Creating new directory")
				 dir.create(path=fname, recursive=TRUE)
			 } 
			 object@directory <- fname
			 object
                 })

##setMethod("featureData", "XdeParameter", function(object) object@featureData)
##setReplaceMethod("featureData", "XdeParameter", function(object, value){
##  object@featureData <- value
##  object
##})

setMethod("hyperparameters", "XdeParameter", function(object) object@hyperparameters)
setReplaceMethod("hyperparameters", "XdeParameter", function(object, value) {
  object@hyperparameters <- value
  object
})

setMethod("iterations", "XdeParameter", function(object) object@iterations)
setReplaceMethod("iterations", c("XdeParameter", "numeric"),
                 function(object, value){
                   object@iterations <- as.integer(value)
                   object
                 })
setReplaceMethod("iterations", c("XdeParameter", "integer"),
                 function(object, value){
                   object@iterations <- value
                   object
                 })

setMethod("output", "XdeParameter", function(object) object@output)
setReplaceMethod("output", "XdeParameter", function(object, value){
  object@output <- value
  names(object@output) <- .parameterNames()
  ##if output is nonzero, then values are written to file
  if(any(value[2:length(value)] > 0)) object@burnin <- FALSE
  object
})

setMethod("phenotypeLabel", "XdeParameter", function(object) object@phenotypeLabel)
setReplaceMethod("phenotypeLabel", c("XdeParameter", "character"), 
  function(object, value){
    object@phenotypeLabel <- value
    object
    })

setMethod("savedIterations", "XdeParameter", function(object) object@iterations/output(object)[1])

setMethod("show", "XdeParameter",
          function(object){
            cat("Instance of", class(object), "\n\n")
            cat("hyperparameters:\n")
            print(hyperparameters(object)[1:8])
            cat("...\n\n")
            cat("updates (frequency of updates per MCMC iteration):\n")
            print(updates(object)[1:5])
            cat("... \n\n")
            cat("tuning (the epsilon for Metropolis-Hastings proposals): \n")
            print(tuning(object)[1:5])
            cat("...\n\n")
            cat("output (parameters to save (0 = not saved, 1 = saved to log file): \n")
            print(output(object)[2:6])
            cat("...\n\n")
            cat("iterations: ", iterations(object), "\n")
            cat("thin: ", thin(object), "\n")                        
            cat("seed: ", seed(object), "\n")
            cat("notes: ", object@notes, "\n")
            cat("firstMcmc: \n")
            str(firstMcmc(object)[1:5])
            cat("...\n\n")
            cat("showIterations: ", showIterations(object), "\n")
            cat("specifiedInitialValues: ", object@specifiedInitialValues, "\n")
            cat("directory (where to save the MCMC chains): ", directory(object), "\n")
            cat("phenotypeLabel: ", phenotypeLabel(object), "\n")
            cat("studyNames: ", studyNames(object), "\n")
	    cat("one.delta: ", object@one.delta, "\n")
          })
            
setMethod("showIterations", "XdeParameter", function(object) object@showIterations)
setReplaceMethod("showIterations", "XdeParameter", function(object, value){ object@showIterations <- value; return(object)})
setMethod("seed", "XdeParameter", function(object) object@seed)
setReplaceMethod("seed", c("XdeParameter", "integer"),
                 function(object, value){
                   object@seed <- value
                   object
                 })
setReplaceMethod("seed", c("XdeParameter", "numeric"),
                 function(object, value){
                   object@seed <- as.integer(value)
                   object
                 })

setMethod("studyNames", "XdeParameter", function(object) object@studyNames)
setReplaceMethod("studyNames", "XdeParameter",
                 function(object, value){
                   object@studyNames <- value
                   object
                 })

setMethod("thin", "XdeParameter", function(x, ...) output(x)[1])
setReplaceMethod("thin", c("XdeParameter", "numeric"),
                 function(x, value){
                   output(x)[1] <- value
                   x
                 })

setMethod("tuning", "XdeParameter", function(object) object@tuning)
setReplaceMethod("tuning", "XdeParameter",
                 function(object, value){
                   object@tuning <- value
                   names(object@tuning) <- .parameterNames()[4:20]
                   object
                 })

setMethod("updates", "XdeParameter", function(object)  object@updates)
setReplaceMethod("updates", "XdeParameter",
                 function(object, value){
                   object@updates <- value
                   names(object@updates) <- .parameterNames()[4:21]
                   object
                 })

## from xmapcore package
if( require( "RUnit", quietly=TRUE ) ) {
	pkg <- "XDE"

	if( Sys.getenv( "RCMDCHECK" ) == "FALSE" ) {
		path <- file.path( getwd(), "..", "inst", "unitTests" )
	} else {
		path <- system.file( package=pkg, "unitTests" )
	}

	cat( "\nRunning unit tests\n" )
	print( list( pkg=pkg, getwd=getwd(), pathToUnitTests=path ) )
	library( package=pkg, character.only=TRUE )

	##xmap.clear.cache()

	##Fail on warnings
	options( warn=2 )

	## Get the pattern (if there is one?)
	patt <- Sys.getenv( "RUNITFILEPATTERN" )
	if( is.null( patt ) || nchar( patt ) == 0 ) {
		testSuite <- defineTestSuite(name=paste( pkg, "unit testing" ),
					     dirs=path,
					     testFileRegexp=paste( "^test.+", patt, "\\.[rR]$", sep="" ))
	} else {
		##testSuite <- defineTestSuite( name=paste( pkg, "unit testing" ), testFileRegexp=paste( "^runit\\.", patt, "\\.[rR]$", sep="" ), dirs=path )
		testSuite <- defineTestSuite(name=paste( pkg, "unit testing" ),
					     testFileRegexp=paste( "^test.+", patt, "\\.[rR]$", sep="" ),
					     dirs=path )
	}
	tests <- runTestSuite( testSuite )

	pathReport <- file.path( path, "report" )

	cat( "------------------- UNIT TEST SUMMARY ---------------------\n\n" )
	printTextProtocol( tests, showDetails=FALSE )
	printTextProtocol( tests, showDetails=FALSE, fileName=paste( pathReport, "Summary.txt", sep="" ) )
	printTextProtocol( tests, showDetails=TRUE,  fileName=paste( pathReport, ".txt", sep="" ) )

	printHTMLProtocol( tests, fileName=paste( pathReport, ".html", sep="" ) )

	tmp <- getErrors( tests )
	if( tmp$nFail > 0 | tmp$nErr > 0 ){
		stop( paste( "\n\nunit testing failed (#test failures: ", tmp$nFail, ", #R errors: ",  tmp$nErr, ")\n\n", sep=""))
	}
} else {
	warning( "cannot run unit tests -- package RUnit is not available" )
}

library(XDE)
data(expressionSetList)

###Initializing slots common to all Models
commonParams <- XDE:::Parameters(object=expressionSetList, clinicalCovariate="adenoVsquamous")
commonObject <- XDE:::startingValues(commonParams, expressionSetList, "adenoVsquamous")



###Initializing Model C

objectC=as(commonObject, "ParametersC")
objectC@betag=rep(1.0, 1500) 
objectC@nNeighbour=rep(1L, 1500)
objectC@neighbour=rep(1L, 1500)
objectC@alpha=rep(1.0, 1500)
objectC@beta=rep(1.0, 1500)

setMethod("initialize", signature(.Object="ParametersC"), function(.Object, ...){
  object=callNextMethod(.Object, ...)
  object@betag -...
  object@nNeighbour -...
  object@neighbour -...
  object@alpha -...
  object@beta -...
    return(object)
})

#paramsC <- new("ParametersC")

#dms <- dims(paramsC)
#objectC <- XDE:::startingValues(paramsC,
#                                expressionSetList,
#                                "adenoVsquamous")

##
#orig <- objectC
#dms2 <- dims(objectC)
#one.delta <- FALSE
#all.equal(dms, dms2)
##


##Updates for all models
objectC <- modelA_B_MIupdates(objectC)

##C-specific updates
objectC <- rupdateAlpha(object=objectC,
                        nTry=5L,
                        epsilon=0.1,
                        dryrun=FALSE)

objectC <- rupdateBeta(object=objectC,
                       nTry=5L,
                       epsilon=0.1,
                       dryrun=FALSE)

objectC <- rupdateBetag(object=objectC,
                        nTry=5L,
                        epsilon=0.1,
                        dryrun=FALSE)

##Model C update common between C and D
objectC <- rupdateDeltaDDelta_MRF2(object=objectC,
                                   nTry=5L,
                                   dryrun=FALSE,
                                   one.delta=FALSE)

##Model C update common between C and D
objectC <- rupdateDelta_MRF2(object=objectC,
                             nTry=5L,
                             dryrun=FALSE,
                             one.delta=FALSE)




###Initializing Model D


##paramsD <- XDE:::ParametersD(object=expressionSetList,
##                             clinicalCovariate="adenoVsquamous")
##paramsD <- new("ParametersD")
##objectD=as(commonObject, "ParametersC")
##tmp=XDE::Parameters(expressionSetList, clinicalCovariate="adenoVsquamous")
##objD=as(tmp, "ParametersD")


objectD=as(commonObject, "ParametersD")
objectD@nNeighbour=rep(1L, 1500)
objectD@neighbour=rep(1L, 1500)
objectD@alpha=rep(1.0, 1500)
objectD@beta=rep(1.0, 1500)


setMethod("initialize", signature(.Object="ParametersD"), function(.Object, ...){
object=callNextMethod(.Object, ...)
object@nNeighbour -...
object@neighbour -...
object@alpha -...
object@beta -...
return(object)
})

#dms <- dims()
#objectD <- XDE:::startingValues(paramsD,expressionSetList,"adenoVsquamous")
#orig <- objectD
#dms2 <- dims(objectD)
#one.delta <- FALSE
#all.equal(dms, dms2)
                    
##common updates
objectD <- modelA_B_MIupdates(objectD) 

##D-specifc updates
objectD <- rupdateAlpha_onedelta(object=objectD,
                        nTry=5L,
                        epsilon=0.1,
                        dryrun=FALSE)

objectD <- rupdateBeta_onedelta(object=objectD,
                       nTry=5L,
                       epsilon=0.1,
                       dryrun=FALSE)

##Model C update common between C and D
objectD <- rupdateDeltaDDelta_MRF2(object=objectD,
                                   nTry=5L,
                                   dryrun=FALSE,
                                   one.delta=TRUE) 

##Model D update common between C and D
objectD <- rupdateDelta_MRF2(object=objectD,
                             nTry=5L,
                             dryrun=FALSE,
                             one.delta=TRUE) 

THISPKG <- "XDE"

.onAttach <- function(libname, pkgname) {
	version <- packageDescription("XDE", fields="Version")
	packageStartupMessage("Welcome to XDE version ", version)
}

.onUnload <- function( libpath ){
	library.dynam.unload(THISPKG, libpath)
}

setMethod("initialize", "XdeMcmc",
          function(.Object,
                   studyNames="",
                   featureNames=character(),
                   iterations=numeric(),
                   seed=integer(),
                   output=numeric(),
                   directory="./",
                   lastMcmc=new.env(),
                   posteriorAvg=NULL,
                   bayesianEffectSize=NULL){
            .Object@studyNames <- studyNames
            .Object@featureNames <- featureNames
            .Object@iterations <- iterations
            .Object@seed <- seed
            .Object@output <- output
            .Object@directory <- directory
            .Object@lastMcmc <- lastMcmc
            .Object@posteriorAvg <- posteriorAvg
            .Object@bayesianEffectSize <- bayesianEffectSize
            .Object
    })

setMethod("$", "XdeMcmc", function(x, name) {
	if(!(name %in% .parameterNames()[output(x) != 0])){
		stop(paste("Parameter", name, "not saved.  See output for XdeParameter object"))
	}
	mcmc <- scan(paste(directory(x), "/", name, ".log", sep = ""))

	##---------------------------------------------------------------------------
	##Parameters indexed by gene and study
	##
	## If ITER iterations were executed, there are ITER lines written to the file. 
	## Each line is a big vector in the following order:
	## gene1 study 1, gene 1 study2, ... , gene1 study P, gene 2 study 1, ...
	## Or,
	##iter1:     nu_11, nu_12, ..., nu_1P, nu_21, ..., nu_2P, nu_G1, ..., nu_GP
	##iter2:     nu_11, nu_12, ..., nu_1P, nu_21, ..., nu_2P, nu_G1, ..., nu_GP
	##
	## for the nu parameter.
	##
	## For reading in arrays, the 'left subscript moves the fastest'
	##
	## scan() reads in the data by rows.
	## Therefore, the fastest moving index is study, followed by genes and then the mcmc iteration. 
	##
	##  mcmc <- array(mcmc, dim=c(# studies, # genes, # iterations)) is equiv to
	## For iteration 1:
	## mcmc[1, 1, 1] <- nu_11
	## mcmc[2, 1, 1] <- nu_12
	## mcmc[P, 1, 1] <- nu_1P
	## mcmc[1, 2, 1] <- nu_21
	## mcmc[2, 2, 1] <- nu_22
	## ...
	## mcmc[P, 2, 1] <- nu_2P
	## ...
	## Example:
	##	tmp <- outer(1:10, 1:3, FUN="*")
	##	tmp2 <- as.numeric(t(tmp))
	##	tmp2 <- rbind(tmp2, tmp2)
	##      ##rows are iterations
	##	write.table(tmp2, file="tmp2.txt", sep=" ", quote=FALSE, row.names=FALSE,col.names=FALSE)
	##	x=scan("tmp2.txt")
	##	y=array(x, dim=c(3, 10,  2))
	##	y <- aperm(y)
	##---------------------------------------------------------------------------	
	if(name %in% c("DDelta", "nu", "phi", "sigma2", "delta", "probDelta")){
		I <- iterations(x)
		mcmc <- array(mcmc,
			      dim=c(length(studyNames(x)),
			      nrow(x),
			      iterations(x)),
			      dimnames=list(studyNames(x),
			      featureNames(x),
			      as.character(1:I)))
		##Now transform this to an array with dimensions:
		## iteration x features x study
		mcmc <- aperm(mcmc)
		return(mcmc)
	}
	##--------------------------------------------------

	##Parameters indexed by study
	if(name %in% c("a", "b", "lambda", "l", "tau2", "t", "theta", "xi", "tau2R", "tau2Rho")){
		nr <- iterations(x)
		nc <- length(studyNames(x))
		if(length(mcmc) < nr*nc) byrow <- FALSE else byrow <- TRUE
		mcmc <- matrix(mcmc, nrow=iterations(x), ncol=length(studyNames(x)), byrow=byrow)
		colnames(mcmc) <- studyNames(x)
		return(mcmc)    
	}

  ##################################################
	##Parameters not indexed by gene or study
	if(name %in% c("c2", "gamma2")){
		mcmc <- matrix(mcmc, ncol=1, byrow=TRUE)
		if(name == "c2"){
			##check for xi-inflation
			if(median(mcmc, na.rm=TRUE) < 0.01){
				warning("c2 values are small.  The estimated proportion of differentially expressed genes in a study (given by the parameter xi) is likely inflated.  See the discussion in the XDE manuscript for additional details")
			}
		}
		return(mcmc)    
	}

  ##################################################  
	##Correlation parameters
	if(name %in% c("r", "rho")){
		S <- length(studyNames(x))
		mcmc <- matrix(mcmc, ncol=S*(S-1)/2, byrow=TRUE)
		return(mcmc)    
	}

	##---------------------------------------------------------------------------
	##Diagnostics
	if(name == "acceptance"){
		mcmc <- matrix(mcmc, ncol = 18, nrow = iterations(x), byrow = TRUE)
		##Drop parameters updated by gibbs
		##mcmc <- mcmc[, -c(1, 2, 5, 6, 10)]
		colnames(mcmc) <- c("nu", "Delta", "a", "b", "c2", "gamma2",
				    "r", "rho", "delta", "xi", "sigma2",
				    "t", "l", "phi", "theta", "lambda", "tauR", "tau2Rho")
		return(mcmc)
	}
	if(name == "potential"){
		mcmc <- matrix(mcmc, ncol=20, byrow=TRUE)
		colnames(mcmc) <- c("posterior", "likelihood_potential",
				    .parameterNames()[4:21])
		return(mcmc)
	}

	if(name == "diffExpressed"){
		mcmc <- matrix(mcmc, ncol=3, byrow=FALSE)
		colnames(mcmc) <- c("diffExpressed", "concordant", "discordant")
		return(mcmc)
	}
  
	stop(paste("Supplied name not found.  Should be one of", .parameterNames()[2:22]))
	##  eval(substitute(pData(x)$NAME_ARG, list(NAME_ARG=name)))
})

##setMethod("[", "XdeMcmc", function(x, i, j, ..., drop = FALSE){
##	if (missing(drop)) drop <- FALSE
##	if (missing(i) && missing(j))
##	{
##		if (length(list(...))!=0)
##			stop("specify genes or samples to subset; use '",
##			     substitute(x), "$", names(list(...))[[1]],
##			     "' to access phenoData variables")
##		return(x)
##	}
##	if (!missing(j)){
##		f <- function(x, j){
##			x <- x[, j]
##		}
##		x <- lapply(x, f, j)
##	}
##	if(!missing(i)){
##		f <- function(x, i){
##			x <- x[i, ]
##		}
##		x <- lapply(x, f, i)
##	}
##	as(x, "ExpressionSetList")
##})

setMethod("bayesianEffectSize", "XdeMcmc", function(object) object@bayesianEffectSize)

setReplaceMethod("bayesianEffectSize", c("XdeMcmc", "matrix"),
                 function(object, value){
			 object@bayesianEffectSize <- value
			 object
		 })

setMethod("calculateBayesianEffectSize", "XdeMcmc",
          function(object){
		  D <- .standardizedDelta(object)
		  averageDelta <- apply(D, c(2, 3), "mean")
		  averageDelta
          })

setMethod("directory", "XdeMcmc", function(object) object@directory)
setMethod("featureNames", "XdeMcmc", function(object) object@featureNames)
setMethod("iterations", "XdeMcmc", function(object) object@iterations)
setMethod("lastMcmc", "XdeMcmc", function(object) object@lastMcmc)
setMethod("nrow", "XdeMcmc", function(x) length(featureNames(x)))
setMethod("output", "XdeMcmc", function(object) object@output)

##setMethod("calculatePosteriorAvg", "XdeMcmc", function(object, NCONC=2, NDIFF=2){

setMethod("posteriorAvg", "XdeMcmc", function(object) object@posteriorAvg)
setReplaceMethod("posteriorAvg", c("XdeMcmc", "matrix"),
		 function(object, value){
			 object@posteriorAvg <- value
			 object
		 })

setMethod("seed", "XdeMcmc", function(object) object@seed)
setMethod("studyNames", "XdeMcmc", function(object) object@studyNames)
	  
setMethod(".standardizedDelta", "XdeMcmc",
          function(object, deltaProduct=TRUE){
		  delta <- object$delta
		  sqrt.c2 <- sqrt(object$c2)
		  sigma <- sqrt(object$sigma2)
		  if("tau2R" %in% names(output(object))){
			  separateTau <- TRUE
		  } else separateTau <- FALSE
		  if(separateTau){
			  tau <- sqrt(object$tau2R)
			  ##tauRho <- sqrt(object$tau2Rho)
		  } else{
			  tau <- sqrt(object$tau2)
		  }
		  b <- object$b
		  dDelta <- object$DDelta
		  s <- array(NA, dim=dim(sigma))
		  ##dDelta <- Delta
		  P <- dim(sigma)[3]
		  ##For each platform...
		  for(p in 1:P){
			  s[, , p] <- (sigma[, , p]^b[,p])*tau[, p]*as.numeric(sqrt.c2)
		  }
		  dDelta <- dDelta * delta
		  D <- dDelta/s
		  D
          })

setMethod("show", "XdeMcmc",
          function(object){
		  cat("Instance of", class(object), "\n")
		  cat("Study names:", studyNames(object), "\n")
		  cat("Number of features:" , length(featureNames(object)), "\n\n")
		  ##cat("phenotypeLabel", phenotypeLabel(object), "\n\n")
		  cat("seed (a new seed):", seed(object), "\n\n")            
		  cat("iterations (saved):", iterations(object), "\n\n")
		  out <- as.logical(output(object)[2:length(output(object))])
		  names(out) <- .parameterNames()[2:length(output(object))]
		  cat("output (parameters saved):\n")
		  print(out)
		  cat("\n")
		  cat("directory (of saved log files):", directory(object), "\n\n")
		  cat("lastMcmc:", class(lastMcmc(object)), "\n\n")
		  if(!is.null(posteriorAvg(object))){
			  cat("posteriorAvg:\n")
			  str(posteriorAvg(object))
			  cat("\n")
		  } else cat("posteriorAvg: NULL\n")
		  if(!is.null(bayesianEffectSize(object))){
			  cat("bayesianEffectSize:\n")
			  str(bayesianEffectSize(object))
			  cat("\n\n")
		  } else cat("bayesianEffectSize: NULL\n")
		  return()
          })

setMethod("plot", "XdeMcmc",
          function(x, y, op, verbose=FALSE, ...){
		  if(missing(y)){
			  getLogs <- function(object){
				  params <- output(object)[output(object) == 1]
				  params <- params[!(names(params) %in% c("nu", "phi", "DDelta", "delta", "sigma2", "diffExpressed"))]
				  names(params)
			  }
			  y <- getLogs(x)
		  }
		  params <- lapply(lapply(as.list(y), function(name, object) eval(substitute(object$NAME_ARG, list(NAME_ARG=name))), object=x), as.ts)
		  names(params) <- y
		  tracefxn <- function(x, name)  plot(x, plot.type="single", col=1:ncol(x), ylab=name)
		  mapply(tracefxn, params, name=names(params))			  
          })

##setValidity("Params", function(object){
##	nms <- names(object)
##	p.nms <- parameterNames()
##	if(!all(p.nms %in% nms)){
##		message("Missing one or more parameters required for the class:")
##		return(setdiff(p.nms, nms))
##	}
##	TRUE
##})
## initialize an instance of the class Params
##setMethod("Params", signature(object="HyperParams"),
Parameters <- function(object,
		       G=nrow(object),
		       QQ=length(object),
		       S=sapply(object, ncol),
		       clinicalCovariate,
		       psi=phenotype(object, clinicalCovariate),
		       one.delta,
		       MRF=FALSE,
		   alphaA=1.0,
		   betaA=1.0,
		   alphaB=1.0,
		   betaB=1.0,
		   pA0=0.1,
		   pA1=0.1,
		   pB0=0.1,
		   pB1=0.1,
		   nuR=1.0+QQ,
		   nuRho=1.0+QQ,
		   alphaXi=1.0,
		   betaXi=1.0,
		   c2Max=10.0,
		   alphaEta=1.0,
		   betaEta=1.0,
		   pOmega0=0.1,
		   lambdaOmega=1.0,
		   lambdaKappa=1.0,
		   seed=123L,
		   ...){
	if(missing(one.delta)) stop("one.delta should be logical, but is missing")
		  ##require(mvtnorm)
##		  if(!missing(object)){
##			  stopifnot(is(object, "ExpressionSetList"))
##			  Gs <- sapply(object, nrow)
##			  stopifnot(length(unique(Gs)) == 1)
##			  G <- Gs[[1]]
##			  QQ <- length(object)
##			  S <- sapply(object, ncol)
##			  psi <- phenotype(object, clinicalCovariate)
##			  stopifnot(length(vectorize(psi)) == sum(S))
##		  } else {
##		  if(missing(object)){
##			  anymissing <- missing(G) | missing(QQ) | missing(S)
##			  stopifnot(!anymissing)
##			  psi <- NULL
##		  }
	stopifnot(!missing(object))
	psi <- vectorize(psi)
	xi <- rep(0.5, QQ)
	gamma2 <- 0.5*0.5
	c2 <- 0.5*0.5
	tau2Rho <- rep(1.0, QQ)
	tau2R <- rep(1.0,QQ)
	a <- b <- rep(NA, QQ)
	l <- rep(1.0, QQ)
	t <- rep(0.5^2, QQ)
	sigma2 <- matrix(NA, G, QQ)
	## simulate variances from gamma
	param2 <- l/t
	param1 <- l*param2
	for(q in seq(length=QQ)){
		u <- runif(1)
		if(u < pA0){
			a[q] <- 0
		} else {
			if(u < pA0+pA1){
				a[q] <- 1
			} else {
				a[q] <-runif(1)
			}
		}
		u <- runif(1)
		if(u < pB0){
			b[q] <- 0
		} else {
			if(u < pB0+pB1){
				b[q] <- 1
			} else {
				b[q] <-runif(1)
			}
		}
		## in R, mean is shape * scale and variance is shape*scale^2
		## in Haakon's formulation, mean = l and variance = t
		## => shape=l^2/t and scale =t/l
		##  (this means that param2 is the rate and param1 is the shape
		sigma2[, q] <- rgamma(G, shape=param1[q], rate=param2[q])
	}
	## the platform index changes the fastest, then gene
	##sigma2 <- as.numeric(t(sigma2))
	##
	## initialize phi
	lambda <- rep(1.0, QQ)
	theta <- rep(0.1*0.1, QQ)
	param2 <- lambda/theta
	param1 <- lambda*theta
	phi <- matrix(NA, G, QQ)
	for(q in seq(length=QQ)){
		phi[, q] <- rgamma(G, shape=param1[q], rate=param2[q])
	}
	##r <- rho <- rep(0.5, QQ*(QQ-1)/2)
	r <- rho <- matrix(NA, QQ, QQ)
	diag(r) <- diag(rho) <- 1
	rho[upper.tri(rho)] <- r[upper.tri(r)] <- 0.5
	rho[lower.tri(rho)] <- r[lower.tri(r)] <- 0.5
	## nu
	nu <- matrix(NA, G, QQ)
	for(g in seq(length=G)){
		Sig <- makeSigma(Q=QQ, gamma2=gamma2, tau2=tau2Rho, a=a,
				 sigma2=sigma2[g, ], r=rho)
		## simulate from multivariate normal
		nu[g, ] <- rmvnorm(1, sigma=Sig)
	}
	Delta <- matrix(NA, G, QQ)
	for(g in seq(length=G)){
		R <- makeSigma(Q=QQ, gamma2=c2, tau2=tau2Rho, a=b,
			       sigma2=sigma2[g, ], r=r)
		## simulate from multivariate normal
		Delta[g, ] <- rmvnorm(1, sigma=Sig)
	}
	##---------------------------------------------------------------------------
	##
	## Simulating delta
	##
	## There are 4 prior models for delta:
	##    model A: one delta
	##    model B: study-specific delta
	##    model C: MRF study-specific delta
	##    model D: MRF one delta
	##
	##---------------------------------------------------------------------------
	## Delta in the Rinterface.cpp file there are different
	## functions relating to each of the now four prior models for
	##
	## delta
	##
	## model A:
	##         updateXi_onedelta
	##         updateDeltaDDelta_onedelta
	##
	## model B:
	##         updateXi
	##         updateDeltaDDelta
	##
	## model C:
	##         updateAlpha_MRF
	##         updateBeta_MRF
	##         updateBetag_MRF
	##         updateDeltaDDelta_MRF
	##
	##
	## model D:
	##         updateAlpha_MRF_onedelta
	##         updateBeta_MRF_onedelta
	##         updateDeltaDDelta_MRF_onedelta
	##
	alpha.mrf <- -0.2  ## in (-Inf, +Inf)
	beta.mrf <- 3.0    ## > 0
	if(one.delta){
		delta <- rbinom(G, 1, 0.2)
		## This results in Cholesky problems
		##Delta[delta==0, ] <- 0
	} else{
		delta <- matrix(rbinom(G*QQ, 1, 0.2), G, QQ)
	}
	##	if(!MRF){
	##		if(one.delta){
	##			## model A
	##			##delta <- rep(0L, G)
	##			delta <- rbinom(G, 1, 0.2)
	##		} else {
	##			## model B (default)
	##			delta <- matrix(0L, G, QQ)
	##		}
	##	} else {
	##		## 1. specify alpha.mrf, beta.mrf
	##		## 2. specify |N_g|
	##		## 3. sample |N_g| indices from {1, ..., G} to form N_g for each g
	##		## 4. simulate delta_g or delta_gp from Bernoulli(prob), with
	##		##    prob = exp (...)/(1+exp(...))
	##		##    ... =
	##		##
	##		if(one.delta){
	##			delta <- rbinom(G, 1, 0.2)
	##			## model D
	##			## a subset of genes are differentially expressed
	##			##    the probability of a gene's differential expression
	##			##    depends on other genes in the network and is assumed
	##			##    to be the same across platforms.
	##			## Let's assume 20% of the genes are differentially expressed
	##
	##			##
	##			##
	##		} else {
	##			## model C
	##			delta <- matrix(NA, G, Q)
	##		}
	##	}
	##		  hyper.params <- data.frame(
	rho <- rho[upper.tri(rho)]
	r <- r[upper.tri(r)]
	new("Parameters",
	    seed=seed,
	    data=expressionVector(object),
	    phenodata=psi,
	    Q=as.integer(QQ),
	    G=as.integer(G),
	    S=as.integer(S),
	    alphaA=alphaA,
	    alphaB=alphaB,
	    betaA=betaA,
	    betaB=betaB,
	    pA0=pA0,
	    pA1=pA1,
	    pB0=pB0,
	    pB1=pB1,
	    nuR=nuR,
	    nuRho=nuRho,
	    alphaXi=alphaXi,
	    betaXi=betaXi,
	    c2Max=c2Max,
	    alphaEta=alphaEta,
	    betaEta=betaEta,
	    pOmega0=pOmega0,
	    lambdaOmega=lambdaOmega,
	    lambdaKappa=lambdaKappa,
	    gamma2=gamma2,
	    c2=c2,
	    tau2Rho=tau2Rho,
	    tau2R=tau2R,
	    a=a,
	    b=b,
	    l=l,
	    t=t,
	    lambda=lambda,
	    theta=theta,
	    phi=vectorize(phi),
	    sigma2=vectorize(sigma2),
	    r=r,
	    rho=rho,
	    nu=vectorize(nu),
	    delta=vectorize(delta),
	    Delta=vectorize(Delta),
	    xi=vectorize(xi))
#		  res <- as(res, "Params")
##		  return(res)
	  }

setMethod("show", signature(object="Parameters"),
	  function(object){
		  cat("class Parameters: elements of class include\n")
		  nms <- slotNames(object)
		  L <- rep(NA, length(nms))
		  headers <- vector("list", length(nms))
		  for(i in seq_len(length(L))){
			  obj <- eval(substitute(object@NAME_ARG, list(NAME_ARG=nms[i])))
			  L[i] <- length(obj)
			  ##headers <- head(obj)
		  }
		  cls <- sapply(nms, function(x, object){
			  class(eval(substitute(object@NAME_ARG, list(NAME_ARG=x))))
		  }, object=object)
		  size <- paste("[1:", L, "]", sep="")
		  res <- data.frame(nms=nms, cls=substr(cls, 1,3), size=size)
		  row.names(res) <- NULL
		  colnames(res) <- c("slots", "type", "size")
		  print(head(res))
		  cat("\n...\n")
		  colnames(res)<-
		  print(tail(res))
	  })

setMethod("exprs", signature(object="Parameters"),
	  function(object) object@data)

setMethod("vectorize", signature(object="integer"), function(object) return(object))
setMethod("vectorize", signature(object="numeric"), function(object) return(object))
##setMethod("vectorize", signature(object="Params"), function(object){
##	## gene index changes fastest, then study index
##	object$nu <- vectorize(object$nu)
##	object$delta <- vectorize(object$delta)
##	object$Delta <- vectorize(object$Delta)
##	object$phi <- vectorize(object$phi)
##	if(is(object$rho, "matrix")){
##		rho <- object$rho
##		rho <- rho[upper.tri(rho)]
##		object$rho <- rho
##	}
##	object$sigma2 <- vectorize(object$sigma2)
##	return(object)
##})
##setMethod("show", signature(object="Params"), function(object) print(ls.str(object)))
setAs("XdeParameter", "Parameters", function(from){
	x <- firstMcmc(from)
	S <- length(x[["Xi"]])
	G <- length(x[["Nu"]])/S
	res <- list(gamma2=x[["Gamma2"]],
		    c2=x[["C2"]],
		    tau2Rho=x[["Tau2Rho"]],
		    tau2R=x[["Tau2R"]],
		    a=x[["A"]],
		    b=x[["B"]],
		    l=x[["L"]],
		    t=x[["T"]],
		    lambda=x[["Lambda"]],
		    theta=x[["Theta"]],
		    phi=matrix(x[["Phi"]], G, S),
		    sigma2=matrix(x[["Sigma2"]],G,S),
		    r=x[["R"]],
		    rho=x[["Rho"]],
		    delta=matrix(x[["Delta"]], G, S),
		    nu=matrix(x[["Nu"]], G, S),
		    Delta=matrix(x[["DDelta"]], G, S),
		    xi=x[["Xi"]])
	res <- as(res, "Params")
	return(res)
})
setMethod("$", "Parameters", function(x, name){
	slot(x, name)
	##eval(substitute(x@NAME_ARG, list(NAME_ARG=name)))
})

setReplaceMethod("$", "Parameters", function(x, name, value){
	slot(x, name) <- value
	##eval(substitute(x@NAME_ARG, list(NAME_ARG=name)))
})

setMethod("pnames", "Parameters", function(object){
	slotNames(object)
})

setMethod("[[", "Parameters", function(x,i,j,...){
	if(!is.character(i)) return(x)
	if(length(i) > 1) stop("invalid subsetting")
	slot(x, i)
})

setReplaceMethod("[[", "Parameters", function(x,i,j,...,value){
	if(!is.character(i)) return(x)
	if(length(i) > 1) stop("invalid subsetting")
	slot(x, i) <- value
	x
})

setMethod("dims", "Parameters", function(x){
	nms <- slotNames(x)
	L <- length(nms)
	res <- rep(NA, L)
	for(i in seq_len(L)) res[i] <- length(slot(x, nms[i]))
	names(res) <- nms
	return(res)
})

startingValues <- function(params, expressionSetList, phenotypeLabel, one.delta){
	if(missing(one.delta)) stop("one.delta should be logical but is missing")
	params.xde <- firstMcmc(new("XdeParameter", esetList=expressionSetList,
				    phenotypeLabel=phenotypeLabel, one.delta=one.delta))
	nms <- names(params.xde)
	firstletter <- tolower(substr(nms, 1, 1))
	nms2 <- paste(firstletter, substr(nms,2, nchar(nms)),sep="")
	nms2[nms2=="dDelta"] <- "Delta"
	all(nms2%in% slotNames(params))
	names(params.xde) <- nms2
	for(i in seq_along(nms2)){
		nm <- nms2[i]
		params[[nm]] <- params.xde[[nm]]
	}
	return(params)
}



          ##nipun: for ParametersD

          ParametersD <- function(object,...){
            tmp <- Parameters(object,...)
            object <- as(tmp, "ParametersD")
            object@alpha <- 1.0
            object@beta <- 1.0

          }


          ##nipun: for ParametersC

          ParametersC <- function(object,...){
            tmp <- ParametersD(object,...)
            object <- as(tmp, "ParametersC")
            object@betag <- 1.0
          }



          ##nipun: for ParametersMII

          ParametersMII <- function(object,...){
            tmp <- Parameters(object,...)
            object <- as(tmp, "ParametersMII")
            object@Omega <- 1.0
          }

##object is a LinearXdeSet or loglinearXdeSet
## setMethod("integrativeCorrelationFilter", "mergeExpressionSet",
##           function(object, fdrCut, ...){
## 		  ##require(gtools) || stop("gtools package not available")
## 		  ##require(MergeMaid) || stop("MergeMaid package not available")
## 		  if(missing(fdrCut)) stop("must specify fdrCut (FDR threshold)")
## 		  emp <- pairwise.cors(intCor(object))
## 		  ##This is the approximation to the null (does fine if you have
## 		  ##thousands of genes)
## 		  message("approximating the null distribution for the integrative correlation...")
## 		  null <- intcorDens(object)
## 		  null <- do.call(cbind, null)            
## 		  ##Find the cutoff, c,  at which
## 		  ##(NULL_c)/(NULL_c + EMP_c) = fdrcut
## 		  ##Lowering the fdrCut applies a more stringent integrative correlation filter
## 		  findCuts <- function(x1, x2, probs=seq(0.6, 0.99, by=0.005), fdrCut){
## 			  k <- 1
## 			  quantiles <- quantile(x2, probs)
## 			  fdrhat <- 1
## 			  while(fdrhat > fdrCut & k <= length(quantiles)){
## 				  p.null <- sum(x1 > quantiles[k])/length(x1)
## 				  p.emp <- sum(x2 > quantiles[k])/length(x2)
## 				  fdrhat <- p.null/(p.null + p.emp)
## 				  ##print(fdrhat)
## 				  if(is.na(fdrhat)) { warning("0 in fdr denominator"); break()}
## 				  if(k+1 < length(quantiles)) k <- k+1 else break()
## 			  }
## 			  quantiles[k]
## 		  }
## 		  N <- ncol(emp)
## 		  cut <- rep(NA, N)  ##a threshold for each pairwise combination of studies
## 		  for(i in 1:N)   cut[i] <- findCuts(null[, i], emp[, i], fdrCut=fdrCut)
## 		  print(paste("integrative correlation coefficient threshold:", round(cut, 2)))
## 		  
## 		  ##Define an indicator matrix for each gene x study-pair
## 		  cuts <- matrix(NA, nrow=nrow(emp), ncol=ncol(emp))
## 		  for(i in 1:N){
## 			  cuts[, i] <- emp[, i] > cut[i]
## 		  }
## 		  return(cuts)
##           })

library(XDE)
data(expressionSetList)

## initializing A
paramsA <- XDE:::Parameters(object=expressionSetList,
                           clinicalCovariate="adenoVsquamous")
##No additional slots for A
dms <- dims(paramsA)
objectA <- XDE:::startingValues(paramsA,
                                expressionSetList,
                                "adenoVsquamous")
orig <- objectA
dms2 <- dims(objectA)
one.delta <- FALSE
all.equal(dms, dms2)

##objectA updates (no specific updates for MA)
trace(modelA_B_MIupdates, browser)
objectA <- modelA_B_MIupdates(objectA)


## initializing B
paramsB <- XDE:::Parameters(object=expressionSetList,
                             clinicalCovariate="adenoVsquamous")
##No additional slots for B
dms <- dims(paramsB)
objectB <- XDE:::startingValues(paramsB,
                                expressionSetList,
                                "adenoVsquamous")
orig <- objectB
dms2 <- dims(objectB)
one.delta <- FALSE
all.equal(dms, dms2)

##objectB updates (no specific updates for MA)
objectB <- modelA_B_MIupdates(objectB)

library(Test)
##trace(initializeParams, browser)
initializeParams(G=50L, nIt=1L, Q=3L, S=c(10L, 10L, 10L), seed=1L)

	## #################################################################################
	##str(oldClique)
	##str(unlist(oldComponents))
	##str(nOld)
	##str(nTotalInClique)
	## Omega
##	OmegaM = diag(rep(0,G))
##	Si = NULL
##	Omega = NULL
##	CliquesF <- vector("list", nClique)
##	for (i in 1:(nClique)){
##		Ci = which(clique==i-1)
##		cli = oldClique[i]
##		if (cli>=0){
##			list1 = oldComponents[[i]]
##			CiS = CliquesF[[cli+1]]
##			Si = CiS[list1]
##			CliquesF[[i]] = sort(c(Ci,Si))
##		}
##		else {
##			CliquesF[[i]] = Ci
##		}
##		setC = c(Ci,Si)
##		OmegaM[setC,setC] = 2
##		Om = OmegaM[setC,setC]
##		Omega = c(Omega,c(Om[lower.tri(Om,diag=TRUE)]))
##	}
##	Omega[is.na(Omega)] <- 2

## add arguments for number genes, etc. so that these are not hardcoded
##
## have updated parameters written to files
##
## Can only pass 65 arguments
## TODO
##
## - change initializeParams such that G, Q, psi (clinical
##   parameters), etc. are inputs
##
## - have an option that selects which parameters are
##   written to file
##
## - modify such that mcmc samples are appended to files according to
##  previous option (see how sigma2 and phi are currently written to
##  file, and adopt this for other parameters)
##
## - modify such that only selected iterations are appended to file
##
## - modify such that data is passed to the function and not simulated
## - (or have an option that allows passing data)
##
## - many of the specific update types are already available with R wrappers
##   (see R/Rupdates.R)
##   -> initializeParams could be changed to only provide initial parameters
##   -> using .C, we would need to specify the correct size for each parameter as input
##      to initializeParams function
##

setMethod("dim", "ExpressionSetList", function(x) sapply(x, dim))

setMethod("rowttests", "ExpressionSetList", function(x, fac, tstatOnly=FALSE){
	sapply(x, function(x) rowttests(x, fac, tstatOnly)$statistic)
})

setMethod("lapply", "ExpressionSetList", function(X, FUN, ...){
	  X <- lapply(as(X, "list"), FUN, ...)
	  if(all(sapply(X, class) == "ExpressionSet")){
		  X <- as(X, "ExpressionSetList")
	  }
	  return(X)
	  })

setMethod("[", "ExpressionSetList", function(x, i, j, ..., drop = FALSE){
            if (missing(drop)) drop <- FALSE
            if (missing(i) && missing(j))
              {
                 if (length(list(...))!=0)
                   stop("specify genes or samples to subset; use '",
                        substitute(x), "$", names(list(...))[[1]],
                        "' to access phenoData variables")
                 return(x)
               }
            if (!missing(j)){
              f1 <- function(x, j){
                x <- x[, j]
              }
              x <- lapply(x, f1, j)
            }
            if(!missing(i)){
              f2 <- function(x, i){
                x <- x[i, ]
              }
              x <- lapply(x, f2, i)
            }
            as(x, "ExpressionSetList")
          })

setAs("list", "ExpressionSetList",
      function(from, to){
        new("ExpressionSetList", from)
      })

setMethod("featureNames", "ExpressionSetList", function(object) featureNames(object[[1]]))
setMethod("nrow", "ExpressionSetList", function(x) nrow(x[[1]]))
setMethod("nSamples", "ExpressionSetList", function(x)  unlist(lapply(x, function(x) ncol(x))))

setMethod(".pca", "ExpressionSetList",
          function(object, x, ...){
		  P <- length(object)
		  N <- nSamples(object)
		  G <- nrow(object)
		  principal.components <- function(x, P, N, G){
			  ##1. obtain the effect sizes in the P studies
			  ##   - these are stored in 'x'

			  ##2. center the effect sizes by their means
			  meancen <- colMeans(x)
			  xcen <- sweep(x, 2, meancen)

			  ##3. Fit principal components to w1, w2, and w3 using
			  ##   covariance, saving a1, a2 and a3, the loadings of the first
			  ##   principal component.
			  fit <- princomp(xcen, cor = FALSE)
			  a <- fit$loadings[1:P, 1]

			  ##4. Estimate the combined effect: (see p.9 of Garrett-Mayer
			  ##   paper)
			  weight <- sum(a * sqrt(N))
			  combined.effect <- matrix(NA, ncol=P, nrow=G)
			  for(i in 1:P){
				  combined.effect[,i] <- a[i] * sqrt(N[i]) * xcen[, i]
			  }
			  score <- apply(combined.effect, 1, sum)
			  score <- score/weight
			  return(score)
		  }
		  score <- principal.components(x=x, P=P, N=N, G=G)
		  return(score)
          })

setMethod("pData", "ExpressionSetList",
          function(object){
            f <- function(x) pData(x)
            lapply(object, f)
          })

setMethod("standardizeSamples", "ExpressionSetList",
          function(object, ...){
            standardizeColumns <- function(object){
              colSds <- function(x) rowSds(t(x))
              sds <- colSds(exprs(object))
              exprs(object) <- t(apply(exprs(object), 1, "/", sds))
              mns <- colMeans(exprs(object))
              exprs(object) <- sweep(exprs(object), 2, mns)
              object
            }
            object <- lapply(object, standardizeColumns)
            object
          })

setMethod("geneCenter", "ExpressionSetList",
          function(object){
		  mean.center <- function(x){
			  ##xx.c <- rowMeans(exprs(x))
			  exprs(x) <- exprs(x) - rowMeans(exprs(x))
			  ##exprs(x) <- sweep(exprs(x), 1, xx.c)
			  return(x)
		  }
		  object <- lapply(object, mean.center)
		  object
	  })

setMethod("studyCenter", "ExpressionSetList",
          function(object){
            mean.center <- function(x){
              overallMean <- mean(exprs(x))
              exprs(x) <- exprs(x) - overallMean
              return(x)
            }
            object <- lapply(object, mean.center)
            as(object, "ExpressionSetList")
          })

setMethod("zeroNu", "ExpressionSetList",
          function(object, phenotypeLabel, one.delta=FALSE, ...){
		  if(missing(phenotypeLabel)) stop("must specify phenotypeLabel (character string)")
		  object <- geneCenter(object)

		  ##Note that by zeroing the nu's we must specify initial
		  ##values and can not draw random samples from the prior
		  ##(could result in illegal values)
		  ##            params <- new("XdeParameter", phenotypeLabel=phenotypeLabel, expressionSetList=object)
		  params <- new("XdeParameter", esetList=object, phenotypeLabel=phenotypeLabel,
				one.delta=one.delta)
		  firstMcmc <- empiricalStart(object, zeroNu=TRUE, phenotypeLabel=phenotypeLabel, one.delta=one.delta)
		  firstMcmc$A <- rep(0, length(object))
		  firstMcmc$Rho <- rep(0, choose(length(object), 2))
		  firstMcmc$Tau2Rho <- rep(1, length(object))
		  up <- updates(params)
		  up["nu"] <- 0
		  up["a"] <- 0
		  up["gamma2"] <- 0
		  up["rhoAndGamma2"] <- 0
		  up["tau2Rho"] <- 0
		  updates(params) <- up
		  firstMcmc(params) <- firstMcmc
		  params
          })

setMethod("goodnessOfFit", c("ExpressionSetList", "XdeMcmc"),
	  function(object,
             fit,
             phenotype,
             firstIteration=1,
             lastIteration=iterations(fit),
             by=2){
		  stopifnot(phenotype %in% varLabels(object[[1]]))
		  psi <- lapply(object, function(x) pData(x)[, match(phenotype, varLabels(object))])
		  nus <- fit$nu
		  Delta <- fit$DDelta
		  delta <- fit$delta
		  sigma2 <- fit$sigma2
		  phi <- fit$phi
		  computeGOF(object,
                 nus=nus,
                 Delta=Delta,
                 delta=delta,
                 sigma2=sigma2,
                 phi=phi,
                 psi=psi,
                 firstIteration=firstIteration,
                 lastIteration=lastIteration,
                 by=by)
	  })


##setMethod("getHyperparameters", signature(object="ExpressionSetList"),


##setMethod("getHyperparameters", signature(object="NULL"),
##	  function(object, G, Q, S, ...){
##		  anymissing <- missing(G) | missing(Q) | missing(S)
##		  stopifnot(!anymissing)
##
##		  betaA <- alphaA <- 1.0
##		  pA0 <- pA1 <- 0.1
##
##		  ##
##		  betaB <- alphaB <- 1.0
##		  pA0 <- pB0 <- 0.1
##
##		  nuR <- 1.0+Q
##		  nuRho <- 1.0+Q
##
##		  betaXi <- alphaXi <- 1.0
##
##		  c2Max <- 10.0
##
##		  betaEta <- alphaEta <- 1.0
##
##		  pOmega0 <- 0.1
##		  lambdaOmega <- 1.0
##		  lambdaKappa <- 1.0
##
##		  res <- list(G=G,
##			      Q=Q,
##			      S=S,
##			      alphaA=alphaA,
##			      betaA=betaA,
##			      pA0=pA0,
##			      pA1=pA1,
##			      nuR=nuR,
##			      nuRho=nuRho,
##			      alphaXi=alphaXi,
##			      betaXi=betaXi,
##			      c2Max=c2Max,
##			      alphaEta=alphaEta,
##			      betaEta=betaEta,
##			      pOmega0=pOmega0,
##			      lambdaOmega=lambdaOmega,
##			      lambdaKappa=lambdaKappa)
##		  return(res)
##	  })
setMethod("phenotype", signature(object="ExpressionSetList", varLabel="character"),
	  function(object, varLabel){
		  stopifnot(all(sapply(object, function(x, label){ label %in% varLabels(x)}, label=varLabel)))
		  f <- function(object, varLabel){
			  as.integer(eval(substitute(object$NAME_ARG, list(NAME_ARG=varLabel))))
		  }
		  clinical.var <- sapply(object, f, varLabel)
		  unique.var <- unique(as.integer(clinical.var))
		  stopifnot(is(unique.var, "integer"))
		  stopifnot(all(unique.var %in% 0:1))
		  return(clinical.var)
	  })
setMethod("expressionVector", signature(object="ExpressionSetList"),
	  function(object){
		  ##x: A vector of expression values.
		  ## The order of the values is
		  ## x_gsp
		  ## sample index changes the fastest, then gene, then study
		  ## x_{1,1,1},  ... , x_{1, S_1, 1}, x_{2,1,1} ... x_{G,S_1,1}
		  x <- lapply(object, exprs)
		  x <- lapply(x, expressionVector)
		  ##x <- expressionVector(x)
		  ##x <- lapply(object, function(object) as.numeric(exprs(object)))
		  x <- unlist(x)
		  return(x)
	  })

setClassUnion("NULLorNumeric", c("NULL", "numeric"))
setClassUnion("NULLorMatrix", c("NULL", "matrix"))
validityMethod <- function(object){
	validExpressionSet <- sapply(object, function(eset) validObject(eset))
	if(any(!validExpressionSet)) {
		return("Each element in ExpressionSetList must be a valid ExpressionSet")
	}
	##featureNames should be identical for all elements of the list.
	fnList <- sapply(object, featureNames)
	if(class(fnList)[[1]] != "matrix") {
		return("all objects in ExpressionSetList must have the same number of features")
	}

	f <- function(features){
		length(unique(features)) == 1
	}

	identicalFeatureNames <- apply(fnList, 1, f)
	if(any(!identicalFeatureNames)) {
		return("featureNames must be in the same order for each element in the list")
	}
	return(TRUE)
}
setClass("ExpressionSetList", representation("list"),
         validity=validityMethod)




##output of MCMC -- only the posterior averages
setClass("XdeMcmc", ##contains="ExpressionSetList",
         representation(studyNames="character",
                        featureNames="character",
                        iterations="numeric",
                        directory="character",
                        seed="integer",
                        output="numeric",
                        lastMcmc="environment",
                        posteriorAvg="NULLorMatrix",
                        bayesianEffectSize="NULLorMatrix"))

##Parameters needed to fit XDE, including starting values
setClass("XdeParameter",
         representation(updates = "numeric",
                        tuning = "numeric",
                        hyperparameters = "numeric",
                        output = "numeric",
                        iterations = "numeric",
                        burnin="logical",
                        seed = "integer",
                        notes = "character",
                        firstMcmc="environment",
                        showIterations="logical",
                        specifiedInitialValues="logical",
                        directory="character",
                        phenotypeLabel="character",
                        verbose="logical",
                        studyNames="character",
			one.delta="logical"))


##setClass("HyperParams", contains="list")
##setClass("Params", contains="list")
##setClass("foo", contains="list",
##	 representation(A="numeric",
##			B="numeric"))
##setValidity("foo", function(object){
##	c("A", "B") %in% names(object)
##}


setClass("Parameters",
	 representation(seed="integer",
			data="numeric",##"environment",
			phenodata="integer",
			G="integer",
			Q="integer",
			S="integer",
			alphaA="numeric",
			alphaB="numeric",
			betaA="numeric",
			betaB="numeric",
			pA0="numeric",
			pA1="numeric",
			pB0="numeric",
			pB1="numeric",
			nuR="numeric",
			nuRho="numeric",
			alphaXi="numeric",
			betaXi="numeric",
			c2Max="numeric",
			alphaEta="numeric",
			betaEta="numeric",
			pOmega0="numeric",
			lambdaOmega="numeric",
			lambdaKappa="numeric",
			gamma2="numeric",
			c2="numeric",
			tau2Rho="numeric",
			tau2R="numeric",
			a="numeric",
			b="numeric",
			l="numeric",
			t="numeric",
			lambda="numeric",
			theta="numeric",
			phi="numeric",
			sigma2="numeric",
			r="numeric",
			rho="numeric",
			nu="numeric",
			delta="numeric",
			Delta="numeric",
			xi="numeric"))
setGeneric("pnames", function(object) standardGeneric("pnames"))

setValidity("Parameters", function(object){
	if(length(exprs(object)) != object@G*sum(object@S))
		return("data should have length G*sum(S)")
})##nipun: slots are common to Models A,B and MI 


##nipun: ParametersD
setClass("ParametersD",contains= "Parameters",
         representation(nNeighbour="integer",
                        neighbour="integer",
                        alpha="numeric",
                        beta="numeric"))
##setGeneric("pnamesII", function(object) standardGeneric("pnames")) ##:?

setValidity("ParametersD", function(object){
  if(length(exprs(object)) != object@G*sum(object@S))
    return("data should have length G*sum(S)")
})



##nipun: Parameters specific to model C
setClass("ParametersC",contains= "ParametersD",
         representation(betag="numeric"))
##setGeneric("pnamesII", function(object) standardGeneric("pnames")) ##??

setValidity("ParametersC", function(object){
  if(length(exprs(object)) != object@G*sum(object@S))
    return("data should have length G*sum(S)")
})


##nipun: Parameters specific to model II
setClass("ParametersMII",contains= "Parameters",
         representation(Omega="numeric",
                        zeta = "numeric",
                        D = "numeric",
                        nClique="integer",
                        oldClique="integer",
                        nOldComponents="integer",
                        nNewComponents="integer",
                        oldComponents="integer"))
##setGeneric("pnamesII", function(object) standardGeneric("pnames")) ##??

setValidity("ParametersMII", function(object){
  if(length(exprs(object)) != object@G*sum(object@S))
    return("data should have length G*sum(S)")
})

library(XDE)
data(expressionSetList)
## some initial values
## one.delta is 'model B'
initial.paramsA <- XDE:::Parameters(object=expressionSetList,
				    clinicalCovariate="adenoVsquamous",
				    one.delta=TRUE)
##
## there should probably be a model specification here (model A or model B)
##
## There should be a C entry point to get initial values for all
## parameters under model A or model B... could probably use the 'v1'
## interface for this
##
paramsA <- XDE:::startingValues(initial.paramsA, expressionSetList,
				"adenoVsquamous", one.delta=TRUE)

## ideally, this should all be one step
initial.paramsB <- XDE:::Parameters(object=expressionSetList, clinicalCovariate="adenoVsquamous",
				    one.delta=FALSE)
paramsB <- XDE:::startingValues(initial.paramsB, expressionSetList, "adenoVsquamous", one.delta=FALSE)
orig <- params2
dms2 <- dims(params2)
one.delta <- FALSE
all.equal(dms, dms2)
for(i in 1:50){
	##
	## An entry point for each of the C routines in Rintervace_v2.cpp
	##
	## Updates that can be used by all model variants
	##
	a=paramsA@a
	paramsA <- rupdateANu(object=paramsA, nTry=5L,
			      epsilon=0.1, dryrun=FALSE)
	paramsA <- rupdateTau2RhoNu(object=paramsA,
				    nTry=5L, epsilon=0.1, dryrun=FALSE)
	paramsA <- rupdateNu(object=paramsA, dryrun=FALSE)
	paramsA <- rupdateGamma2(object=paramsA, dryrun=FALSE)
	paramsA <- rupdateRhoNu(object=paramsA,
				nTry=5L,
				epsilon=0.1,
				dryrun=FALSE)
	paramsA <- rupdateRhoGamma2(object=paramsA,
				    nTry=5L,
				    epsilon=0.1,
				    dryrun=FALSE)
	paramsA <- rupdatePhi(object=paramsA,
				 nTry=5L,
				 epsilon=0.1,
				 dryrun=FALSE)
	paramsA <- rupdateTheta(object=paramsA,
				 nTry=5L,
				 epsilon=0.1,
				 dryrun=FALSE)
	paramsA <- rupdateLambda(object=paramsA,
				 nTry=5L,
				 epsilon=0.1,
				 dryrun=FALSE)
	paramsA <- rupdateT(object=paramsA,
				 nTry=5L,
				 epsilon=0.1,
				 dryrun=FALSE)
	paramsA <- rupdateL(object=paramsA,
				 nTry=5L,
				 epsilon=0.1,
				 dryrun=FALSE)
	paramsA <- rupdateLambdaPhi(object=paramsA,
				      nTry=5L,
				      epsilon=0.1,
				      dryrun=FALSE)
	paramsA <- rupdateThetaPhi(object=paramsA,
				      nTry=5L,
				      epsilon=0.1,
				      dryrun=FALSE)
	##
	## finished: updates that can be used by all model variants
	##
	##
	## updates only for model A
	##
	paramsA <- rupdateXi(object=paramsA, dryrun=FALSE, one.delta=TRUE)
	##
	## finished: updates that can be used only for model A
	##
	## updates only for model B
	paramsB <- rupdateXi(object=paramsB, dryrun=FALSE, one.delta=FALSE)

	params2 <- rupdateBDDelta(object=params2,
				  nTry=5L,
				  epsilon=0.1,
				  dryrun=FALSE)
	## stop

	params2 <- rupdateTau2RDDelta(object=params2,
				      nTry=5L,
				      epsilon=0.1,
				      dryrun=FALSE)

	## NaN's appear in nu after the update...?
	params2 <- rupdateDDelta(object=params2,
				 dryrun=FALSE)

	params2 <- rupdateC2(object=params2,
			     nTry=5L,
			     dryrun=FALSE)

	params2 <- rupdateC2DDelta(object=params2,
				   nTry=5L,
				   dryrun=FALSE)



	params2 <- rupdateGamma2Nu(object=params2,
				   nTry=5L,
				   epsilon=0.1,
				   dryrun=FALSE)

	params2 <- rupdateRDDelta(object=params2,
				 nTry=5L,
				 epsilon=0.1,
				 dryrun=FALSE)

	params2 <- rupdateRC2(object=params2,
				 nTry=5L,
				 epsilon=0.1,
				 dryrun=FALSE)





	params2 <- rupdateSigma2(object=params2,
				    nTry=5L,
				    epsilon=0.1,
				    dryrun=FALSE)










	if(!one.delta){
		params2 <- rupdateXi(object=params2,
				     dryrun=FALSE,
				     one.delta=FALSE)
		params2 <- rupdateDeltaDDelta(object=params2,
					      nTry=5L,
					      dryrun=FALSE,
					      one.delta=FALSE)
	}
	if(one.delta){
		## must make sure that the deltas
		## for a gene are the same

		params2 <- rupdateDeltaDDelta(object=params2,
					      nTry=5L,
					      dryrun=FALSE,
					      one.delta=TRUE)
	}
	params2 <- rupdateLSigma2(object=params2,
				  nTry=5L,
				  epsilon=0.1,
				  dryrun=FALSE)

	params2 <- rupdateTSigma2(object=params2,
				      nTry=5L,
				      epsilon=0.1,
				      dryrun=FALSE)





	if(FALSE){
		## add appropriate slots to Parameters object
		params2 <- rupdateDeltaDDelta_MRF(object=params2,
						  nTry=5L,
						  epsilon=0.1,
						  dryrun=FALSE)

		params2 <- rupdateAlpha_MRF(object=params2,
					    nTry=5L,
					    epsilon=0.1,
					    dryrun=FALSE)
		params2 <- rupdateBeta_MRF(object=params2,
					   nTry=5L,
					   epsilon=0.1,
					   dryrun=FALSE)
		params2 <- rupdateBetag_MRF(object=params2,
					    nTry=5L,
					    epsilon=0.1,
					    dryrun=FALSE)
	}
}

















	rupdate <- function(object,
			    type=c("ANu",
			           "BDDelta",
			           "Tau2Rho",
			           "Tau2DDelta"),
			    nTry=10L,
			    epsilon=0.1,
			    dryrun=FALSE){
		update.type <- paste("rupdate", type, sep="")
		.C(update.type, ...)

xde <- function(paramsMcmc, esetList, outputMcmc, batchSize=NULL, NCONC=2, center=TRUE, ...){
	if(is.null(batchSize)){
		fit <- xdeFit(paramsMcmc=paramsMcmc,
			      esetList=esetList,
			      outputMcmc=outputMcmc,
			      center=center, ...)
	} else{
		## Tabulate running average of posterior means
		## Remove log files after each batch
		print("Log files automatically removed after each batch")
		I <- iterations(paramsMcmc)/batchSize
		iterations(paramsMcmc) <- batchSize
		for(i in 1:I){
			cat("Batch ", i, "\n")
			if(i > 1){
				firstMcmc(paramsMcmc) <- lastMcmc(fit)
				fit <- xdeFit(paramsMcmc=paramsMcmc,
					      esetList=esetList,
					      center=center)
				pa.last <- calculatePosteriorAvg(fit, NCONC=NCONC)
				pa.cum <- (pa.last*batchSize + pa.cum*(i-1)*batchSize)/(i*batchSize)

				bes.last <- calculateBayesianEffectSize(fit)
				bes.cum <- (bes.last*batchSize + bes.cum*(i-1)*batchSize)/(i*batchSize)
			} else{
				fit <- xdeFit(paramsMcmc=paramsMcmc,
					      esetList=esetList,
					      center=center)
				pa.cum <- calculatePosteriorAvg(fit, NCONC=NCONC)
				bes.cum <- calculateBayesianEffectSize(fit)
			}
			unlink(directory(paramsMcmc), recursive=TRUE)
		}
		bayesianEffectSize(fit) <- bes.cum
		posteriorAvg(fit) <- pa.cum
	}
	return(fit)
}

xdeFit <- function(paramsMcmc, esetList, outputMcmc, center=TRUE,
		   dryrun=FALSE){
	if(!file.exists(directory(paramsMcmc))){
		dir.create(directory(paramsMcmc), recursive=TRUE)
	}
	if(class(esetList) != "ExpressionSetList") {
		esetList <- as(esetList, "ExpressionSetList")
	}
	##stop("argument esetList must have class ExpresssionSetList")
	if(class(paramsMcmc) != "XdeParameter") stop("paramsMcmc must be an object of class XdeParameter")
	##if outputMcmc is present, use the seed stored in outputMcmc for
	##beginning the MCMC (prevents simulating from the same seed as the
	##previous run).  Furthermore, start the chain using the value of
	##chain stored in outputMcmc (by default, this would be the last
	##iteration from the previous run).
	if(!missing(outputMcmc)){
		if(class(outputMcmc) == "XdeMcmc"){
			seed(paramsMcmc) <- outputMcmc@seed
			firstMcmc(paramsMcmc) <- lastMcmc(outputMcmc)
		} else {
			stop("Argument 'outputMcmc' must be an object of class XdeMcmc")
		}
	}
	if(center){
		studyMean <- function(x) abs(mean(as.numeric(exprs(x)))) > 0.1
		overall.means <- sapply(esetList, studyMean)
		if(any(overall.means)){
			print("Replacing expression matrices in esetList with mean-centered matrices...")
			esetList <- studyCenter(esetList)
		}
	}
	##Convert expression to vector
	f <- function(x)  x <- as.vector(t(exprs(x)))
	expression.vector <- as.numeric(unlist(lapply(esetList, f)))
	if(any(is.na(expression.vector))){
		stop("Missing values in the expression data")
	}
	##Convert phenoData to a vector
	convertToVector <- function(x, phenotypeLabel){
		x <- pData(x)
		if(dim(x)[2] > 1 & is.null(phenotypeLabel)){
			warning("More than one phenoData covariate -- using the first")
			x <- x[, 1]
		}
		if(dim(x)[2] > 1 & !is.null(phenotypeLabel)){
			var.i <- match(phenotypeLabel, colnames(x))
			x <- x[, var.i]
		}
		return(x)
	}
	psi <- as.numeric(unlist(lapply(esetList, convertToVector, phenotypeLabel=paramsMcmc@phenotypeLabel)))
	if(paramsMcmc@verbose) cat("Covariate to use in phenoData: ", phenotypeLabel(paramsMcmc), "\n")
	if(paramsMcmc@verbose) print(paste("writing chain files to", directory(paramsMcmc)))
	firstMcmc <- firstMcmc(paramsMcmc)
	ZZ <- .xdeparameterlist(paramsMcmc=paramsMcmc,
				esetList=esetList,
				firstMcmc=firstMcmc,
				expression.vector=expression.vector,
				psi=psi)
	if(dryrun) stop(return(ZZ))
	TRY <- tryCatch(results <- .C("xdeLIN_main",
				      seed = ZZ[["seed"]],
				      showIterations = ZZ[["showIterations"]],
				      nIt = ZZ[["nIt"]],
				      oneDelta=ZZ[["one.delta"]],  ##if zero, prior model A (multiple delta) is used
				      Q = ZZ[["Q"]],
				      G = ZZ[["G"]],
				      S = ZZ[["S"]],
				      x = ZZ[["x"]],
				      Psi = ZZ[["Psi"]],
				      specifiedInitialValues = ZZ[["specifiedInitialValues"]],
				      Nu = ZZ[["Nu"]],
				      DDelta = ZZ[["DDelta"]],
				      A = ZZ[["A"]],
				      B = ZZ[["B"]],
				      C2 = ZZ[["C2"]],
				      Gamma2 = ZZ[["Gamma2"]],
				      R = ZZ[["R"]],
				      Rho = ZZ[["Rho"]],
				      Delta = ZZ[["Delta"]],
				      Xi = ZZ[["Xi"]],
				      Sigma2 = ZZ[["Sigma2"]],
				      T = ZZ[["T"]],
				      L = ZZ[["L"]],
				      Phi = ZZ[["Phi"]],
				      Theta = ZZ[["Theta"]],
				      Lambda = ZZ[["Lambda"]],
				      Tau2R = ZZ[["Tau2R"]],
				      Tau2Rho=ZZ[["Tau2Rho"]],
				      param = ZZ[["param"]],
				      nUpdate = ZZ[["nUpdate"]],
				      epsilon = ZZ[["epsilon"]],
				      output = ZZ[["output"]],
				      writeToFile = ZZ[["writeToFile"]],
				      directory = ZZ[["directory"]],
				      valuePotential = ZZ[["valuePotential"]],
				      valueAcceptance = ZZ[["valueAcceptance"]],
				      valueNu = ZZ[["valueNu"]],
				      valueDDelta = ZZ[["valueDDelta"]],
				      valueA = ZZ[["valueA"]],
				      valueB = ZZ[["valueB"]],
				      valueC2 = ZZ[["valueC2"]],
				      valueGamma2 = ZZ[["valueGamma2"]],
				      valueR = ZZ[["valueR"]],
				      valueRho = ZZ[["valueRho"]],
				      valueDelta = ZZ[["valueDelta"]],
				      valueXi = ZZ[["valueXi"]],
				      valueSigma2 = ZZ[["valueSigma2"]],
				      valueT = ZZ[["valueT"]],
				      valueL = ZZ[["valueL"]],
				      valuePhi = ZZ[["valuePhi"]],
				      valueTheta = ZZ[["valueTheta"]],
				      valueLambda = ZZ[["valueLambda"]],
				      valueTau2R = ZZ[["valueTau2R"]],
				      valueTau2Rho=ZZ[["valueTau2Rho"]],
				      valueProbDelta = ZZ[["valueProbDelta"]],
				      valueDiffexpressed=ZZ[["valueDiffexpressed"]],
				      writeDiffexpressedTofile=ZZ[["writeDiffexpressedTofile"]]),
                  error=function(e) NULL)
	if(is.null(TRY)){
		stop("Problem in C wrapper to xdeLIN_main. Check arguments in .fit")
	}
	##The data can be stored more efficiently in environments?
	##If writeToFile or burnin is TRUE, we only collect the last
	##iteration of the chain
	index <- match(c("Nu",
			 "DDelta",
			 "A",
			 "B",
			 "C2",
			 "Gamma2",
			 "R",
			 "Rho",
			 "Delta",
			 "Xi",
			 "Sigma2",
			 "T",
			 "L",
			 "Phi",
			 "Theta",
			 "Lambda",
			 "Tau2R",
			 "Tau2Rho"), names(results))
	lastMcmc <- results[index]
	eenv <- new.env()
	eenv[["vars"]] <- lastMcmc
	xmcmc <- new("XdeMcmc",
		     studyNames=studyNames(paramsMcmc),
		     featureNames=featureNames(esetList),
		     iterations=savedIterations(paramsMcmc)[[1]],
		     directory=directory(paramsMcmc),
		     seed=results[[1]],
		     output=output(paramsMcmc),
		     lastMcmc=eenv,
		     posteriorAvg=NULL,
		     bayesianEffectSize=NULL)
##	if(!burnin(paramsMcmc)){
##		##paramsMcmc has directory where chains are stored, number of iterations, etc
##		##i <- match(c("c2", "sigma2", "tau2", "b"), names(output(paramsMcmc)))
##		##xmcmc@posteriorAvg <- xmcmc$diffExpressed
##		##if(nrow(xmcmc@posteriorAvg) == ZZ$G){
##		##	rownames(xmcmc@posteriorAvg) <- featureNames(esetList)
##		##}
##	}
	xmcmc
}


.xdeparameterlist <- function(paramsMcmc,
			      esetList,
			      firstMcmc,
                              expression.vector,
			      psi){
	ZZ <-list(seed = as.integer(seed(paramsMcmc)),#1
		  showIterations = as.integer(paramsMcmc@showIterations),
		  nIt = as.integer(iterations(paramsMcmc)),
		  one.delta=as.integer(paramsMcmc@one.delta),## if TRUE, "prior model B" (multiple delta) is used
		  Q = as.integer(length(esetList)),
		  G = as.integer(nrow(esetList)),
		  S = as.integer(nSamples(esetList)),
		  x = as.double(expression.vector),
		  Psi = as.integer(psi),
		  specifiedInitialValues = as.integer(paramsMcmc@specifiedInitialValues),
		  ##Nu: a vector of GP values.  Must be of the right length even if specifiedInitialValues is FALSE
		  Nu = as.double(firstMcmc$Nu),#11
		  DDelta = as.double(firstMcmc$DDelta),
		  A = as.double(firstMcmc$A),
		  B = as.double(firstMcmc$B),
		  C2 = as.double(firstMcmc$C2),
		  Gamma2 = as.double(firstMcmc$Gamma2),#16
		  R = as.double(firstMcmc$R),
		  Rho = as.double(firstMcmc$Rho),
		  Delta = as.integer(firstMcmc$Delta),
		  Xi = as.double(firstMcmc$Xi),#20
		  Sigma2 = as.double(firstMcmc$Sigma2), #21
		  T = as.double(firstMcmc$T),
		  L = as.double(firstMcmc$L),
		  Phi = as.double(firstMcmc$Phi),
		  Theta = as.double(firstMcmc$Theta), #25
		  Lambda = as.double(firstMcmc$Lambda),#26
##		  Tau2 = as.double(firstMcmc$Tau2),#27  ##decoupling of taus
		  Tau2R=as.double(firstMcmc$Tau2R),
		  Tau2Rho=as.double(firstMcmc$Tau2Rho),
		  param = as.double(hyperparameters(paramsMcmc)),#28
		  nUpdate = as.integer(paramsMcmc@updates),#29
		  epsilon = as.double(paramsMcmc@tuning),#30
		  output = as.integer(paramsMcmc@output),#31 (should have length 22)
		  ##do not write to file if running burnin
		  writeToFile = as.integer(!paramsMcmc@burnin), #32
		  directory = as.character(paramsMcmc@directory), #,#33
		  valuePotential = as.double(firstMcmc$Potential),#34
		  valueAcceptance = as.double(firstMcmc$Acceptance),#35
		  valueNu = as.double(firstMcmc$Nu),#36
		  valueDDelta = as.double(firstMcmc$DDelta),#37
		  valueA = as.double(firstMcmc$A),#38
		  valueB = as.double(firstMcmc$B),#39
		  valueC2 = as.double(firstMcmc$C2),#40
		  valueGamma2 = as.double(firstMcmc$Gamma2),#41
		  valueR = as.double(firstMcmc$R),#42
		  valueRho = as.double(firstMcmc$Rho),#43
		  valueDelta = as.integer(firstMcmc$Delta),#44
		  valueXi = as.double(firstMcmc$Xi),#45
		  valueSigma2 = as.double(firstMcmc$Sigma2),#46
		  valueT = as.double(firstMcmc$T),#47
		  valueL = as.double(firstMcmc$L),#48
		  valuePhi = as.double(firstMcmc$Phi),#49
		  valueTheta = as.double(firstMcmc$Theta),#50
		  valueLambda = as.double(firstMcmc$Lambda),#51
		  valueTau2R = as.double(firstMcmc$Tau2R),#52
		  valueTau2Rho = as.double(firstMcmc$Tau2Rho),#52
		  valueProbDelta = as.double(firstMcmc$ProbDelta),#53
		  ##posterior mean of differential expression,  concordant differential expression, and discordant differential expression
		  valueDiffexpressed = as.double(firstMcmc$Diffexpressed), ##54
		  writeDiffexpressedTofile = as.integer(FALSE)) ##55 --
	ZZ
}

library(XDE)
data(expressionSetList)

### Initializing slots common to all models
commonParams <- XDE:::Parameters(object=expressionSetList, clinicalCovariate="adenoVsquamous")
## need to specify: sumS
## not specified by HT: c2, gamma2, a, b, l, t, lambda, theta, ...
## initialize clique
##
commonObject <- XDE:::startingValues(commonParams, expressionSetList, "adenoVsquamous")





### Initializing MI

objectMI <- commonObject ##no specific updates for MI
#paramsMI <- XDE:::Parameters(object=expressionSetList,
#                           clinicalCovariate="adenoVsquamous")
#dms <- dims(paramsMI)
#objectMI <- XDE:::startingValues(paramsMI,
#                                expressionSetList,
#                                "adenoVsquamous")
#orig <- objectMI
#dms2 <- dims(objectMI)
#one.delta <- FALSE
#all.equal(dms, dms2)
##common updates (no specific updates for MI)
objectMI <- modelA_B_MIupdates(objectMI)



### Initializing MII

##paramsMII <- XDE:::ParametersMII(object=expressionSetList,
##                              clinicalCovariate="adenoVsquamous")
##dms <- dims(paramsMII)
##objectMII <- XDE:::startingValues(paramsMII,
##                                 expressionSetList,
##                                 "adenoVsquamous")
##orig <- objectMII
##dms2 <- dims(objectMII)
##one.delta <- FALSE
##all.equal(dms, dms2)

objectMII=as(commonObject, "ParametersMII")
objectMII@Omega=rep(1.0, 1500)
objectMII@zeta=rep(1.0, 1500)
objectMII@D=rep(1.0, 1500)
objectMII@nClique=rep(1L, 1500)
objectMII@oldClique=rep(1L, 1500)
objectMII@nOldComponents=rep(1L, 1500)
objectMII@nNewComponents=rep(1L, 1500)
objectMII@oldComponents=rep(1L, 1500)


setMethod("initialize", signature(.Object="ParametersMII"), function(.Object, ...){
  object=callNextMethod(.Object, ...)
  object@Omega -...
  object@zeta -...
  object@D -...
  object@nClique -...
  object@oldClique -...
  object@nOldComponents -...
  object@nNewComponents -...
  object@oldComponents -...
  return(object)
})

##paramsMII <- new("ParametersMII")
##tmp=XDE:::Parameters(expressionSetList, clinicalCovariate="adenoVsquamous")
##objMII=as(tmp, "ParametersMII")

#dms <- dims(commonParams)
#objectMII <- XDE:::startingValues(paramsMII,expressionSetList,"adenoVsquamous")
orig <- objectMII
#dms2 <- dims(objectMII)
one.delta <- FALSE
#all.equal(dms, dms2)

##common updates
objectMII <- modelA_B_MIupdates(objectMII)


##Model II-specific updates

objectMII <- rupdateSigma2_HyperInverseWishart(object=objectMII,
                                             nTry=5L,
                                             epsilon=0.1,
                                             dryrun=FALSE)

objectMII <- rupdateLSigma2_HyperInverseWishart(object=objectMII,
                                              nTry=5L,
                                              epsilon=0.1,
                                              dryrun=FALSE)

objectMII <- rupdateTSigma2_HyperInverseWishart(object=objectMII,
                                              nTry=5L,
                                              epsilon=0.1,
                                              dryrun=FALSE)

objectMII <- rupdateOmega_HyperInverseWishart(object=objectMII,
                                            dryrun=FALSE)

#objectMII <- rupdateDDeltaStar_HyperInverseWishart(object=objectMII,
#                                                dryrun=FALSE)

#objectMII <- rupdateTau2RDDeltaStar_HyperInverseWishart(object=objectMII,
#                                                      nTry=5L,
#                                                      epsilon=0.1,
#                                                     dryrun=FALSE)

#objectMII <- rupdateBDDeltaStar_HyperInverseWishart(object=objectMII,
#                                                  nTry=5L,
#                                                 epsilon=0.1,
#                                                  dryrun=FALSE)

#objectMII <- rupdateRDDeltaStar_HyperInverseWishart(object=objectMII,
#                                                  nTry=5L,
#                                                  epsilon=0.1,
#                                                  dryrun=FALSE)

setMethod("pairs", "matrix",
          function(x, ...){
            op <- par(no.readonly=TRUE)
            on.exit(par(op))
            ##require(RColorBrewer) || stop("Package RColorBrewer is not available")
            par(mfrow=c(1,1), las=1)
            panel <- function(...){
              par(new="TRUE")
              colramp <- colorRampPalette(c("white", brewer.pal(9, "Greys")))
              smoothScatter(..., colramp=colramp, nrpoints=0, xaxt="n", yaxt="n")
              x <- list(...)
              r <- round(cor(x[[1]], x[[2]], method="spearman"), 2)
              legend("topleft", legend=as.character(r), bty="n", cex=1.4)
            }
            pairs(x, panel=panel, upper.panel=NULL, ...)
          })

##N is a vector of sample sizes
setMethod(".pca", "matrix",
          function(object, N=NULL, ...){
		  if(length(N) != ncol(object)) stop("The sample size in each study must be specified")
		  ##1. obtain the effect sizes in the P studies
		  ##   - these are stored in 'object'
		  ##2. center the effect sizes by their means
		  meancen <- colMeans(object)
		  xcen <- sweep(object, 2, meancen)

		  ##3. Fit principal components to w1, w2, and w3 using
		  ##   covariance, saving a1, a2 and a3, the loadings of the first
		  ##   principal component.
		  fit <- princomp(xcen, cor = FALSE)
		  a <- fit$loadings[1:ncol(object), 1]

		  ##4. Estimate the combined effect: (see p.9 of Garrett-Mayer
		  ##   paper)
		  weight <- sum(a * sqrt(N))
		  combined.effect <- matrix(NA, ncol=ncol(object), nrow=nrow(object))
		  for(i in 1:ncol(object)){
			  combined.effect[,i] <- a[i] * sqrt(N[i]) * xcen[, i]
		  }
		  score <- apply(combined.effect, 1, sum)
		  score <- score/weight
		  return(score)
          })

setMethod("expressionVector", signature(object="matrix"),
	  function(object){
		  ##x: A vector of expression values.
		  ## The order of the values is
		  ## x_gsp
		  ## sample index changes the fastest, then gene, then study
		  ## x_{1,1,1},  ... , x_{1, S_1, 1}, x_{2,1,1} ... x_{G,S_1,1}
		  ##x <- lapply(object, function(object) as.numeric(exprs(object)))
		  x <- as.numeric(t(object))
		  return(x)
	  })

setMethod("vectorize", signature(object="matrix"), function(object){
	## gene index changes fastest, then study index
	as(object, class(object[,1]))
})

##setMethod("unvectorize", signature(object="matrix"), function(object){
##	## gene index changes fastest, then study index
##	as(object, class(object[,1]))
##})

setMethod(".studySplit", "ExpressionSet",
          function(object, 
                   phenotypeLabel,
                   nsplit=2,
                   balanced=TRUE,
                   classSize=100,
                   studyName="study",
                   SCALE.SD=1, ...){

		  if(missing(phenotypeLabel)) stop("must indicate phenotypeLabel as an element in varLabel")
		  phenotypeLabels <- pData(object)[, grep(phenotypeLabel, colnames(pData(object)))]
            group0 <- grep(0, phenotypeLabels)
            group1 <- grep(1, phenotypeLabels)
            if(balanced){
              smallestGroup <- min(length(group0), length(group1))
              splitSize <- floor(smallestGroup/nsplit)
              if(splitSize > classSize)    splitSize <- classSize
              splitSize0 <- splitSize1 <- splitSize
            } else{##do not require balanced study
              splitSize0 <- floor(length(group0)/nsplit)
              splitSize1 <- floor(length(group1)/nsplit)
              if(splitSize0 > classSize) splitSize0 <- classSize
              if(splitSize1 > classSize) splitSize1 <- classSize
            }
            "%w/o%" <- function(x,y) x[!x %in% y] #--  x without y
            eset <- list()
            for(i in 1:nsplit){
              samples0 <- sample(group0, size=splitSize0, replace=FALSE)
              group0 <- group0 %w/o% samples0
              samples1 <- sample(group1, size=splitSize1, replace=FALSE)
              group1 <- group1 %w/o% samples1
              tmp <- object[, c(samples0, samples1)]
              ##Add independent noise
              s <- rowSds(exprs(tmp))
              e <- matrix(rnorm(length(s), 0, SCALE.SD*s), nrow(tmp), ncol(tmp), byrow=FALSE)
              exprs(tmp) <- exprs(tmp) + e
              ##    eset[[i]] <- dat[, c(samples0, samplnes1)]
              eset[[i]] <- tmp
            }
            if(!identical(featureNames(eset[[1]]), featureNames(eset[[2]])))
              stop("feature names not identical in the study split")
            gs <- matrix(1, nrow=nrow(eset[[1]]), ncol=nsplit)
            rownames(gs) <- featureNames(eset[[1]])
            xset <- new("ExpressionSetList",
                        list(split1=eset[[1]],
                             split2=eset[[2]],
                             split3=eset[[3]]))
            xset
          })

simulateCliques <- function(G){
	u <- runif(G)
	clique <- rep(0L,G)
	for(g in 2:G){
		if(u[g] < 0.95){
			clique[g] <- clique[g-1]
		} else clique[g] <- clique[g-1]+1
	}
	as.integer(clique)
}

cliqueParams <- function(clique){
	##
	## nClique: integer (number of cliques)
	##
	## oldClique: vector of integers with length nClique
	##            - first element of oldClique is arbitrary
	##            - element i specifies for which clique j < i  P_i intersect P_j is not the empty set
	##            - C++ assumes the cliques to be numbered from zero to nClique-1
	##
	## nOldClique: vector of integers with length nClique
	##            - element i specifies the number of elements in separator i
	##            - the first element should always be zero
	##
	## nNewClique: vector of integers with length nClique
	##            - element i specifies number of elements of P_i\S_i
	##
	## oldComponents: vector of integers with length equal to the
	##                sum of all elements in the vector nOldClique
	##              - the first |S_1| elements specify the elements in S_1
	##              - the next |S_2| elements specify the elements in S_2
	##              - ...
	##              - assumes a local numbering of genes inside each clique from zero to |P_i|
	##
	## Toy example:
	##G <- 10
	## P_0={0,1,2,3}, P_1 = {2,4,5,6}, P_2={4,5,7,8}, P_3={4,6,9}
	## S_0={}, S_1=P_1 intersect P_0 = {2}, S_2 = P_2 intersect P_1 = {4,5}, S_3=P_3 intersect P_1={4,6}
	## then
##	 nClique=4
##	 oldClique=c(-1,0,1,1)
##	 nOldClique=c(0,1,2,2)
##	 nNewInClique=c(4,3,2,1)
##	 oldComponents=c(2,1,2,1,3)
	nNewInClique <- tabulate(clique+1)
	oldComponents <- vector("list", length(nNewInClique))
	oldClique <- nNewInClique
	oldClique[1] <- -1
	nTotalInClique <- nNewInClique
	u1 <- runif(length(nNewInClique)-1)
	u2 <- runif(length(nNewInClique)-1)
	u <- u1*u2
	for (c in 2:length(nNewInClique)){
		oldClique[c] <- round(u1[c-1]*(c-2))
		nOld <- round(u[c-1]*(nTotalInClique[oldClique[c]+1]))
		nTotalInClique[c] <- nTotalInClique[c] + nOld
		##oldComponents[[c]] <- if(nOld > 0) rep(0, nOld) else 0
		nSampled <- 0
		while(nSampled < nOld) {
			oldComponents[[c]][nSampled+1] <- round((runif(1)*(nTotalInClique[oldClique[c]+1]-1))+1)
			existAlready <- 0
			if (nSampled>0){
				for (i in 1:(nSampled)){
					if (oldComponents[[c]][i]==oldComponents[[c]][nSampled+1]){
						existAlready <- 1
					}
				}
			}
			if (existAlready==0) nSampled <- nSampled+1
		}
	}
	nClique <- max(clique) + 1
	nOldClique <- rep(0,nClique)
	for (i in 2:(nClique)){
		nOldClique[i] = length(oldComponents[[i]])
	}
	list(oldClique=as.integer(oldClique),
	     oldComponents=oldComponents,
	     nClique=as.integer(nClique),
	     nOldClique=as.integer(nOldClique),
	     nTotalInClique=as.integer(nTotalInClique),
	     nNewInClique=as.integer(nNewInClique))
}

simulateOmega <- function(clique, clique.params, G){
	nClique <- clique.params[["nClique"]]
	oldComponents <- clique.params[["oldComponents"]]
	oldClique <- clique.params[["oldClique"]]
	OmegaM = diag(rep(0,G))
	Si = NULL
	Omega = NULL
	CliquesF <- vector("list", nClique)
	for (i in 1:(nClique)){
		Ci = which(clique==i-1)
		cli = oldClique[i]
		if (cli>=0){
			list1 = oldComponents[[i]]
			CiS = CliquesF[[cli+1]]
			Si = CiS[list1]
			CliquesF[[i]] = sort(c(Ci,Si))
		} else {
			CliquesF[[i]] = Ci
		}
		setC = c(Ci,Si)
		OmegaM[setC,setC] = 2
		Om = OmegaM[setC,setC]
		Omega = c(Omega,c(Om[lower.tri(Om,diag=TRUE)]))
	}
	Omega[is.na(Omega)] <- 2
	Omega
}


initializeParams <- function(G=3592L, nIt=1L, Q=3L,
			     S=c(100L, 50L, 75L),
			     clique,
			     clique.params,
			     psi,
			     seed=123L,
			     a=rep(0.5, Q),
			     b=rep(0.5, Q),
			     l=rep(1.0, Q),
			     t=rep(0.5*0.5, Q),
			     xi=rep(0.5, Q),
			     lambda=rep(0.9, Q),
			     theta=rep(0.1^2, Q),
			     x=as.numeric(0),
			     gamma2=0.5^2,
			     tau2Rho=rep(1.0,Q),
			     writeout=rep(1L, 20),
			     ...){
	simulateExpression <- if(length(x)<2) TRUE else FALSE
	x <- numeric(G*sum(S))
	if(missing(clique))
		clique <- simulateCliques(G)
	if(missing(clique.params))
		clique.params <- cliqueParams(clique)
	Omega <- simulateOmega(clique,clique.params, G)
	if(missing(psi)){
		message("simulating clinical variable")
		psi <- as.integer(runif(sum(S)) > 0.5)
	}
	tmp <- .C("initializeParams",
		  nIt=nIt,
		  seedR=as.integer(seed),
		  G=as.integer(G),
		  Q=as.integer(Q),
		  S=as.integer(S),
		  psi=as.integer(psi),
		  alphaA=1.0,
		  betaA=1.0,
		  pA0=0.1,
		  pA1=0.1,
		  alphaB=1.0,
		  betaB=1.0,
		  pB0=0.1,
		  pB1=0.1,
		  nuR=1.0,
		  nuRho=1.0,
		  alphaXi=1.0,
		  betaXi=1.0,
		  c2Max=10.0,
		  sigma2=rep(0.0, G*Q), ## G * Q
		  tau2Rho=as.numeric(tau2Rho),
		  gamma2=as.numeric(gamma2),
		  tau2R=as.numeric(tau2Rho),
		  aIn=as.numeric(a),
		  bIn=as.numeric(b),
		  lIn=as.numeric(l),
		  tIn=as.numeric(t),
		  lambdaIn=as.numeric(lambda),
		  thetaIn=as.numeric(theta),
		  xiIn=as.numeric(xi),
		  simulateExpression=as.integer(simulateExpression),
		  x=as.numeric(x),
		  writeout=as.integer(writeout),
		  simulateSigma2=1L,
		  oldCliqueInput=clique.params[["oldClique"]],
		  oldComponentsInput=as.integer(unlist(clique.params[["oldComponents"]])),
		  nClique=as.integer(clique.params[["nClique"]]),
		  nOldClique=as.integer(clique.params[["nOldClique"]]),
		  nTotalInClique=as.integer(clique.params[["nTotalInClique"]]),
		  clique=as.integer(clique),
		  nNewInCliqueInput=as.integer(clique.params[["nNewInClique"]]))
}

##setGeneric("avgConcordant",   function(object, ...) standardGeneric("avgConcordant"))
##setGeneric("avgDiff",   function(object, ...) standardGeneric("avgDiff"))
##setGeneric("avgDiscordant",   function(object, ...) standardGeneric("avgDiscordant"))
setGeneric("bayesianEffectSize",   function(object) standardGeneric("bayesianEffectSize"))
setGeneric("bayesianEffectSize<-",   function(object, value) standardGeneric("bayesianEffectSize<-"))
setGeneric("burnin",   function(object) standardGeneric("burnin"))
setGeneric("burnin<-",   function(object, value) standardGeneric("burnin<-"))
setGeneric("calculateBayesianEffectSize",   function(object) standardGeneric("calculateBayesianEffectSize"))
##setGeneric("calculatePosteriorAvg", function(object, ...) standardGeneric("calculatePosteriorAvg"))
setGeneric("diffExpressed", function(object) standardGeneric("diffExpressed"))
setGeneric("directory", function(object) standardGeneric("directory"))
setGeneric("directory<-", function(object, value) standardGeneric("directory<-"))
setGeneric("firstMcmc", function(object) standardGeneric("firstMcmc"))
setGeneric("firstMcmc<-", function(object, value) standardGeneric("firstMcmc<-"))
setGeneric("geneCenter", function(object) standardGeneric("geneCenter"))
setGeneric("goodnessOfFit", function(object, fit, ...) standardGeneric("goodnessOfFit"))
setGeneric("hyperparameters", function(object) standardGeneric("hyperparameters"))
setGeneric("hyperparameters<-", function(object, value) standardGeneric("hyperparameters<-"))
## setGeneric("integrativeCorrelationFilter", function(object, ...) standardGeneric("integrativeCorrelationFilter"))
setGeneric("iterations", function(object) standardGeneric("iterations"))
setGeneric("iterations<-", function(object, value) standardGeneric("iterations<-"))
setGeneric("lastMcmc", function(object) standardGeneric("lastMcmc"))
setGeneric("lastMcmc<-", function(object, value) standardGeneric("lastMcmc<-"))
setGeneric("notes", function(object) standardGeneric("notes"))
setGeneric("nSamples", function(x) standardGeneric("nSamples"))
setGeneric("output",   function(object) standardGeneric("output"))
setGeneric("output<-",   function(object, value) standardGeneric("output<-"))
setGeneric(".pca", function(object, ...) standardGeneric(".pca"))
setGeneric("phenotypeLabel", function(object) standardGeneric("phenotypeLabel"))
setGeneric("phenotypeLabel<-", function(object, value) standardGeneric("phenotypeLabel<-"))
setGeneric("posteriorAvg", function(object) standardGeneric("posteriorAvg"))
setGeneric("posteriorAvg<-", function(object, value) standardGeneric("posteriorAvg<-"))
setGeneric("qqplot", function(x, y, plot.it = TRUE, xlab = deparse(substitute(x)),
                              ylab = deparse(substitute(y)),...) standardGeneric("qqplot"))
setGeneric("seed", function(object) standardGeneric("seed"))
setGeneric("seed<-", function(object, value) standardGeneric("seed<-"))
setGeneric("savedIterations", function(object) standardGeneric("savedIterations"))
setGeneric("showIterations", function(object) standardGeneric("showIterations"))
setGeneric("showIterations<-", function(object, value) standardGeneric("showIterations<-"))
setGeneric(".standardizedDelta", function(object, ...) standardGeneric(".standardizedDelta"))
setGeneric("standardizeSamples", function(object, ...) standardGeneric("standardizeSamples"))
setGeneric("studyCenter", function(object) standardGeneric("studyCenter"))
setGeneric("studyNames", function(object) standardGeneric("studyNames"))
setGeneric("studyNames<-", function(object, value) standardGeneric("studyNames<-"))
setGeneric(".studySplit", function(object, ...) standardGeneric(".studySplit"))
setGeneric("thin", function(x,...) standardGeneric("thin"))
setGeneric("thin<-", function(x, value) standardGeneric("thin<-"))
setGeneric("tuning", function(object) standardGeneric("tuning"))
setGeneric("tuning<-", function(object, value) standardGeneric("tuning<-"))
setGeneric("updates", function(object) standardGeneric("updates"))
setGeneric("updates<-", function(object, value) standardGeneric("updates<-"))
setGeneric("zeroNu", function(object, ...) standardGeneric("zeroNu"))


##setGeneric("getHyperparameters", function(object, G, Q, S, ...) standardGeneric("getHyperparameters"))
setGeneric("Params", function(object, one.delta=FALSE, MRF=FALSE) standardGeneric("Params"))
setGeneric("phenotype", function(object, varLabel) standardGeneric("phenotype"))
setGeneric("expressionVector", function(object) standardGeneric("expressionVector"))
setGeneric("vectorize", function(object) standardGeneric("vectorize"))

updateMissing <- function(orig, current){
	## the parameter list after an Rupdate type
	## must have all the parameters required for
	## a different update type.
	nms <- setdiff(names(orig), names(current))
	for(i in seq_along(nms)){
		eval(substitute(current$NAME_ARG, list(NAME_ARG=nms[i])))
	}
	return(current)
}

rupdateANu <- function(object,
		       nTry=10L,
		       nAccept=0L,
		       epsilon=0.2,
		       dryrun=FALSE){
	res <- .C("updateANu",
		   seed=object[["seed"]],
		   nTry=as.integer(nTry),
		   nAccept=as.integer(nAccept),
		   epsilon=as.numeric(epsilon),
		   a=object[["a"]],
		   nu=object[["nu"]],
		   Q=object[["Q"]],
		   G=object[["G"]],
		   S=object[["S"]],
		   x=exprs(object),
		   psi=object[["phenodata"]],
		   delta=object[["delta"]],
		   Delta=object[["Delta"]],
		   gamma2=object[["gamma2"]],
		   rho=object[["rho"]],
		   sigma2=object[["sigma2"]],
		   phi=object[["phi"]],
		   tau2Rho=object[["tau2Rho"]],
		   pA0=object[["pA0"]],
		   pA1=object[["pA1"]],
		   alphaA=object[["alphaA"]],
		   betaA=object[["betaA"]])
	## update a and nu
	slot(object, "seed") <- res[["seed"]]
	slot(object, "a") <- res[["a"]]
	slot(object, "nu") <- res[["nu"]]
	return(object)
}

rupdateBDDelta <- function(object,
			   nTry=10L,
			   nAccept=0L,
			   epsilon=0.2,
			   dryrun=FALSE){
  phenodata <- NULL
	if(dryrun){
		obj <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    tau2Rho=object[["tau2Rho"]],
			    b=object[["b"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    c2=object[["c2"]],
			    r=object[["r"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2R=object[["tau2R"]],
			    pB0=object[["pB0"]],
			    pB1=object[["pB1"]],
			    alphaB=object[["alphaB"]],
			    betaB=object[["betaB"]])
		return(obj)
	}

	res <- .C("updateBDDelta_MI",
		  seed=object[["seed"]],
		  nTry=as.integer(nTry),
		  nAccept=as.integer(nAccept),
		  epsilon=as.numeric(epsilon),
		  b=object[["b"]],
		  Delta=object[["Delta"]],
		  Q=object[["Q"]],
		  G=object[["G"]],
		  S=object[["S"]],
		  x=exprs(object),
		  psi=object[["phenodata"]],
		  nu=object[["nu"]],
		  delta=object[["delta"]],
		  c2=object[["c2"]],
		  r=object[["r"]],
		  sigma2=object[["sigma2"]],
		  phi=object[["phi"]],
		  tau2R=object[["tau2R"]],
		  pB0=object[["pB0"]],
		  pB1=object[["pB1"]],
		  alphaB=object[["alphaB"]],
		  betaB=object[["betaB"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "b") <- res[["b"]]
	slot(object, "Delta") <- res[["Delta"]]
	return(object) ##nipun: changed updateBDDelta to updateBDDelta_MI
}

rupdateTau2RhoNu <- function(object,
			     nTry=10L,
			     nAccept=0L,
			     epsilon=0.2,
			     dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    tau2Rho=object[["tau2Rho"]],
			    nu=object[["nu"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    gamma2=object[["gamma2"]],
			    rho=object[["rho"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    a=object[["a"]])
		return(res)
	}
	res <- .C("updateTau2RhoNu",
		  seed=object[["seed"]],
		  nTry=nTry,
		  nAccept=nAccept,
		  epsilon=epsilon,
		  tau2Rho=object[["tau2Rho"]],
		  nu=object[["nu"]],
		  Q=object[["Q"]],
		  G=object[["G"]],
		  S=object[["S"]],
		  x=exprs(object),
		  psi=object[["phenodata"]],
		  delta=object[["delta"]],
		  Delta=object[["Delta"]],
		  gamma2=object[["gamma2"]],
		  rho=object[["rho"]],
		  sigma2=object[["sigma2"]],
		  phi=object[["phi"]],
		  a=object[["a"]])
	## update tau2Rho and nu
	slot(object, "seed") <- res[["seed"]]
	slot(object, "tau2Rho") <- res[["tau2Rho"]]
	slot(object, "nu") <- res[["nu"]]
	return(object)
}


rupdateTau2RDDelta <- function(object,
			       nTry=10L,
			       nAccept=0L,
			       epsilon=0.2,
			       dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    tau2R=object[["tau2R"]],
			    Delta=object[["Delta"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    c2=object[["c2"]],
			    r=object[["r"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    b=object[["b"]])
		return(res)
	}
	res <- .C("updateTau2RDDelta_MI",
		  seed=object[["seed"]],
		  nTry=nTry,
		  nAccept=nAccept,
		  epsilon=epsilon,
		  tau2R=object[["tau2R"]],
		  Delta=object[["Delta"]],
		  Q=object[["Q"]],
		  G=object[["G"]],
		  S=object[["S"]],
		  x=exprs(object),
		  psi=object[["phenodata"]],
		  nu=object[["nu"]],
		  delta=object[["delta"]],
		  c2=object[["c2"]],
		  r=object[["r"]],
		  sigma2=object[["sigma2"]],
		  phi=object[["phi"]],
		  b=object[["b"]])
	## update tau2R and Delta
	slot(object, "seed") <- res[["seed"]]
	slot(object, "tau2R") <- res[["tau2R"]]
	slot(object, "Delta") <- res[["Delta"]]
	return(object)
}

rupdateNu <- function(object,
		      nAccept=0L,
		      dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nAccept=nAccept,
			    nu=object[["nu"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    gamma2=object[["gamma2"]],
			    rho=object[["rho"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]])
		return(res)
	}
	res <- .C("updateNu",
		  seed=object[["seed"]],
		  nAccept=nAccept,
		  nu=object[["nu"]],
		  Q=object[["Q"]],
		  G=object[["G"]],
		  S=object[["S"]],
		  x=exprs(object),
		  psi=object[["phenodata"]],
		  delta=object[["delta"]],
		  Delta=object[["Delta"]],
		  gamma2=object[["gamma2"]],
		  rho=object[["rho"]],
		  sigma2=object[["sigma2"]],
		  phi=object[["phi"]],
		  tau2Rho=object[["tau2Rho"]],
		  a=object[["a"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "nu") <- res[["nu"]]
	return(object)
}

rupdateDDelta <- function(object,
			  nAccept=0L,
			  dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nAccept=nAccept,
			    Delta=object[["Delta"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    c2=object[["c2"]],
			    r=object[["r"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2R=object[["tau2R"]],
			    b=object[["b"]])
		return(res)
	}
	res <- .C("updateDDelta_MI",
		  seed=object[["seed"]],
		  nAccept=nAccept,
		  Delta=object[["Delta"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    c2=object[["c2"]],
			    r=object[["r"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2R=object[["tau2R"]],
			    b=object[["b"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "Delta") <- res[["Delta"]]
	return(object) ##nipun: changed updateDDelta to updateDDelta_MI
}

rupdateC2 <- function(object,
		      nTry=10L,
		      nAccept=0L,
		      dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    c2=object[["c2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    r=object[["r"]],
			    sigma2=object[["sigma2"]],
			    tau2R=object[["tau2R"]],
			    b=object[["b"]],
			    c2Max=object[["c2Max"]])
		return(res)
	}
	res <- .C("updateC2_MI",
		  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    c2=object[["c2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    r=object[["r"]],
			    sigma2=object[["sigma2"]],
			    tau2R=object[["tau2R"]],
			    b=object[["b"]],
			    c2Max=object[["c2Max"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "c2") <- res[["c2"]]
	return(object) ##nipun: changed updateC2 to updateC2_MI
}

rupdateC2DDelta <- function(object,
			    nTry=10L,
			    nAccept=0L,
			    epsilon=0.2,
			    dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    c2=object[["c2"]],
			    Delta=object[["Delta"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    r=object[["r"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2R=object[["tau2R"]],
			    b=object[["b"]],
			    c2Max=object[["c2Max"]])
		return(res)
	}
	res <- .C("updateC2DDelta_MI",
		  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    c2=object[["c2"]],
			    Delta=object[["Delta"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    r=object[["r"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2R=object[["tau2R"]],
			    b=object[["b"]],
			    c2Max=object[["c2Max"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "c2") <- res[["c2"]]
	slot(object, "Delta") <- res[["Delta"]]
	return(object) ##nipun: changed updateC2DDelta to updateC2DDelta_MI
}


rupdateGamma2 <- function(object,
			  nAccept=0L,
			  dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nAccept=nAccept,
			    gamma2=object[["gamma2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    nu=object[["nu"]],
			    rho=object[["rho"]],
			    sigma2=object[["sigma2"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]])
		return(res)
	}
	res <- .C("updateGamma2",
		  seed=object[["seed"]],
			    nAccept=nAccept,
			    gamma2=object[["gamma2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    nu=object[["nu"]],
			    rho=object[["rho"]],
			    sigma2=object[["sigma2"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "gamma2") <- res[["gamma2"]]
	return(object)
}

rupdateGamma2Nu <- function(object,
			    nTry=10L,
			    nAccept=0L,
			    epsilon=0.2,
			    dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    gamma2=object[["gamma2"]],
			    nu=object[["nu"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    rho=object[["rho"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]])
		return(res)
	}
		res <- .C("updateGamma2Nu_MI",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    gamma2=object[["gamma2"]],
			    nu=object[["nu"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    rho=object[["rho"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "gamma2") <- res[["gamma2"]]
	slot(object, "nu") <- res[["nu"]]
	return(object) ##nipun: changed updateGamma2Nu to updateGamma2Nu_MI
}

rupdateRDDelta <- function(object,
			   nTry=10L,
			   nAccept=0L,
			   epsilon=0.2,
			   dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    r=object[["r"]],
			    Delta=object[["Delta"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    c2=object[["c2"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2R=object[["tau2R"]],
			    b=object[["b"]],
			    nuR=object[["nuR"]])
		return(res)
	}
		res <- .C("updateRDDelta_MI",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    r=object[["r"]],
			    Delta=object[["Delta"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    c2=object[["c2"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2R=object[["tau2R"]],
			    b=object[["b"]],
			    nuR=object[["nuR"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "r") <- res[["r"]]
	slot(object, "Delta") <- res[["Delta"]]
	return(object)
}

rupdateRC2 <- function(object,
		       nTry=10L,
		       nAccept=0L,
		       epsilon=0.2,
		       dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    r=object[["r"]],
			    c2=object[["c2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    sigma2=object[["sigma2"]],
			    tau2R=object[["tau2R"]],
			    b=object[["b"]],
			    nuR=object[["nuR"]],
			    c2Max=object[["c2Max"]])
		return(res)
	}
		res <- .C("updateRC2_MI",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    r=object[["r"]],
			    c2=object[["c2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    sigma2=object[["sigma2"]],
			    tau2R=object[["tau2R"]],
			    b=object[["b"]],
			    nuR=object[["nuR"]],
			    c2Max=object[["c2Max"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "r") <- res[["r"]]
	slot(object, "c2") <- res[["c2"]]
	return(object)
}

rupdateRhoNu <- function(object,
			 nTry=10L,
			 nAccept=0L,
			 epsilon=0.2,
			 dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    rho=object[["rho"]],
			    nu=object[["nu"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    gamma2=object[["gamma2"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]],
			    nuRho=object[["nuRho"]])
		return(res)
	}
		res <- .C("updateRhoNu",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    rho=object[["rho"]],
			    nu=object[["nu"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    gamma2=object[["gamma2"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]],
			    nuRho=object[["nuRho"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "rho") <- res[["rho"]]
	slot(object, "nu") <- res[["nu"]]
	return(object)
}


rupdateRhoGamma2 <- function(object,
			 nTry=10L,
			 nAccept=0L,
			 epsilon=0.2,
			 dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    rho=object[["rho"]],
			    gamma2=object[["gamma2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    nu=object[["nu"]],
			    sigma2=object[["sigma2"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]],
			    nuRho=object[["nuRho"]])
		return(res)
	}
		res <- .C("updateRhoGamma2",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    rho=object[["rho"]],
			    gamma2=object[["gamma2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    nu=object[["nu"]],
			    sigma2=object[["sigma2"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]],
			    nuRho=object[["nuRho"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "rho") <- res[["rho"]]
	slot(object, "gamma2") <- res[["gamma2"]]
	return(object)
}

rupdateSigma2 <- function(object,
			  nTry=10L,
			  nAccept=0L,
			  epsilon=0.2,
			  dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    sigma2=object[["sigma2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    c2=object[["c2"]],
			    gamma2=object[["gamma2"]],
			    r=object[["r"]],
			    rho=object[["rho"]],
			    phi=object[["phi"]],
			    t=object[["t"]],
			    l=object[["l"]],
			    tau2R=object[["tau2R"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]],
			    b=object[["b"]])
		return(res)
	}
		res <- .C("updateSigma2_MI",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    sigma2=object[["sigma2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    c2=object[["c2"]],
			    gamma2=object[["gamma2"]],
			    r=object[["r"]],
			    rho=object[["rho"]],
			    phi=object[["phi"]],
			    t=object[["t"]],
			    l=object[["l"]],
			    tau2R=object[["tau2R"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]],
			    b=object[["b"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "sigma2") <- res[["sigma2"]]
	return(object)
}

rupdatePhi <- function(object,
			  nTry=10L,
			  nAccept=0L,
			  epsilon=0.2,
			  dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    phi=object[["phi"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    sigma2=object[["sigma2"]],
			    theta=object[["theta"]],
			    lambda=object[["lambda"]])
		return(res)
	}
		res <- .C("updatePhi",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    phi=object[["phi"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    sigma2=object[["sigma2"]],
			    theta=object[["theta"]],
			    lambda=object[["lambda"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "phi") <- res[["phi"]]
	return(object)
}

rupdateTheta <- function(object,
			 nTry=10L,
			 nAccept=0L,
			 epsilon=0.2,
			 dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    theta=object[["theta"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    phi=object[["phi"]],
			    lambda=object[["lambda"]])
		return(res)
	}
		res <- .C("updateTheta",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    theta=object[["theta"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    phi=object[["phi"]],
			    lambda=object[["lambda"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "theta") <- res[["theta"]]
	return(object)
}

rupdateLambda <- function(object,
			  nTry=10L,
			  nAccept=0L,
			  epsilon=0.2,
			  dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    lambda=object[["lambda"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    phi=object[["phi"]],
			    theta=object[["theta"]])
		return(res)
	}
		res <- .C("updateLambda",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    lambda=object[["lambda"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    phi=object[["phi"]],
			    theta=object[["theta"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "lambda") <- res[["lambda"]]
	return(object)
}

rupdateT <- function(object,
		     nTry=10L,
		     nAccept=0L,
		     epsilon=0.2,
		     dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    t=object[["t"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    sigma2=object[["sigma2"]],
			    l=object[["l"]])
		return(res)
	}
		res <- .C("updateT",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    t=object[["t"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    sigma2=object[["sigma2"]],
			    l=object[["l"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "t") <- res[["t"]]
	return(object)
}

rupdateL <- function(object,
		     nTry=10L,
		     nAccept=0L,
		     epsilon=0.2,
		     dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    l=object[["l"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    sigma2=object[["sigma2"]],
			    t=object[["t"]])
		return(res)
	}
		res <- .C("updateL",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  epsilon=epsilon,
			  l=object[["l"]],
			  Q=object[["Q"]],
			  G=object[["G"]],
			  sigma2=object[["sigma2"]],
			  t=object[["t"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "l") <- res[["l"]]
	return(object)
}

rupdateXi <- function(object,
		      nAccept=0L,
		      dryrun=FALSE,
		      one.delta=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nAccept=nAccept,
			    xi=object[["xi"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    delta=object[["delta"]],
			    t=object[["t"]],
			    alphaXi=object[["alphaXi"]],
			    betaXi=object[["betaXi"]])
		return(res)
	}
	if(one.delta){
		res <- .C("updateXi_MB",
			  seed=object[["seed"]],
			    nAccept=nAccept,
			    xi=object[["xi"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    delta=object[["delta"]],
			    t=object[["t"]],
			    alphaXi=object[["alphaXi"]],
			    betaXi=object[["betaXi"]])		##nipun: changed updateXi_onedelta to updateXi_MB

	} else {
		res <- .C("updateXi_MA",
			  seed=object[["seed"]],
			    nAccept=nAccept,
			    xi=object[["xi"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    delta=object[["delta"]],
			    t=object[["t"]],
			    alphaXi=object[["alphaXi"]],
			    betaXi=object[["betaXi"]])  ##nipun: changed updateXi to updateXi_MA
	}
	slot(object, "seed") <- res[["seed"]]
	## why do we need to do this?
	slot(object, "delta") <- res[["delta"]]
	return(object)
}

rupdateDeltaDDelta <- function(object,
			       nTry=10L,
			       nAccept=0L,
			       dryrun=FALSE,
			       one.delta=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    c2=object[["c2"]],
			    r=object[["r"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2R=object[["tau2R"]],
			    xi=object[["xi"]],
			    b=object[["b"]])
		return(res)
	}
	if(one.delta){
		res <- .C("updateDeltaDDelta_MBI",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    c2=object[["c2"]],
			    r=object[["r"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2R=object[["tau2R"]],
			    xi=object[["xi"]],
			    b=object[["b"]]) ##nipun: changed updateDeltaDDelta_onedelta to updateDeltaDDelta_MBI
	} else {
		res <- .C("updateDeltaDDelta_MAI",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    c2=object[["c2"]],
			    r=object[["r"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2R=object[["tau2R"]],
			    xi=object[["xi"]],
			    b=object[["b"]]) ##nipun: changed updateDeltaDDelta to updateDeltaDDelta_MAI
	}
	slot(object, "seed") <- res[["seed"]]
	slot(object, "delta") <- res[["delta"]]
	slot(object, "Delta") <- res[["Delta"]]
	return(object)
}


##nipun: added rupdateDeltaDDelta_MRF2
rupdateDeltaDDelta_MRF2 <- function(object,
                               nTry=10L,
                               nAccept=0L,
                               dryrun=FALSE,
                               one.delta){
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                delta=object[["delta"]],
                Delta=object[["Delta"]],
                Q=object[["Q"]],
                G=object[["G"]],
                S=object[["S"]],
                x=exprs(object),
                psi=object[["phenodata"]],
                nu=object[["nu"]],
                c2=object[["c2"]],
                r=object[["r"]],
                sigma2=object[["sigma2"]],
                phi=object[["phi"]],
                tau2R=object[["tau2R"]],
                xi=object[["xi"]],
                b=object[["b"]])
    return(res)
  }
  if(one.delta){
    res <- .C("updateDeltaDDelta_MDI",
              seed=object[["seed"]],
              nTry=nTry,
              nAccept=nAccept,
              delta=object[["delta"]],
              Delta=object[["Delta"]],
              Q=object[["Q"]],
              G=object[["G"]],
              S=object[["S"]],
              x=exprs(object),
              psi=object[["phenodata"]],
              nu=object[["nu"]],
              c2=object[["c2"]],
              r=object[["r"]],
              sigma2=object[["sigma2"]],
              phi=object[["phi"]],
              tau2R=object[["tau2R"]],
              b=object[["b"]],
              nNeighbour=object[["nNeighbour"]],
              neighbour=object[["neighbour"]],
              alpha = object[["alpha"]],
              beta=object[["beta"]])   ##nipun: changed updateDeltaDDelta_MRF2_onedelta to updateDeltaDDelta_MDI
  } else {
    res <- .C("updateDeltaDDelta_MCI",
              seed=object[["seed"]],
              nTry=nTry,
              nAccept=nAccept,
              delta=object[["delta"]],
              Delta=object[["Delta"]],
              Q=object[["Q"]],
              G=object[["G"]],
              S=object[["S"]],
              x=exprs(object),
              psi=object[["phenodata"]],
              nu=object[["nu"]],
              c2=object[["c2"]],
              r=object[["r"]],
              sigma2=object[["sigma2"]],
              phi=object[["phi"]],
              tau2R=object[["tau2R"]],
              b=object[["b"]],
              nNeighbour=object[["nNeighbour"]],
              neighbour=object[["neighbour"]],
              alpha = object[["alpha"]], ##working
              beta=object[["beta"]],
              betag=object[["betag"]]) ##nipun: changed updateDeltaDDelta_MRF2 to updateDeltaDDelta_MCI
  }
  slot(object, "seed") <- res[["seed"]]
  slot(object, "delta") <- res[["delta"]]
  slot(object, "Delta") <- res[["Delta"]]
  return(object)
}


rupdateLSigma2 <- function(object,
			   nTry=10L,
			   nAccept=0L,
			   epsilon=0.2,
			   dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    l=object[["l"]],
			    sigma2=object[["sigma2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    c2=object[["c2"]],
			    gamma2=object[["gamma2"]],
			    r=object[["r"]],
			    rho=object[["rho"]],
			    phi=object[["phi"]],
			    t=object[["t"]],
			    tau2R=object[["tau2R"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]],
			    b=object[["b"]])
		return(res)
	}
		res <- .C("updateLSigma2_MI",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    l=object[["l"]],
			    sigma2=object[["sigma2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    c2=object[["c2"]],
			    gamma2=object[["gamma2"]],
			    r=object[["r"]],
			    rho=object[["rho"]],
			    phi=object[["phi"]],
			    t=object[["t"]],
			    tau2R=object[["tau2R"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]],
			    b=object[["b"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "l") <- res[["l"]]
	slot(object, "sigma2") <- res[["sigma2"]]
	return(object) ##nipun: Changed updateLSigma2 to updateLSigma2_MI
}

rupdateTSigma2 <- function(object,
			   nTry=10L,
			   nAccept=0L,
			   epsilon=0.2,
			   dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    t=object[["t"]],
			    sigma2=object[["sigma2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    c2=object[["c2"]],
			    gamma2=object[["gamma2"]],
			    r=object[["r"]],
			    rho=object[["rho"]],
			    phi=object[["phi"]],
			    l=object[["l"]],
			    tau2R=object[["tau2R"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]],
			    b=object[["b"]])
		return(res)
	}
		res <- .C("updateTSigma2_MI",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    t=object[["t"]],
			    sigma2=object[["sigma2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    c2=object[["c2"]],
			    gamma2=object[["gamma2"]],
			    r=object[["r"]],
			    rho=object[["rho"]],
			    phi=object[["phi"]],
			    l=object[["l"]],
			    tau2R=object[["tau2R"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]],
			    b=object[["b"]])   ##nipun: Changed updateTSigma2 to updateTSigma2_MI
	slot(object, "seed") <- res[["seed"]]
	slot(object, "t") <- res[["t"]]
	slot(object, "sigma2") <- res[["sigma2"]]
	return(object)
}

rupdateLambdaPhi <- function(object,
			     nTry=10L,
			     nAccept=0L,
			     epsilon=0.2,
			     dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    lambda=object[["lambda"]],
			    phi=object[["phi"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
  			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    sigma2=object[["sigma2"]],
			    theta=object[["theta"]])
		return(res)
	}
		res <- .C("updateLambdaPhi",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    lambda=object[["lambda"]],
			    phi=object[["phi"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    sigma2=object[["sigma2"]],
			    theta=object[["theta"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "lambda") <- res[["lambda"]]
	slot(object, "phi") <- res[["phi"]]
	return(object)
}

rupdateThetaPhi <- function(object,
			     nTry=10L,
			     nAccept=0L,
			     epsilon=0.2,
			     dryrun=FALSE){
	if(dryrun){
		res <- list(seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    theta=object[["theta"]],
			    phi=object[["phi"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    sigma2=object[["sigma2"]],
			    lambda=object[["lambda"]])
		return(res)
	}
		res <- .C("updateThetaPhi",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    theta=object[["theta"]],
			    phi=object[["phi"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    sigma2=object[["sigma2"]],
			    lambda=object[["lambda"]])
	slot(object, "seed") <- res[["seed"]]
	slot(object, "theta") <- res[["theta"]]
	slot(object, "phi") <- res[["phi"]]
	return(object)
}

##rupdateDeltaDDelta_MRF <- function(object,
##				   nTry=10L,
##				   nAccept=0L,
##			   dryrun=FALSE,
##				   one.delta=FALSE){
##	if(dryrun){
##	res <- list(seed=object[["seed"]],
##		    nTry=nTry,
##		    nAccept=nAccept,
##		    delta=object[["delta"]],
##		    Delta=object[["Delta"]],
##		    Q=object[["Q"]],
##		    G=object[["G"]],
##		    S=object[["S"]],
##		    x=exprs(object),
##		    psi=object[["phenodata"]],
##		    nu=object[["nu"]],
##		    c2=object[["c2"]],
##		    r=object[["r"]],
##		    sigma2=object[["sigma2"]],
##		    phi=object[["phi"]],
##		    tau2R=object[["tau2R"]],
##		    b=object[["b"]],
##		    nNeighbour=object[["nNeighbour"]],
##		    neighbour=object[["neighbour"]],
##		    alpha=object[["alpha"]],
##		    beta=object[["beta"]],
##		    betag=object[["betag"]])
##	if(one.delta) res <- res[-length(res)]
##	return(res)
##}
##if(one.delta){
##	res <- .C("updateDeltaDDelta_MRF_onedelta",
##		  seed=object[["seed"]],
##		    nTry=nTry,
##		    nAccept=nAccept,
##		    delta=object[["delta"]],
##		    Delta=object[["Delta"]],
##		    Q=object[["Q"]],
##		    G=object[["G"]],
##		    S=object[["S"]],
##		    x=exprs(object),
##		    psi=object[["phenodata"]],
##		    nu=object[["nu"]],
##		    c2=object[["c2"]],
##		    r=object[["r"]],
##		    sigma2=object[["sigma2"]],
##		    phi=object[["phi"]],
##		    tau2R=object[["tau2R"]],
##		    b=object[["b"]],
##		    nNeighbour=object[["nNeighbour"]],
##		    neighbour=object[["neighbour"]],
##		    alpha=object[["alpha"]],
##		    beta=object[["beta"]])##nipun:updateDeltaDDelta_MRF_onedelta missing
##} else {
##	res <- .C("updateDeltaDDelta_MRF",
##		  seed=object[["seed"]],
##		    nTry=nTry,
##		    nAccept=nAccept,
##		    delta=object[["delta"]],
##		    Delta=object[["Delta"]],
##		    Q=object[["Q"]],
##		    G=object[["G"]],
##		    S=object[["S"]],
##		    x=exprs(object),
##		    psi=object[["phenodata"]],
##		    nu=object[["nu"]],
##		    c2=object[["c2"]],
##		    r=object[["r"]],
##		    sigma2=object[["sigma2"]],
##		    phi=object[["phi"]],
##		    tau2R=object[["tau2R"]],
##		    b=object[["b"]],
##		    nNeighbour=object[["nNeighbour"]],
##		    neighbour=object[["neighbour"]],
##		    alpha=object[["alpha"]],
##		    beta=object[["beta"]],
##		  betag=object[["betag"]]) ##nipun:updateDeltaDDelta_MRF missing
##}
##slot(object, "seed") <- res[["seed"]]
##slot(object, "delta") <- res[["delta"]]
##slot(object, "Delta") <- res[["Delta"]]
##return(object)
##}





##rupdateAlpha_MRF <- function(object,
##			     nTry=10L,
##		     nAccept=0L,
##		     epsilon=0.2,
##		     dryrun=FALSE,
##		     one.delta=FALSE){
##if(dryrun){
##	res <- list(seed=object[["seed"]],
##		    nTry=nTry,
##		    nAccept=nAccept,
##		    epsilon=epsilon,
##		    alpha=object[["alpha"]],
##		    Q=object[["Q"]],
##		    G=object[["G"]],
##		    delta=object[["delta"]],
##			    nNeighbour=object[["nNeighbour"]],
##			    neighbour=object[["neighbour"]],
##		    beta=object[["beta"]],
##		    betag=object[["betag"]])
##	if(one.delta) res <- res[-length(res)]
##	return(res)
##}
##if(one.delta){
##	res <- .C("updateAlpha_MRF_onedelta",
##		  seed=object[["seed"]],
##		    nTry=nTry,
##		    nAccept=nAccept,
##		    epsilon=epsilon,
##		    alpha=object[["alpha"]],
##		    Q=object[["Q"]],
##		    G=object[["G"]],
##		    delta=object[["delta"]],
##		    nNeighbour=object[["nNeighbour"]],
##		    neighbour=object[["neighbour"]],
##		    beta=object[["beta"]])
##} else {
##	res <- .C("updateAlpha_MRF",
##		  seed=object[["seed"]],
##		    nTry=nTry,
##		    nAccept=nAccept,
##		    epsilon=epsilon,
##		    alpha=object[["alpha"]],
##		    Q=object[["Q"]],
##		    G=object[["G"]],
##		    delta=object[["delta"]],
##		    nNeighbour=object[["nNeighbour"]],
##		    neighbour=object[["neighbour"]],
##		    beta=object[["beta"]],
##		    betag=object[["betag"]])
##}
##slot(object, "seed") <- res[["seed"]]
##slot(object, "alpha") <- res[["alpha"]]
##return(object)
##}
##
##rupdateBeta_MRF <- function(object,
##		     nTry=10L,
##		     nAccept=0L,
##		     epsilon=0.2,
##		     dryrun=FALSE,
##		     one.delta=FALSE){
##if(dryrun){
##	res <- list(seed=object[["seed"]],
##		    nTry=nTry,
##		    nAccept=nAccept,
##		    epsilon=epsilon,
##		    beta=object[["beta"]],
##		    Q=object[["Q"]],
##		    G=object[["G"]],
##		    delta=object[["delta"]],
##		    nNeighbour=object[["nNeighbour"]],
##		    neighbour=object[["neighbour"]],
##		    alpha=object[["alpha"]],
##		    betag=object[["betag"]])
##	if(one.delta) res <- res[-length(res)]
##	return(res)
##}
##if(one.delta){
##	res <- .C("updateBeta_MRF_onedelta",
##		  seed=object[["seed"]],
##		    nTry=nTry,
##		    nAccept=nAccept,
##		    epsilon=epsilon,
##		    beta=object[["beta"]],
##		    Q=object[["Q"]],
##		    G=object[["G"]],
##		    delta=object[["delta"]],
##		    nNeighbour=object[["nNeighbour"]],
##		    neighbour=object[["neighbour"]],
##		    alpha=object[["alpha"]])
##} else {
##	res <- .C("updateBeta_MRF",
##		  seed=object[["seed"]],
##		    nTry=nTry,
##		    nAccept=nAccept,
##		    epsilon=epsilon,
##		    beta=object[["beta"]],
##		    Q=object[["Q"]],
##		    G=object[["G"]],
##		    delta=object[["delta"]],
##		    nNeighbour=object[["nNeighbour"]],
##		    neighbour=object[["neighbour"]],
##		    alpha=object[["alpha"]],
##		    betag=object[["betag"]])
##}
##slot(object, "seed") <- res[["seed"]]
##slot(object, "beta") <- res[["beta"]]
##return(object)
##}
##

##rupdateBetag_MRF <- function(object,
##		     nTry=10L,
##		     nAccept=0L,
##		     epsilon=0.2,
##		     dryrun=FALSE){
##if(dryrun){
##	res <- list(seed=object[["seed"]],
##		    nTry=nTry,
##		    nAccept=nAccept,
##		    epsilon=epsilon,
##		    betag=object[["betag"]],
##		    Q=object[["Q"]],
##		    G=object[["G"]],
##		    delta=object[["delta"]],
##		    nNeighbour=object[["nNeighbour"]],
##		    neighbour=object[["neighbour"]],
##		    alpha=object[["alpha"]],
##		    beta=object[["beta"]])
##	return(res)
##}
##	res <- .C("updateBetag_MRF",
##		  seed=object[["seed"]],
##		    nTry=nTry,
##		    nAccept=nAccept,
##		    epsilon=epsilon,
##		    betag=object[["betag"]],
##		    Q=object[["Q"]],
##		    G=object[["G"]],
##		    delta=object[["delta"]],
##		    nNeighbour=object[["nNeighbour"]],
##		    neighbour=object[["neighbour"]],
##		    alpha=object[["alpha"]],
##		    beta=object[["beta"]])
##slot(object, "seed") <- res[["seed"]]
##slot(object, "betag") <- res[["betag"]]
##	return(object)
##}

##nipun: wrappers for the remaining functions

rupdateAlpha <- function(object,
                     nTry=10L,
                     nAccept=0L,
                     epsilon=0.2,
                     dryrun=FALSE){
  #if(dryrun){
  # res <- list(seed=object[["seed"]],
  #              nTry=nTry,
  #              nAccept=nAccept,
  #              epsilon=epsilon,
  #              alpha=object[["alpha"]],
  #              Q=object[["Q"]],
  #              G=object[["G"]],
  #              delta=object[["delta"]],
  #              nNeighbour=object[["nNeighbour"]],
  #              neighbour=object[["neighbour"]],
  #              beta=object[["beta"]],
  #              betag=object[["betag"]])
  #  return(res)
  #}
  res <- .C("updateAlpha_MC",
            seed=object[["seed"]],
            nTry=nTry,
            nAccept=nAccept,
            epsilon=epsilon,
            alpha=object[["alpha"]],
            Q=object[["Q"]],
            G=object[["G"]],
            delta=object[["delta"]],
            nNeighbour=object[["nNeighbour"]],
            neighbour=object[["neighbour"]],
            beta=object[["beta"]],
            betag=object[["betag"]])
  slot(object, "seed") <- res[["seed"]]
  slot(object, "alpha") <- res[["alpha"]]
  return(object)
}

rupdateAlpha_onedelta <- function(object,
                         nTry=10L,
                         nAccept=0L,
                         epsilon=0.2,
                         dryrun=FALSE){
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                epsilon=epsilon,
                alpha=object[["alpha"]],
                Q=object[["Q"]],
                G=object[["G"]],
                delta=object[["delta"]],
                nNeighbour=object[["nNeighbour"]],
                neighbour=object[["neighbour"]],
                beta=object[["beta"]])
    return(res)
  }
  res <- .C("updateAlpha_MD",
            seed=object[["seed"]],
            nTry=nTry,
            nAccept=nAccept,
            epsilon=epsilon,
            alpha=object[["alpha"]],
            Q=object[["Q"]],
            G=object[["G"]],
            delta=object[["delta"]],
            nNeighbour=object[["nNeighbour"]],
            neighbour=object[["neighbour"]],
            beta=object[["beta"]])
  slot(object, "seed") <- res[["seed"]]
  slot(object, "alpha") <- res[["alpha"]]
  return(object)
}

rupdateBeta <- function(object,
                         nTry=10L,
                         nAccept=0L,
                         epsilon=0.2,
                         dryrun=FALSE){
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                epsilon=epsilon,
                beta=object[["beta"]],
                Q=object[["Q"]],
                G=object[["G"]],
                delta=object[["delta"]],
                nNeighbour=object[["nNeighbour"]],
                neighbour=object[["neighbour"]],
                alpha=object[["alpha"]],
                betag=object[["betag"]])
    return(res)
  }
  res <- .C("updateBeta_MC",
            seed=object[["seed"]],
            nTry=nTry,
            nAccept=nAccept,
            epsilon=epsilon,
            beta=object[["beta"]],
            Q=object[["Q"]],
            G=object[["G"]],
            delta=object[["delta"]],
            nNeighbour=object[["nNeighbour"]],
            neighbour=object[["neighbour"]],
            alpha=object[["alpha"]],
            betag=object[["betag"]])
  slot(object, "seed") <- res[["seed"]]
  slot(object, "beta") <- res[["beta"]]
  return(object)
}

rupdateBeta_onedelta <- function(object,
                        nTry=10L,
                        nAccept=0L,
                        epsilon=0.2,
                        dryrun=FALSE){
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                epsilon=epsilon,
                beta=object[["beta"]],
                Q=object[["Q"]],
                G=object[["G"]],
                delta=object[["delta"]],
                nNeighbour=object[["nNeighbour"]],
                neighbour=object[["neighbour"]],
                alpha=object[["alpha"]])
    return(res)
  }
  res <- .C("updateBeta_MD",
            seed=object[["seed"]],
            nTry=nTry,
            nAccept=nAccept,
            epsilon=epsilon,
            beta=object[["beta"]],
            Q=object[["Q"]],
            G=object[["G"]],
            delta=object[["delta"]],
            nNeighbour=object[["nNeighbour"]],
            neighbour=object[["neighbour"]],
            alpha=object[["alpha"]])
  slot(object, "seed") <- res[["seed"]]
  slot(object, "beta") <- res[["beta"]]
  return(object)
}

rupdateBetag <- function(object,
                     nTry=10L,
                     nAccept=0L,
                     epsilon=0.2,
                     dryrun=FALSE){
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                epsilon=epsilon,
                betag=object[["betag"]],
                Q=object[["Q"]],
                G=object[["G"]],
                delta=object[["delta"]],
                nNeighbour=object[["nNeighbour"]],
                neighbour=object[["neighbour"]],
                alpha=object[["alpha"]],
                beta=object[["beta"]])
    return(res)
  }
  res <- .C("updateBetag_MC",
            seed=object[["seed"]],
            nTry=nTry,
            nAccept=nAccept,
            epsilon=epsilon,
            betag=object[["betag"]],
            Q=object[["Q"]],
            G=object[["G"]],
            delta=object[["delta"]],
            nNeighbour=object[["nNeighbour"]],
            neighbour=object[["neighbour"]],
            alpha=object[["alpha"]],
            beta=object[["beta"]])
  slot(object, "seed") <- res[["seed"]]
  slot(object, "betag") <- res[["betag"]]
  return(object)
}


rupdateDelta <- function(object,
                        nTry=10L,
                        nAccept=0L,
                        dryrun=FALSE,
                        one.delta=FALSE){
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                delta=object[["delta"]],
                Q=object[["Q"]],
                G=object[["G"]],
                S=object[["S"]],
                x=exprs(object),
                psi=object[["phenodata"]],
                nu=object[["nu"]],
                Delta=object[["Delta"]],
                r=object[["r"]],
                sigma2=object[["sigma2"]],
                phi=object[["phi"]],
                xi=object[["xi"]],
                b=object[["b"]])

    if(one.delta) res <- res[-length(res)]
    return(res)
  }
  if(one.delta){
    res <- .C("updateDelta_MBII",
              seed=object[["seed"]],
              nTry=nTry,
              nAccept=nAccept,
              delta=object[["delta"]],
              Q=object[["Q"]],
              G=object[["G"]],
              S=object[["S"]],
              x=exprs(object),
              psi=object[["phenodata"]],
              nu=object[["nu"]],
              Delta=object[["Delta"]],
              r=object[["r"]],
              sigma2=object[["sigma2"]],
              phi=object[["phi"]],
              xi=object[["xi"]],
              b=object[["b"]])
  } else {
    res <- .C("updateDelta_MAII",
              seed=object[["seed"]],
              nTry=nTry,
              nAccept=nAccept,
              delta=object[["delta"]],
              Q=object[["Q"]],
              G=object[["G"]],
              S=object[["S"]],
              x=exprs(object),
              psi=object[["phenodata"]],
              nu=object[["nu"]],
              Delta=object[["Delta"]],
              r=object[["r"]],
              sigma2=object[["sigma2"]],
              phi=object[["phi"]],
              xi=object[["xi"]],
              b=object[["b"]])
  }
  slot(object, "seed") <- res[["seed"]]
  slot(object, "delta") <- res[["delta"]]
  return(object)
}

rupdateDelta_MRF2 <- function(object,
                                   nTry=10L,
                                   nAccept=0L,
                                   dryrun=FALSE,
                                   one.delta){
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                delta=object[["delta"]],
                Q=object[["Q"]],
                G=object[["G"]],
                S=object[["S"]],
                x=exprs(object),
                psi=object[["phenodata"]],
                nu=object[["nu"]],
                Delta=object[["Delta"]],
                r=object[["r"]],
                sigma2=object[["sigma2"]],
                phi=object[["phi"]],
                b=object[["b"]],
                nNeighbour=object[["nNeighbour"]],
                neighbour=object[["neighbour"]],
                alpha=object[["alpha"]],
                beta=object[["beta"]],
                betag=object[["betag"]])
    if(one.delta) res <- res[-length(res)]
    return(res)
  }
  if(one.delta){
    res <- .C("updateDelta_MDII",
              seed=object[["seed"]],
              nTry=nTry,
              nAccept=nAccept,
              delta=object[["delta"]],
              Q=object[["Q"]],
              G=object[["G"]],
              S=object[["S"]],
              x=exprs(object),
              psi=object[["phenodata"]],
              nu=object[["nu"]],
              Delta=object[["Delta"]],
              r=object[["r"]],
              sigma2=object[["sigma2"]],
              phi=object[["phi"]],
              b=object[["b"]],
              nNeighbour=object[["nNeighbour"]],
              neighbour=object[["neighbour"]],
              alpha=object[["alpha"]],
              beta=object[["beta"]])
   }else {
    res <- .C("updateDelta_MCII",
              seed=object[["seed"]],
              nTry=nTry,
              nAccept=nAccept,
              delta=object[["delta"]],
              Q=object[["Q"]],
              G=object[["G"]],
              S=object[["S"]],
              x=exprs(object),
              psi=object[["phenodata"]],
              nu=object[["nu"]],
              Delta=object[["Delta"]],
              r=object[["r"]],
              sigma2=object[["sigma2"]],
              phi=object[["phi"]],
              b=object[["b"]],
              nNeighbour=object[["nNeighbour"]],
              neighbour=object[["neighbour"]],
              alpha=object[["alpha"]],
              beta=object[["beta"]],
              betag=object[["betag"]])
  }
  slot(object, "seed") <- res[["seed"]]
  slot(object, "delta") <- res[["delta"]]
  return(object)
}

rupdateSigma2_HyperInverseWishart <- function(object,
                     nTry=10L,
                     nAccept=0L,
                     epsilon=0.2,
                     dryrun=FALSE){
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                epsilon=epsilon,
                sigma2=object[["sigma2"]],
                Q=object[["Q"]],
                G=object[["G"]],
                S=object[["S"]],
                x=exprs(object),
                psi=object[["phenodata"]],
                nu=object[["nu"]],
                delta=object[["delta"]],
                Delta=object[["Delta"]],
                gamma2=object[["gamma2"]],
                r=object[["r"]],
                rho=object[["rho"]],
                phi=object[["phi"]],
                t=object[["t"]],
                l=object[["l"]],
                tau2R=object[["tau2R"]],
                tau2Rho=object[["tau2Rho"]],
                a=object[["a"]],
                b=object[["b"]],
                Omega=object[["Omega"]],
                nClique=object[["nClique"]],
                oldClique=object[["oldClique"]],
                nOldComponents=object[["nOldComponents"]],
                nNewComponents=object[["nNewComponents"]],
                oldComponents=object[["oldComponents"]])
    return(res)
  }
  res <- .C("updateSigma2_MII",
            seed=object[["seed"]],
            nTry=nTry,
            nAccept=nAccept,
            epsilon=epsilon,
            sigma2=object[["sigma2"]],
            Q=object[["Q"]],
            G=object[["G"]],
            S=object[["S"]],
            x=exprs(object),
            psi=object[["phenodata"]],
            nu=object[["nu"]],
            delta=object[["delta"]],
            Delta=object[["Delta"]],
            gamma2=object[["gamma2"]],
            r=object[["r"]],
            rho=object[["rho"]],
            phi=object[["phi"]],
            t=object[["t"]],
            l=object[["l"]],
            tau2R=object[["tau2R"]],
            tau2Rho=object[["tau2Rho"]],
            a=object[["a"]],
            b=object[["b"]],
            Omega=object[["Omega"]],
            nClique=object[["nClique"]],
            oldClique=object[["oldClique"]],
            nOldComponents=object[["nOldComponents"]],
            nNewComponents=object[["nNewComponents"]],
            oldComponents=object[["oldComponents"]])

  slot(object, "seed") <- res[["seed"]]
  slot(object, "sigma2") <- res[["sigma2"]]
  return(object)
}

rupdateLSigma2_HyperInverseWishart <- function(object,
                     nTry=10L,
                     nAccept=0L,
                     epsilon=0.2,
                     dryrun=FALSE){
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                epsilon=epsilon,
                l=object[["l"]],
                sigma2=object[["sigma2"]],
                Q=object[["Q"]],
                G=object[["G"]],
                S=object[["S"]],
                x=exprs(object),
                psi=object[["phenodata"]],
                nu=object[["nu"]],
                delta=object[["delta"]],
                Delta=object[["Delta"]],
                gamma2=object[["gamma2"]],
                r=object[["r"]],
                rho=object[["rho"]],
                phi=object[["phi"]],
                t=object[["t"]],
                tau2R=object[["tau2R"]],
                tau2Rho=object[["tau2Rho"]],
                a=object[["a"]],
                b=object[["b"]],
                Omega=object[["Omega"]],
                S=object[["S"]],
                nClique=object[["nClique"]],
                oldClique=object[["oldClique"]],
                nOldComponents=object[["nOldComponents"]],
                nNewComponents=object[["nNewComponents"]],
                oldComponents=object[["oldComponents"]])
    return(res)
  }
  res <- .C("updateLSigma2_MII",
            seed=object[["seed"]],
            nTry=nTry,
            nAccept=nAccept,
            epsilon=epsilon,
            l=object[["l"]],
            sigma2=object[["sigma2"]],
            Q=object[["Q"]],
            G=object[["G"]],
            S=object[["S"]],
            x=exprs(object),
            psi=object[["phenodata"]],
            nu=object[["nu"]],
            delta=object[["delta"]],
            Delta=object[["Delta"]],
            gamma2=object[["gamma2"]],
            r=object[["r"]],
            rho=object[["rho"]],
            phi=object[["phi"]],
            t=object[["t"]],
            tau2R=object[["tau2R"]],
            tau2Rho=object[["tau2Rho"]],
            a=object[["a"]],
            b=object[["b"]],
            Omega=object[["Omega"]],
            S=object[["S"]],
            nClique=object[["nClique"]],
            oldClique=object[["oldClique"]],
            nOldComponents=object[["nOldComponents"]],
            nNewComponents=object[["nNewComponents"]],
            oldComponents=object[["oldComponents"]])
  slot(object, "seed") <- res[["seed"]]
  slot(object, "l") <- res[["l"]]
  return(object)
}

rupdateTSigma2_HyperInverseWishart <- function(object,
                     nTry=10L,
                     nAccept=0L,
                     epsilon=0.2,
                     dryrun=FALSE){
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                epsilon=epsilon,
                t=object[["t"]],
                sigma2=object[["sigma2"]],
                Q=object[["Q"]],
                G=object[["G"]],
                S=object[["S"]],
                x=exprs(object),
                psi=object[["phenodata"]],
                nu=object[["nu"]],
                delta=object[["delta"]],
                Delta=object[["Delta"]],
                gamma2=object[["gamma2"]],
                r=object[["r"]],
                rho=object[["rho"]],
                phi=object[["phi"]],
                l=object[["l"]],
                tau2R=object[["tau2R"]],
                tau2Rho=object[["tau2Rho"]],
                a=object[["a"]],
                b=object[["b"]],
                Omega=object[["Omega"]],
                nClique=object[["nClique"]],
                oldClique=object[["oldClique"]],
                nOldComponents=object[["nOldComponents"]],
                nNewComponents=object[["nNewComponents"]],
                oldComponents=object[["oldComponents"]])
    return(res)
  }
  res <- .C("updateTSigma2_MII",
            seed=object[["seed"]],
            nTry=nTry,
            nAccept=nAccept,
            epsilon=epsilon,
            t=object[["t"]],
            sigma2=object[["sigma2"]],
            Q=object[["Q"]],
            G=object[["G"]],
            S=object[["S"]],
            x=exprs(object),
            psi=object[["phenodata"]],
            nu=object[["nu"]],
            delta=object[["delta"]],
            Delta=object[["Delta"]],
            gamma2=object[["gamma2"]],
            r=object[["r"]],
            rho=object[["rho"]],
            phi=object[["phi"]],
            l=object[["l"]],
            tau2R=object[["tau2R"]],
            tau2Rho=object[["tau2Rho"]],
            a=object[["a"]],
            b=object[["b"]],
            Omega=object[["Omega"]],
            nClique=object[["nClique"]],
            oldClique=object[["oldClique"]],
            nOldComponents=object[["nOldComponents"]],
            nNewComponents=object[["nNewComponents"]],
            oldComponents=object[["oldComponents"]])

  slot(object, "seed") <- res[["seed"]]
  slot(object, "t") <- res[["t"]]
  return(object)
}

rupdateOmega_HyperInverseWishart <- function(object,
                     nAccept=0L,
                     dryrun=FALSE){
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nAccept=nAccept,
                Omega=object[["Omega"]],
                Q=object[["Q"]],
                G=object[["G"]],
                Delta=object[["Delta"]],
                r=object[["r"]],
                sigma2=object[["sigma2"]],
                tau2R=object[["tau2R"]],
                b=object[["b"]],
                zeta=object[["zeta"]],
                D=object[["D"]],
                nClique=object[["nClique"]],
                oldClique=object[["oldClique"]],
                nOldComponents=object[["nOldComponents"]],
                nNewComponents=object[["nNewComponents"]],
                oldComponents=object[["oldComponents"]])
    return(res)
  }
  res <- .C("updateOmega_MII",
            seed=object[["seed"]],
            nAccept=nAccept,
            Omega=object[["Omega"]],
            Q=object[["Q"]],
            G=object[["G"]],
            Delta=object[["Delta"]],
            r=object[["r"]],
            sigma2=object[["sigma2"]],
            tau2R=object[["tau2R"]],
            b=object[["b"]],
            zeta=object[["zeta"]],
            D=object[["D"]],
            nClique=object[["nClique"]],
            oldClique=object[["oldClique"]],
            nOldComponents=object[["nOldComponents"]],
            nNewComponents=object[["nNewComponents"]],
            oldComponents=object[["oldComponents"]])
  slot(object, "seed") <- res[["seed"]]
  slot(object, "Omega") <- res[["Omega"]]
  return(object)
}


rupdateDDeltaStar_HyperInverseWishart <- function(object,
                     nAccept=0L,
                     dryrun=FALSE){
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nAccept=nAccept,
                Delta=object[["Delta"]],
                Q=object[["Q"]],
                G=object[["G"]],
                S=object[["S"]],
                x=exprs(object),
                psi=object[["phenodata"]],
                nu=object[["nu"]],
                delta=object[["delta"]],
                r=object[["r"]],
                sigma2=object[["sigma2"]],
                phi=object[["phi"]],
                tau2R=object[["tau2R"]],
                b=object[["b"]],
                Omega=object[["Omega"]],
                nClique=object[["nClique"]],
                oldClique=object[["oldClique"]],
                nOldComponents=object[["nOldComponents"]],
                nNewComponents=object[["nNewComponents"]],
                oldComponents=object[["oldComponents"]])
    return(res)
  }
  res <- .C("updateDeltaStar_MII",
            seed=object[["seed"]],
            nAccept=nAccept,
            Delta=object[["Delta"]],
            Q=object[["Q"]],
            G=object[["G"]],
            S=object[["S"]],
            x=exprs(object),
            psi=object[["phenodata"]],
            nu=object[["nu"]],
            delta=object[["delta"]],
            r=object[["r"]],
            sigma2=object[["sigma2"]],
            phi=object[["phi"]],
            tau2R=object[["tau2R"]],
            b=object[["b"]],
            Omega=object[["Omega"]],
            nClique=object[["nClique"]],
            oldClique=object[["oldClique"]],
            nOldComponents=object[["nOldComponents"]],
            nNewComponents=object[["nNewComponents"]],
            oldComponents=object[["oldComponents"]])

  slot(object, "seed") <- res[["seed"]]
  slot(object, "Delta") <- res[["Delta"]]
  return(object)
}


rupdateTau2RDDeltaStar_HyperInverseWishart <- function(object,
                     nTry=10L,
                     nAccept=0L,
                     epsilon=0.2,
                     dryrun=FALSE){
	phenodata <- object[["phenodata"]]
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                epsilon=epsilon,
                tau2R=object[["tau2R"]],
                Delta=object[["Delta"]],
                Q=object[["Q"]],
                G=object[["G"]],
                S=object[["S"]],
                x=exprs(object),
                psi=object[["phenodata"]],
                nu=object[["nu"]],
                delta=object[["delta"]],
                r=object[["r"]],
                sigma2=object[["sigma2"]],
                phi=object[["phi"]],
                b=object[["b"]],
                Omega=object[["Omega"]],
                nClique=object[["nClique"]],
                oldClique=object[["oldClique"]],
                nOldComponents=object[["nOldComponents"]],
                nNewComponents=object[["nNewComponents"]],
                oldComponents=object[["oldComponents"]])
    return(res)
  }
  res <- .C("updateTau2RDDeltaStar_MII",
            seed=object[["seed"]],
            nTry=nTry,
            nAccept=nAccept,
            epsilon=epsilon,
            tau2R=object[["tau2R"]],
            Delta=object[["Delta"]],
            Q=object[["Q"]],
            G=object[["G"]],
            S=object[["S"]],
            x=exprs(object),
            psi=object[["phenodata"]],
            nu=object[["nu"]],
            delta=object[["delta"]],
            r=object[["r"]],
            sigma2=object[["sigma2"]],
            phi=object[["phi"]],
            b=object[["b"]],
            Omega=object[["Omega"]],
            nClique=object[["nClique"]],
            oldClique=object[["oldClique"]],
            nOldComponents=object[["nOldComponents"]],
            nNewComponents=object[["nNewComponents"]],
            oldComponents=object[["oldComponents"]])
  slot(object, "seed") <- res[["seed"]]
  slot(object, "tau2R") <- res[["tau2R"]]
  return(object)
}


rupdateBDDeltaStar_HyperInverseWishart <- function(object,
                     nTry=10L,
                     nAccept=0L,
                     epsilon=0.2,
                     dryrun=FALSE){
  phenodata <- NULL
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                epsilon=epsilon,
                b=object[["b"]],
                Delta=object[["Delta"]],
                Q=object[["Q"]],
                G=object[["G"]],
                S=object[["S"]],
                x=exprs(object),
                psi=object[["phenodata"]],
                nu=object[["nu"]],
                delta=object[["delta"]],
                r=object[["r"]],
                sigma2=object[["sigma2"]],
                phi=object[["phi"]],
                tau2R=object[["tau2R"]],
                pB0=object[["pB0"]],
                pB1=object[["pB1"]],
                alphaB=object[["alphaB"]],
                betaB=object[["betaB"]],
                Omega=object[["Omega"]],
                nClique=object[["nClique"]],
                oldClique=object[["oldClique"]],
                nOldComponents=object[["nOldComponents"]],
                nNewComponents=object[["nNewComponents"]],
                oldComponents=object[["oldComponents"]])
    return(res)
  }
  res <- .C("updateBDDeltaStar_MII",
            seed=object[["seed"]],
            nTry=nTry,
            nAccept=nAccept,
            epsilon=epsilon,
            b=object[["b"]],
            Delta=object[["Delta"]],
            Q=object[["Q"]],
            G=object[["G"]],
            S=object[["S"]],
            x=exprs(object),
            psi=phenodata,
            nu=object[["nu"]],
            delta=object[["delta"]],
            r=object[["r"]],
            sigma2=object[["sigma2"]],
            phi=object[["phi"]],
            tau2R=object[["tau2R"]],
            pB0=object[["pB0"]],
            pB1=object[["pB1"]],
            alphaB=object[["alphaB"]],
            betaB=object[["betaB"]],
            Omega=object[["Omega"]],
            nClique=object[["nClique"]],
            oldClique=object[["oldClique"]],
            nOldComponents=object[["nOldComponents"]],
            nNewComponents=object[["nNewComponents"]],
            oldComponents=object[["oldComponents"]])
  slot(object, "seed") <- res[["seed"]]
  slot(object, "b") <- res[["b"]]
  return(object)
}


rupdateRDDeltaStar_HyperInverseWishart <- function(object,
                     nTry=10L,
                     nAccept=0L,
                     epsilon=0.2,
                     dryrun=FALSE){
	phenodata <- object[["phenodata"]]
  if(dryrun){
    res <- list(seed=object[["seed"]],
                nTry=nTry,
                nAccept=nAccept,
                epsilon=epsilon,
                r=object[["r"]],
                Delta=object[["Delta"]],
                Q=object[["Q"]],
                G=object[["G"]],
                S=object[["S"]],
                x=exprs(object),
                psi=object[["phenodata"]],
                nu=object[["nu"]],
                delta=object[["delta"]],
                sigma2=object[["sigma2"]],
                phi=object[["phi"]],
                tau2R=object[["tau2R"]],
                b=object[["b"]],
                nuR=object[["nuR"]],
                Omega=object[["Omega"]],
                nClique=object[["nClique"]],
                oldClique=object[["oldClique"]],
                nOldComponents=object[["nOldComponents"]],
                nNewComponents=object[["nNewComponents"]],
                oldComponents=object[["oldComponents"]])
    return(res)
  }
  res <- .C("updateRDDeltaStar_MII",
            seed=object[["seed"]],
            nTry=nTry,
            nAccept=nAccept,
            epsilon=epsilon,
            r=object[["r"]],
            Delta=object[["Delta"]],
            Q=object[["Q"]],
            G=object[["G"]],
            S=object[["S"]],
            x=exprs(object),
            psi=object[["phenodata"]],
            nu=object[["nu"]],
            delta=object[["delta"]],
            sigma2=object[["sigma2"]],
            phi=object[["phi"]],
            tau2R=object[["tau2R"]],
            b=object[["b"]],
            nuR=object[["nuR"]],
            Omega=object[["Omega"]],
            nClique=object[["nClique"]],
            oldClique=object[["oldClique"]],
            nOldComponents=object[["nOldComponents"]],
            nNewComponents=object[["nNewComponents"]],
            oldComponents=object[["oldComponents"]])
  slot(object, "seed") <- res[["seed"]]
  slot(object, "r") <- res[["r"]]
  return(object)
}



##nipun: common to A, B and MI
modelA_B_MIupdates <- function(object,
			       nupdates = 1500,
			       nTry=10L,
			       nAccept=0L,
			       epsilon=0.2,
			       dryrun=FALSE,
                               one.delta=FALSE){
	G <- object@G; Q <- object@Q
	delta <- array(NA, dim=c(G, Q, nupdates))
	## Q parameters
	lambda <- theta <- xi <- t <- l <- r <- rho <- tau2R <- tau2Rho <- b <- a <- matrix(NA, Q, nupdates)
	## single parameter
	gamma2 <- c2 <- rep(NA, nupdates)
	## hyperparameters
	## alphaXi, betaXi,...
	phenodata <- object@phenodata
	d.i <- object[["delta"]]
	DD.i <- object[["Delta"]]
	S <- object[["S"]]
  d <- x <- NULL
	for(i in seq_len(nupdates)){
		res <- .C("updateANu",
			  seed=object[["seed"]],
			  nTry=as.integer(nTry),
			  nAccept=as.integer(nAccept),
			  epsilon=as.numeric(epsilon),
			  a=object[["a"]],
			  nu=object[["nu"]],
			  Q=Q,
			  G=G,
			  S=S,
			  x=x,
			  psi=phenodata,
			  delta=d.i,
			  Delta=object[["Delta"]],
			  gamma2=object[["gamma2"]],
			  rho=object[["rho"]],
			  sigma2=object[["sigma2"]],
			  phi=object[["phi"]],
			  tau2Rho=object[["tau2Rho"]],
			  pA0=object[["pA0"]],
			  pA1=object[["pA1"]],
			  alphaA=object[["alphaA"]],
			  betaA=object[["betaA"]])
		slot(object, "seed") <- res[["seed"]]
		slot(object, "nu") <- res[["nu"]]
		a[, i] <- slot(object, "a") <- res[["a"]]


		res <- .C("updateTau2RhoNu",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  epsilon=epsilon,
			  tau2Rho=object[["tau2Rho"]],
			  nu=object[["nu"]],
			  Q=object[["Q"]],
			  G=object[["G"]],
			  S=object[["S"]],
			  x=x,
			  psi=phenodata,
			  delta=object[["delta"]],
			  Delta=object[["Delta"]],
			  gamma2=object[["gamma2"]],
			  rho=object[["rho"]],
			  sigma2=object[["sigma2"]],
			  phi=object[["phi"]],
			  a=object[["a"]])
		## update tau2Rho and nu
		slot(object, "seed") <- res[["seed"]]
		tau2Rho[, i] <- slot(object, "tau2Rho") <- res[["tau2Rho"]]
		slot(object, "nu") <- res[["nu"]]


		res <- .C("updateNu",
			  seed=object[["seed"]],
			  nAccept=nAccept,
			  nu=object[["nu"]],
			  Q=object[["Q"]],
			  G=object[["G"]],
			  S=object[["S"]],
			  x=exprs(object),
			  psi=object[["phenodata"]],
			  delta=object[["delta"]],
			  Delta=object[["Delta"]],
			  gamma2=object[["gamma2"]],
			  rho=object[["rho"]],
			  sigma2=object[["sigma2"]],
			  phi=object[["phi"]],
			  tau2Rho=object[["tau2Rho"]],
			  a=object[["a"]])
		slot(object, "seed") <- res[["seed"]]
		slot(object, "nu") <- res[["nu"]]

		res <- .C("updateGamma2",
			  seed=object[["seed"]],
			  nAccept=nAccept,
			  gamma2=object[["gamma2"]],
			  Q=object[["Q"]],
			  G=object[["G"]],
			  nu=object[["nu"]],
			  rho=object[["rho"]],
			  sigma2=object[["sigma2"]],
			  tau2Rho=object[["tau2Rho"]],
			  a=object[["a"]])
		slot(object, "seed") <- res[["seed"]]
		gamma2[i] <- slot(object, "gamma2") <- res[["gamma2"]]

		res <- .C("updateRhoNu",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    rho=object[["rho"]],
			    nu=object[["nu"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    gamma2=object[["gamma2"]],
			    sigma2=object[["sigma2"]],
			    phi=object[["phi"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]],
			    nuRho=object[["nuRho"]])
		slot(object, "seed") <- res[["seed"]]
		rho[, i] <- slot(object, "rho") <- res[["rho"]]
		slot(object, "nu") <- res[["nu"]]

		res <- .C("updateRhoGamma2",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    rho=object[["rho"]],
			    gamma2=object[["gamma2"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    nu=object[["nu"]],
			    sigma2=object[["sigma2"]],
			    tau2Rho=object[["tau2Rho"]],
			    a=object[["a"]],
			    nuRho=object[["nuRho"]])
		slot(object, "seed") <- res[["seed"]]
		rho[, i] <- slot(object, "rho") <- res[["rho"]]
		gamma2[i] <- slot(object, "gamma2") <- res[["gamma2"]]

		res <- .C("updatePhi",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    phi=object[["phi"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    sigma2=object[["sigma2"]],
			    theta=object[["theta"]],
			    lambda=object[["lambda"]])
		slot(object, "seed") <- res[["seed"]]
		slot(object, "phi") <- res[["phi"]]

		res <- .C("updateTheta",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  epsilon=epsilon,
			  theta=object[["theta"]],
			  Q=object[["Q"]],
			  G=object[["G"]],
			  phi=object[["phi"]],
			  lambda=object[["lambda"]])
		slot(object, "seed") <- res[["seed"]]
		theta[,i] <- slot(object, "theta") <- res[["theta"]]

		res <- .C("updateLambda",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    lambda=object[["lambda"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    phi=object[["phi"]],
			    theta=object[["theta"]])
		slot(object, "seed") <- res[["seed"]]
		lambda[,i] <- slot(object, "lambda") <- res[["lambda"]]

		res <- .C("updateT",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    t=object[["t"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    sigma2=object[["sigma2"]],
			    l=object[["l"]])
		slot(object, "seed") <- res[["seed"]]
		t[,i] <- slot(object, "t") <- res[["t"]]

		res <- .C("updateL",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  epsilon=epsilon,
			  l=object[["l"]],
			  Q=Q,
			  G=G,
			  sigma2=object[["sigma2"]],
			  t=object[["t"]])
		slot(object, "seed") <- res[["seed"]]
		l[,i] <- slot(object, "l") <- res[["l"]]

		res <- .C("updateLambdaPhi",
			  seed=object[["seed"]],
			    nTry=nTry,
			    nAccept=nAccept,
			    epsilon=epsilon,
			    lambda=object[["lambda"]],
			    phi=object[["phi"]],
			    Q=object[["Q"]],
			    G=object[["G"]],
			    S=object[["S"]],
			    x=exprs(object),
			    psi=object[["phenodata"]],
			    nu=object[["nu"]],
			    delta=object[["delta"]],
			    Delta=object[["Delta"]],
			    sigma2=object[["sigma2"]],
			    theta=object[["theta"]])
		slot(object, "seed") <- res[["seed"]]
		slot(object, "lambda") <- res[["lambda"]]
		slot(object, "phi") <- res[["phi"]]

		if(one.delta){
			##updateXi_MB
			res <- .C("updateXi_MB",
				  seed=object[["seed"]],
				  nAccept=nAccept,
				  xi=object[["xi"]],
				  Q=Q,
				  G=G,
				  delta=d.i,
				  t=object[["t"]],
				  alphaXi=object[["alphaXi"]],
				  betaXi=object[["betaXi"]])		##nipun: changed updateXi_onedelta to updateXi_MB
		} else {
			##updateXi_MA
			res <- .C("updateXi_MA",
				  seed=object[["seed"]],
				  nAccept=nAccept,
				  xi=object[["xi"]],
				  Q=Q,
				  G=G,
				  delta=d.i,
				  t=object[["t"]],
				  alphaXi=object[["alphaXi"]],
				  betaXi=object[["betaXi"]])  ##nipun: changed updateXi to updateXi_MA
		}
		slot(object, "seed") <- res[["seed"]]
		d.i <- res[["delta"]]
		xi[,i] <- slot(object, "xi") <- res[["xi"]]
		##updateBDDelta_MI
		res <- .C("updateBDDelta_MI",
			  seed=object[["seed"]],
			  nTry=as.integer(nTry),
			  nAccept=as.integer(nAccept),
			  epsilon=as.numeric(epsilon),
			  b=object[["b"]],
			  Delta=DD.i,
			  Q=Q,
			  G=G,
			  S=S,
			  x=x,
			  psi=phenodata,
			  nu=object[["nu"]],
			  delta=d.i,
			  c2=object[["c2"]],
			  r=object[["r"]],
			  sigma2=object[["sigma2"]],
			  phi=object[["phi"]],
			  tau2R=object[["tau2R"]],
			  pB0=object[["pB0"]],
			  pB1=object[["pB1"]],
			  alphaB=object[["alphaB"]],
			  betaB=object[["betaB"]])

		b.i <- res[["b"]]
		b[, i] <- b.i
		DD.i <- res[["Delta"]]
		slot(object, "seed") <- res[["seed"]]
		slot(object, "b") <- b.i
		slot(object, "Delta") <- DD.i

		##updateTau2RDDelta_MI
		res <- .C("updateTau2RDDelta_MI",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  epsilon=epsilon,
			  tau2R=object[["tau2R"]],
			  Delta=DD.i,
			  Q=Q,
			  G=G,
			  S=S,
			  x=x,
			  psi=phenodata,
			  nu=object[["nu"]],
			  delta=d.i,
			  c2=object[["c2"]],
			  r=object[["r"]],
			  sigma2=object[["sigma2"]],
			  phi=object[["phi"]],
			  b=b.i)
		## update tau2R and Delta

		DD.i <- res[["Delta"]]
		tau2R.i <- res[["tau2R"]]
		tau2R[, i] <- tau2R.i
		slot(object, "Delta") <- DD.i
		slot(object, "seed") <- res[["seed"]]
		slot(object, "tau2R") <- tau2R.i

		##updateDDelta_MI
		res <- .C("updateDDelta_MI",
			  seed=object[["seed"]],
			  nAccept=nAccept,
			  Delta=DD.i,
			  Q=Q,
			  G=G,
			  S=object[["S"]],
			  x=x,
			  psi=phenodata,
			  nu=object[["nu"]],
			  delta=d.i,
			  c2=object[["c2"]],
			  r=object[["r"]],
			  sigma2=object[["sigma2"]],
			  phi=object[["phi"]],
			  tau2R=tau2R.i,
			  b=object[["b"]])
		slot(object, "seed") <- res[["seed"]]
		DD.i <- res[["Delta"]]
		slot(object, "Delta") <- DD.i
		##all.equal(d.i, res[["delta"]])

		##updateC2_MI
		res <- .C("updateC2_MI",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  c2=object[["c2"]],
			  Q=Q,
			  G=G,
			  delta=d.i,
			  Delta=DD.i,
			  r=object[["r"]],
			  sigma2=object[["sigma2"]],
			  tau2R=tau2R.i,
			  b=b.i,
			  c2Max=object[["c2Max"]])
		slot(object, "seed") <- res[["seed"]]
		c2[i] <- slot(object, "c2") <- res[["c2"]]

		##updateC2DDelta_MI
		res <- .C("updateC2DDelta_MI",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  epsilon=epsilon,
			  c2=object[["c2"]],
			  Delta=DD.i,
			  Q=Q,
			  G=G,
			  S=S,
			  x=x,
			  psi=phenodata,
			  nu=object[["nu"]],
			  delta=d.i,
			  r=object[["r"]],
			  sigma2=object[["sigma2"]],
			  phi=object[["phi"]],
			  tau2R=tau2R.i,
			  b=b.i,
			  c2Max=object[["c2Max"]])
		##all.equal(d.i, res[["delta"]])
		DD.i <- res[["Delta"]]
		slot(object, "seed") <- res[["seed"]]
		c2[i] <- slot(object, "c2") <- res[["c2"]]
		slot(object, "Delta") <- DD.i

		##updateGamma2Nu_MI
		res <- .C("updateGamma2Nu_MI",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  epsilon=epsilon,
			  gamma2=object[["gamma2"]],
			  nu=object[["nu"]],
			  Q=Q,
			  G=G,
			  S=S,
			  x=x,
			  psi=phenodata,
			  delta=d.i,
			  Delta=DD.i,
			  rho=object[["rho"]],
			  sigma2=object[["sigma2"]],
			  phi=object[["phi"]],
			  tau2Rho=object[["tau2Rho"]],
			  a=object[["a"]])
		slot(object, "seed") <- res[["seed"]]
		gamma2[i] <- slot(object, "gamma2") <- res[["gamma2"]]
		slot(object,  "nu") <- res[["nu"]]

		##updateRDDelta_MI
		res <- .C("updateRDDelta_MI",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  epsilon=epsilon,
			  r=object[["r"]],
			  Delta=DD.i,
			  Q=Q,
			  G=G,
			  S=S,
			  x=x,
			  psi=phenodata,
			  nu=object[["nu"]],
			  delta=d.i,
			  c2=object[["c2"]],
			  sigma2=object[["sigma2"]],
			  phi=object[["phi"]],
			  tau2R=tau2R.i,
			  b=b.i,
			  nuR=object[["nuR"]])
		slot(object, "seed") <- res[["seed"]]
		r[, i] <- slot(object, "r") <- res[["r"]]
		DD.i <- res[["Delta"]]
		slot(object, "Delta") <- DD.i


		##updateRC2_MI
		res <- .C("updateRC2_MI",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  epsilon=epsilon,
			  r=object[["r"]],
			  c2=object[["c2"]],
			  Q=object[["Q"]],
			  G=object[["G"]],
			  delta=object[["delta"]],
			  Delta=object[["Delta"]],
			  sigma2=object[["sigma2"]],
			  tau2R=object[["tau2R"]],
			  b=object[["b"]],
			  nuR=object[["nuR"]],
			  c2Max=object[["c2Max"]])
		slot(object, "seed") <- res[["seed"]]
		r[, i] <- slot(object, "r") <- res[["r"]]
		c2[i] <- slot(object, "c2") <- res[["c2"]]

		##updateSigma2_MI
		res <- .C("updateSigma2_MI",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  epsilon=epsilon,
			  sigma2=object[["sigma2"]],
			  Q=Q,
			  G=G,
			  S=S,
			  x=x,
			  psi=phenodata,
			  nu=object[["nu"]],
			  delta=d.i,
			  Delta=DD.i,
			  c2=object[["c2"]],
			  gamma2=object[["gamma2"]],
			  r=object[["r"]],
			  rho=object[["rho"]],
			  phi=object[["phi"]],
			  t=object[["t"]],
			  l=object[["l"]],
			  tau2R=object[["tau2R"]],
			  tau2Rho=object[["tau2Rho"]],
			  a=object[["a"]],
			  b=object[["b"]])
		slot(object, "seed") <- res[["seed"]]
		slot(object, "sigma2") <- res[["sigma2"]]

		##updateLSigma2_MI
		res <- .C("updateLSigma2_MI",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  epsilon=epsilon,
			  l=object[["l"]],
			  sigma2=object[["sigma2"]],
			  Q=Q,
			  G=G,
			  S=S,
			  x=x,
			  psi=phenodata,
			  nu=object[["nu"]],
			  delta=d.i,
			  Delta=DD.i,
			  c2=object[["c2"]],
			  gamma2=object[["gamma2"]],
			  r=object[["r"]],
			  rho=object[["rho"]],
			  phi=object[["phi"]],
			  t=object[["t"]],
			  tau2R=object[["tau2R"]],
			  tau2Rho=object[["tau2Rho"]],
			  a=object[["a"]],
			  b=object[["b"]])
		slot(object, "seed") <- res[["seed"]]
		l[, i] <- slot(object, "l") <- res[["l"]]
		slot(object, "sigma2") <- res[["sigma2"]]

		##updateTSigma2_MI
		res <- .C("updateTSigma2_MI",
			  seed=object[["seed"]],
			  nTry=nTry,
			  nAccept=nAccept,
			  epsilon=epsilon,
			  t=object[["t"]],
			  sigma2=object[["sigma2"]],
			  Q=Q,
			  G=G,
			  S=S,
			  x=x,
			  psi=phenodata,
			  nu=object[["nu"]],
			  delta=object[["delta"]],
			  Delta=object[["Delta"]],
			  c2=object[["c2"]],
			  gamma2=object[["gamma2"]],
			  r=object[["r"]],
			  rho=object[["rho"]],
			  phi=object[["phi"]],
			  l=object[["l"]],
			  tau2R=object[["tau2R"]],
			  tau2Rho=object[["tau2Rho"]],
			  a=object[["a"]],
			  b=object[["b"]])   ##nipun: Changed updateTSigma2 to updateTSigma2_MI
		slot(object, "seed") <- res[["seed"]]
		t[, i] <- slot(object, "t") <- res[["t"]]
		slot(object, "sigma2") <- res[["sigma2"]]
	}##for
	list(object=object,
	     d=d,
	     t=t,
	     l=l,
	     lambda=lambda,
	     theta=theta,
	     c2=c2,
	     r=r,
	     rho=rho,
	     tau2R=tau2R,
	     tau2Rho=tau2Rho,
	     a=a,
	     b=b,
	     gamma2=gamma2,
	     c2=c2,
	     xi=xi)

	return(object)
}##modelA_B_MIupdates

% \VignetteIndexEntry{XDE Vignette}
% \VignetteKeywords{microarray, differential expression, meta-analysis}
% \VignettePackage{XDE}
\documentclass{article}
\usepackage{amsmath}
\usepackage{inconsolata}
\usepackage{graphicx}
\usepackage{natbib}
\usepackage{hyperref}
\usepackage[mathcal]{euscript}

\parindent 0in  % Left justify
\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}

\newcommand{\Rpackage}[1]{\textit{#1}}
\newcommand{\Rfunction}[1]{\texttt{#1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\stan}{\texttt{Stanford}}
\newcommand{\xde}{\textit{XDE}}
\newcommand{\eset}{\Robject{ExpressionSet}}
\newcommand{\esets}{\Robject{ExpressionSet}s}
\newcommand{\esetList}{\Robject{ExpressionSetList}}
\newcommand{\esetLists}{\Robject{ExpressionSetList}s}
\newcommand{\xparam}{\Robject{XdeParameter}}
\newcommand{\xmcmc}{\Robject{XdeMcmc}}
\newcommand{\R}{\textsf{R}}
\newcommand{\bioc}{http://www.bioconductor.org}

\textwidth=6.2in
\textheight=8.5in
\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\title{XDE: A Bayesian hierarchical model for analysis of differential
  expression in multiple studies}

\author{Robert Scharpf, Andrew Nobel, Giovanni Parmigiani, H\aa kon
  Tjelmeland}

\begin{document}

\maketitle

<<echo=FALSE>>=
options(width=60)
@

\section{Introduction}

There are many publicly available high throughput gene expression
studies that address comparable biological questions with similar
patient populations.  For economical and practical reasons many of
these studies have a relatively small number of biological replicates.
To improve the statistical power it is of interest to combine observed
data from several microarray studies, potentially measured with
different technologies.  However, variation in the measured gene
expression levels is caused not only by the biological conditions of
interest and natural variation in gene expression in different samples
of the same type, but also to a great extent by technological
differences between studies.  To successfully combine observed data
from different studies, it is therefore essential to filter out the
technological effects.  The \R{} package \Rpackage{XDE} fits a
Bayesian Hierarchical model for estimation of differential expression
in 2 or more studies.  Alternative methods for assessing differential
expression are provided.  Other \R{} packages developed for the
cross-study analysis of differential expression are
\Rpackage{GeneMeta} \cite{Lusa2007}, \Rpackage{metaArray}
\cite{Choi2007}, and \Rpackage{rankProduct} \cite{Hong2006}.


After reading this vignette, one should be able to
\begin{itemize}

\item create an instance of the class \esetList{}

\item create an instance of the class \xparam{} that contains default
  options for the MCMC

\item fit the Bayesian hierarchical model to two or more studies
  stored as an \esetList{} class

\item plot MCMC chains to assess convergence

\item compute posterior averages for concordant and discordant
  differential expression

\item generate alternative cross-study summaries of differential
  expression

\end{itemize}

See \cite{Scharpf2009} for a more detailed discussion of the Bayesian
hierarchical model

\section{\label{sec:xlist} The \esetList{} Class}

Presently the software for fitting the Bayesian hierarchical model
requires that each study be represented as an \Robject{ExpressionSet}
\cite{Gentleman2004} and that the same features be present in each
study (the \Rfunction{featureNames} of the studies must be identical).
Therefore, for the meta-analysis of several platforms,
platform-specific annotations must be mapped to a common reference
identifier.  Mapping identifiers in each platform is a non-trivial
stop in any cross-study analysis.  The \R{} packages
\Rpackage{funcBox} (not yet publicly available) and
\Rpackage{MergeMaid} have been developed to facilitate the annotation
process and the merging of multiple studies, respectively
\cite{Cope2004}.

For the purposes of this vignette, \xde{} provides an example dataset
of a single study that was split into three artificial datasets.

<<data, eval=TRUE>>=
library(XDE)
data(expressionSetList)
xlist <- expressionSetList
class(xlist)
@

The original study is described in \cite{garb:etal:2001}.  The
processed data was mapped to unigene identifiers and made available in
the experimental data package \Rpackage{lungExpression} (\bioc) to
facilitate the reproducibility of the analyses described in
\cite{Parmigiani2004a}.

The function \Rfunction{validObject} checks that the each element in
\esetList{} is a valid \eset{} and that the \Robject{featureNames} are
the same in each element.

<<validObject, eval=TRUE>>=
validObject(xlist)
@

In order to assess differential expression across multiple studies,
one must define a dichotomous covariate in the \Robject{phenoData} of
each \eset{} element in the \esetList{} object.  This covariate must
have an identical name in each study.  In this vignette, we will use
\xde{} to quantify differential expression between adenocarcinomas and
squamous carcinomas.  The binary covariate ``adenoVsquamous'' has been
defined in each of the \eset{} elements for this purpose.  The
following statement must evaluate to \texttt{TRUE}:

<<covariate>>=
stopifnot(all(sapply(xlist, function(x, label){ label %in% varLabels(x)}, label="adenoVsquamous")))
@



\section{\label{sec:XdeParam} The \xparam{} Class}

There are many features in our implementation of the hierarchical
Bayesian model that can be modified:

\begin{itemize}

\item hyperparameters for the Bayesian hierarchical model

\item the seed for generating random values in the MCMC

\item the starting values for the MCMC chains

\item tuning parameters for Metropolis-Hastings proposals

\item the number of updates per MCMC iteration (each parameter can
  have a different number of updates)

\item selection of MCMC chains that are to be written to log files

\end{itemize}

All of the above features are provided in the \xparam{} class.  The
attributes provided when initializing an instance of class \xparam{}
work well in most instances.  The \xparam{} vignette provides a more
detailed description of how the attributes can be modified, as well as
a brief description of the Bayesian model and the algorithm for the
MCMC.  See \cite{Scharpf2009} for a more detailed description of the
Bayesian model.

The default values for our \Robject{xlist} object are obtained by
initializing an instance of the \xparam{} class:

<<initializeList, eval=TRUE>>=
params <- new("XdeParameter", esetList=xlist, phenotypeLabel="adenoVsquamous")
params
@

This parameterization, presently the default, assumes that a gene is
differentially expressed in all studies or in none.  An alternative
parametrization that allows genes to be differentially expressed in a
subset of studies can be obtained by setting the argument
\Robject{one.delta} to \Robject{FALSE}.

<<initializeList2, eval=FALSE>>=
params <- new("XdeParameter", esetList=xlist,
	      phenotypeLabel="adenoVsquamous", one.delta=FALSE)
@

Whether one fits the ``$\delta_g$'' (\Robject{one.delta=TRUE}) or the
``$\delta_{gp}$'' model (\Robject{one.delta=FALSE}), the chain written
to file is of dimension G x P x I, where G is the number of genes, P
is the number of studies, and S is the number of samples (in the case
of the $\delta_g$ model, the value written to file for a single gene
will be the same for each study.  The same is true for the $\xi_p$
parameter.)

\section{\label{sec:fit} Fitting the Bayesian hierarchical model}

\subsection{Starting values}

\paragraph{Randomly simulated starting values}
By default, the first iteration of the MCMC chain stored in the slot
\texttt{firstMcmc} of the \Robject{params} are simulated randomly from
the priors.  When the value of \texttt{burnin} is true, the output
from the MCMC are not saved to file and the chain can not be monitored
for convergence. By default the value of \Robject{burnin} is TRUE and
only the last iteration from the chain will be available (the
parameters are not written to log files).





\paragraph{Empirical starting values}
One can use empirical values for starting the chain (or specify your
own starting values) by initializing an object of class XdeParameter
and then specifying your own values for the first MCMC:

<<empiricalStart, eval=FALSE>>=
params <- new("XdeParameter", esetList=xlist, phenotypeLabel="adenoVsquamous", one.delta=FALSE)
empirical <- empiricalStart(xlist, phenotypeLabel="adenoVsquamous")
firstMcmc(params) <- empirical
@

To run a burnin of 3 iterations starting from the empircal values:

<<burnin, eval=FALSE>>=
iterations(params) <- 3
burnin(params) <- TRUE
fit <- xde(params, xlist)
@

Only the first and last iterations of the MCMC are available when
\texttt{burnin} is \texttt{TRUE}.  The output of the \Rfunction{xde}
is an object of class \xmcmc{}.  The object \texttt{fit} contains the
last iteration from the MCMC, as well as a different seed that can be
used for initiating the next chain.  For instance, to run two
additional iterations starting at the last iteration stored in the
\texttt{fit} object, one should provide the \Robject{params},
\Robject{xlist}, and \Robject{fit} objects to the \Rfunction{xde}
function:

<<moreIterations, eval=FALSE>>=
iterations(params) <- 2
fit2 <- xde(params, xlist, fit)
@

When an object of class \xmcmc{} is supplied as an argument to the
\Rfunction{xde} function, the seed and the last iteration from the
\Robject{fit} object are used to begin the next chain.  Note that
the results from the previous call to the \Rfunction{xde} would be
identical to the following sequence of commands:

<<firstMcmc, eval=FALSE>>=
firstMcmc(params) <- lastMcmc(fit)
seed(params) <- seed(fit)
fit2 <- xde(params, xlist)
@

One should run several thousand iterations (saving all parameters to
file) to monitor convergence.  In the following code chunk (not run)
we save only the chains for the parameters that are not indexed by
genes and/or study by setting the \texttt{output} for these parameters
to zero -- this step was taken to keep this package from becoming
unnecessarily large.  By setting the \texttt{thin} to 2, we only write
every other MCMC iteration to file.  In total, 1000 iterations are
saved.

<<runMoreIterations, eval=FALSE, echo=TRUE>>=
burnin(params) <- FALSE
iterations(params) <- 2000
output(params)[c("potential", "acceptance",
		 "diffExpressed",
		 "nu", ##"DDelta",
                 ##"delta",
		 "probDelta",
		 ##"sigma2",
		 "phi")] <- 0
thin(params) <- 2
directory(params) <- "logFiles"
xmcmc <- xde(params, xlist)
@

<<savexmcmc, eval=FALSE, echo=FALSE, results=hide>>=
##this function should work
postAvg <- calculatePosteriorAvg(xmcmc, NCONC=2, NDIFF=1)
save(postAvg, file="~/madman/Rpacks/XDE/inst/logFiles/postAvg.rda")
##put browser in .standardizedDelta to fix tau2R, ...
BES <- calculateBayesianEffectSize(xmcmc)
save(BES, file="~/madman/Rpacks/XDE/inst/logFiles/BES.rda")
save(xmcmc, file="~/madman/Rpacks/XDE/data/xmcmc.RData")
q("no")
@

See the \xparam{} vignette for a more detailed discussion of the
output, burnin, and thin methods.  The \Robject{xmcmc} object can be
loaded by:

<<loadObject, echo=FALSE, eval=TRUE>>=
data(xmcmc, package="XDE")
@

\section{\label{sec:mcmc} MCMC diagnostics}

In this section we briefly describe how to access the chains for
assessing convergence of the MCMC. We refer the \R user to the package
\Rpackage{coda} for more detailed discussion of MCMC diagnostics
\cite{Plummer2007}.

The following is a list of the chains that were saved in our run with
1000 saved iterations:
<<savedParams, eval=TRUE>>=
output(xmcmc)[2:22][output(xmcmc)[2:22] == 1]
@

The \$ operator can be used to read in log files.  First, we need to
update the \texttt{directory} slot in the \Robject{xmcmc} with a
character string indicating the path to the log files.  (Note that an
assignment method for directory is only available for \R{} object of
class \xmcmc{} -- typically one would not need to change the directory
in the \xmcmc{} object).  In the following code chunk, we extract the
chain for the $c^2$ parameter:

<<extractc2, eval=TRUE>>=
pathToLogFiles <- system.file("logFiles", package="XDE")
xmcmc@directory <- pathToLogFiles
c2 <- xmcmc$c2
@

<<c2, fig=TRUE, eval=TRUE>>=
par(las=1)
plot.ts(c2, ylab="c2", xlab="iterations", plot.type="single")
@

Here we extract only the parameters that are not indexed by gene and
platform (log files for parameters indexed by gene and platform are
typically very large):

<<retrieveLogs, results=hide>>=
getLogs <- function(object){
	params <- output(object)[output(object) == 1]
	params <- params[!(names(params) %in% c("nu", "phi", "DDelta", "delta", "sigma2", "diffExpressed"))]
	names(params)
}
param.names <- getLogs(xmcmc)
params <- lapply(lapply(as.list(param.names), function(name, object) eval(substitute(object$NAME_ARG, list(NAME_ARG=name))), object=xmcmc), as.ts)
names(params) <- param.names
tracefxn <- function(x, name)  plot(x, plot.type="single", col=1:ncol(x), ylab=name)
mapply(tracefxn, params, name=names(params))
@

\section{\label{sec:posterior} Posterior probabilities of differential expression}

We refer to the posterior mean of the standardized offsets in the
hierarchical model as the Bayesian effect size (BES).  The BES is
calculated as $\frac{\delta_g\Delta_{gp}}{c \tau \sigma^{b_p}}$ and
obtained by

<<bayesianEffectSize, eval=FALSE>>=
bayesianEffectSize(xmcmc) <- calculateBayesianEffectSize(xmcmc)
@

As the function \Rfunction{calculateBayesianEffectSize} requires that
the $\delta, \Delta$, and $\sigma^2$ chains are saved, the above code
chunk is not evaluated in this vignette.

<<bes, eval=TRUE>>=
load(file.path(pathToLogFiles, "BES.rda"))
load(file.path(pathToLogFiles, "postAvg.rda"))
@

Posterior averages for the probability of differential expression,
concordant differential expression, and discordant differential
expression are stored in the \Robject{postAvg} object.


See \cite{Scharpf2009} for a discussion of how the above posterior
average probabilities are computed.

<<postAvgFig_conc, echo=FALSE, fig=TRUE, eval=TRUE>>=
par(las=1)
hist(postAvg[, "concordant"], breaks=50, xlim=c(0, 1), main="",
     xlab="posterior probability of concordant differential expression")
@

<<postAvgFig_disc, echo=FALSE, fig=TRUE, eval=TRUE>>=
par(las=1)
hist(postAvg[, "discordant"], breaks=50, xlim=c(0, 1), main="",
     xlab="posterior probability of discordant differential expression")
@

We may wish to differentially label the study-specific statistics of
effect size that have high probabilities of concordant differential
expression.  To do this, we order the matrix of the BES so that the
genes with the highest posterior probabilities are plotted last.  The
function \Rfunction{symbolsInteresting} returns a list of graphical
options to \Rfunction{pairs}.

<<setPar, eval=TRUE>>=
op.conc <- symbolsInteresting(rankingStatistic=postAvg[, "concordant"])
op.disc <- symbolsInteresting(rankingStatistic=postAvg[, "discordant"])
@

<<conc, fig=TRUE, eval=TRUE>>=
par(las=1)
graphics:::pairs(BES[op.conc$order, ], pch=op.conc$pch, col=op.conc$col,
                 bg=op.conc$bg, upper.panel=NULL, cex=op.conc$cex)
@

or high probabilities of discordant differential expression

<<disc, fig=TRUE, eval=TRUE>>=
graphics:::pairs(BES[op.disc$order, ], pch=op.disc$pch, col=op.disc$col, bg=op.disc$bg,
		 upper.panel=NULL, cex=op.disc$cex)
@

\section{\label{sec:alternatives} Alternative cross-study summaries of differential expression}

Study-specific estimates of effect size, such as SAM or t-statistics,
can be useful to check the overall reproducibility between studies.
Again using pairwise scatterplots we plot t- and SAM-statistics using
different colors and plotting symbols for the genes that show high
posterior probabilities of concordant differential expression.

<<ssAlternatives, eval=FALSE>>=
##t <- ssStatistic(statistic="t", phenotypeLabel="adenoVsquamous", esetList=xlist)
tt <- rowttests(xlist, "adenoVsquamous", tstatOnly=TRUE)
if(require(siggenes)){
  sam <- ssStatistic(statistic="sam", phenotypeLabel="adenoVsquamous", esetList=xlist)
}
if(require(GeneMeta)){
  z <- ssStatistic(statistic="z", phenotypeLabel="adenoVsquamous", esetList=xlist)
}
@

<<tstatConc, eval=FALSE>>=
graphics:::pairs(tt[op.conc$order, ], pch=op.conc$pch, col=op.conc$col,
                 bg=op.conc$bg, upper.panel=NULL, cex=op.conc$cex)

@

<<zConc, eval=FALSE>>=
graphics:::pairs(tt[op.conc$order, ], pch=op.conc$pch, col=op.conc$col,
                 bg=op.conc$bg, upper.panel=NULL, cex=op.conc$cex)

@

<<tstatDisc, eval=FALSE>>=
graphics:::pairs(tt[op.disc$order, ], pch=op.disc$pch, col=op.disc$col,
                 bg=op.disc$bg, upper.panel=NULL, cex=op.disc$cex)
@

Uncorrelated $t$ and $SAM$ statistics suggest a low level of
reproducibility that may be attributable to technological differences
in the platforms, probes that align to different transcripts of the
same gene, or differences in the study populations. Low or
non-existing reproducibility may induce a wrong borrowing of strength
in the Bayesian model, whereby concordant differential expression is
seen as noise and shrunk to zero.  Hence, study-specific estimates of
t- and SAM-statistics may be helpful in deciding whether the Bayesian
model is likely to be beneficial.

If the correlation across studies is low, we suggest an unsupervised
approach to gene filtering, such as integrative correlation, to select
for genes that show some level of reproducibility across studies.  The
\R{} packages \Rpackage{MergeMaid} and \Rpackage{genefilter} may be
helpful.

For evaluating the overall differential expression, we follow the
discussion of Garrett-Mayer \citep{Garrett-Mayer2007}, and combine the
elements of single study statistics in a linear fashion to obtain a
statistic suitable for assessing differential expression.  For a more
detailed discussion of how these cross-study summaries were generated
for evaluating concordant and discordant differential expression, see
\cite{Scharpf2009}.

<<pca, eval=FALSE>>=
tScores <- xsScores(tt, N=nSamples(xlist))
samScores <- xsScores(sam, nSamples(xlist))
zScores <- xsScores(z[, match(names(xlist), colnames(z))], N=nSamples(xlist))
##Concordant differential expression, we use the combined score from the random effects model directly
zScores[, "concordant"] <- z[, "zSco"]
@

%\section{Assessing Goodness of Fit}


\section{Session Information}

The version number of \R{} and packages loaded for generating the
vignette were:

<<sessionInfo, echo=FALSE, results=tex>>=
toLatex(sessionInfo())
@

\bibliography{genomics}
\bibliographystyle{plain}

\end{document}

% \VignetteIndexEntry{XdeParameterClass Vignette}
% \VignetteKeywords{microarray, differential expression}
% \VignettePackage{XDE}
\documentclass{article}
\usepackage{amsmath}
\usepackage{graphicx}
\usepackage{natbib}
\usepackage{hyperref}
\usepackage[mathcal]{euscript}

\parindent 0in  % Left justify
\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}

\newcommand{\Rpackage}[1]{\textit{#1}}
\newcommand{\Rfunction}[1]{\texttt{#1}}
\newcommand{\Robject}[1]{\texttt{#1}}
\newcommand{\stan}{\texttt{Stanford}}
\newcommand{\xde}{\textit{XDE}}
\newcommand{\eset}{\Robject{ExpressionSet}}
\newcommand{\esets}{\Robject{ExpressionSet}s}
\newcommand{\esetList}{\Robject{ExpressionSetList}}
\newcommand{\esetLists}{\Robject{ExpressionSetList}s}
\newcommand{\xparam}{\Robject{XdeParameter}}
\newcommand{\xmcmc}{\Robject{XdeMcmc}}
\newcommand{\R}{\textsf{R}}
\newcommand{\bioc}{http://www.bioconductor.org}
\newcommand{\xdeVignette}{\xde{} vignette}
\textwidth=6.2in
\textheight=8.5in
\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in

\title{The \xparam{} Class}
\author{H\aa kon Tjelmeland and Robert B. Scharpf}

\begin{document}

\maketitle

<<echo=FALSE>>=
options(width=60)
@ 

\section{Introduction}

The goal of this vignette is to briefly describe the Bayesian
hierarchical model to estimate differential expression across multiple
studies.  This vignette necessarily assumes familiarity with
hierarchical models and Bayesian methods of computation, such as MCMC.
After reading this vignette, one should be able to:

\begin{itemize}
  
\item create an instance of the \xparam{} class that will provide all
  the necessary parameters for fitting the Bayesian model, including
  starting values of all the MCMC chains
  
\item change values from their default setting to custom setting. This
  includes
  
  \begin{itemize}
  \item changing the values of any of the hyperparameters
      
  \item changing the starting values of the MCMC chains
      
  \item change the number of updates per MCMC iteration for any of the
    parameters
      
  \item store all, some, or none of the MCMC chains
      
  \end{itemize}
    
\end{itemize}
  
Apart from these pragmatic goals, the vignette provides a means to
look-up the role of any parameters in our formulation of the Bayesian
model. A more detailed discussion of the Bayesian model is provided
elsewhere \cite{Scharpf2007d}.  If you are content with the default
settings provided when creating an instance of the \xparam{} class,
fitting the model, assessing convergence, and generating alternative
measures of differential expression are discussed in the
\xdeVignette{}.

\section{\label{sec:model} The Stochastic Model}

\newcommand{\bDelta}{\mbox{\boldmath $\Delta$}}
\newcommand{\bnu}{\mbox{\boldmath $\nu$}}
\newcommand{\bx}{\mbox{\boldmath $x$}}
\newcommand{\bpsi}{\mbox{\boldmath $\psi$}}

Let $x_{gsp}$ denote observed expression value for gene $g\in \{
1,\ldots,G\}$ and sample (array) $s\in \{ 1,\ldots,S_q\}$ in study $p
\in \{ 1,\ldots,P\}$, where $P\geq 2$. We assume that some clinical
variable (with two possible values) is available for each of the
arrays in all studies. We denote this by $\psi_{sp}\in\{ 0,1\}$ for
sample (array) number $s$ in study number $p$. We will assume that the
studies have been somehow standardized so that the values in each
study is centered around zero and are approximately Gaussian
distributed.

Our model defined below is based on the following assumptions, $(i)$
for some of the genes, the expression values $x_{gsp}$ are
differentially expressed (have different mean values) for arrays where
$\psi_{sp}=0$ and arrays where $\psi_{sp}=1$, and $(ii)$ any gene is
either differentially expresses in all studies or in no studies (the
``$\delta_g$'' model).  Assumption $(ii)$ can be relaxed by fitting
the ``$\delta_{gp}$'' model that allows for a given gene to be
differentially expressed in some studies but not in others.  The
following description of the Bayesian model is for the $\delta_g$"
model.  The $\delta_{gp}$ model is very similar, substituting
$\delta_{gp}$ for $\delta_g$ and independent beta priors with
parameter $\xi_p$ instead of $\xi$.

We assume the following hierarchical Bayesian model for the expression
data. Conditionally on underlying unobserved parameters we assume the
expression values to be independently Gaussian distributed,
\begin{equation}\label{x}
x_{gsp}|\ldots  \sim \mbox{N}(\nu_{gp} + \delta_g (2\psi_{sp} - 1)\Delta_{gp},
\sigma^2_{g\psi_{sp}p}),
\end{equation}
where $\delta_g\in \{ 0,1\}$ indicates whether gene $g$ is 
differentially expressed ($\delta_g=1$) or not ($\delta_g=0$).
Thus, if $\delta_g = 0$, the mean of $x_{gsp}$ is $\nu_{gp}$, 
whereas if $\delta_g=1$, the mean is $\nu_{gp}-\Delta_{gp}$ and
$\nu_{gp}+\Delta_{gp}$ for samples with $\psi_{sp}=0$ and $\psi_{sp}=1$,
respectively. 

Given hyper-parameters, we assume $\bnu_g = (\nu_{g1},\ldots,\nu_{gP})^T$ and 
$\bDelta_g = (\Delta_{g1},\ldots,\Delta_{gP})^T$ to be multi-Gaussian distributed,
\begin{equation}
\bnu_g |\ldots \sim \mbox{N}(0,\Sigma) \mbox{~~~~~and~~~~~}
\bDelta_g |\ldots \sim \mbox{N}(0,R),
\end{equation}
where $\Sigma = [\Sigma_{pq}]\in\Re^{P\times P}$ and
$R = [R_{pq}]\in\Re^{P\times P}$ with
\begin{equation}\label{Sigma}
\Sigma_{pq} = \gamma^2 \rho_{pq} \sqrt{ \tau_p^2 \tau_q^2 \sigma_{gp}^{2a_p} 
\sigma_{gq}^{2a_q}}
\end{equation}
and
\begin{equation}
R_{pq} = c^2 r_{pq} \sqrt{\tau_p^2 \tau_q^2 \sigma_{gp}^{2b_p}
\sigma_{gq}^{2b_q}}.
\end{equation}
The $a_p$ and $b_p, p=1,\ldots P$ are assumed apriori 
independent with discrete probabilities in $0$ and $1$ and a continuous density on $(0,1)$.
More precisely, we let
\begin{equation}
\mbox{P}(a_p = 0) = p_a^0 \mbox{~~~,~~~} \mbox{P}(a_p = 1) = p_a^1 \mbox{~~~,~~~}
a_p | a_p \in (0,1) \sim \mbox{Beta}(\alpha_a,\beta_a),
\end{equation}
and
\begin{equation}
\mbox{P}(b_p = 0) = p_b^0 \mbox{~~~,~~~} \mbox{P}(b_p = 1) = p_b^1 \mbox{~~~,~~~}
b_p | b_p \in (0,1) \sim \mbox{Beta}(\alpha_b,\beta_b).
\end{equation}
To $c^2$ we assign a uniform prior distribution on 
$[0,c^2_{\mbox{\tiny Max}}]$, where $c^2_{\mbox{\tiny Max}}$ is a parameter 
specified by the user, and for $\gamma^2$ we use an 
improper uniform distributions on $(0,\infty)$.
We restrict $\tau^2_p>0,p=1,\ldots,P$ and 
$\tau_1^2 \cdot \ldots \cdot \tau_P^2 = 1$ and assume an (improper) uniform 
distribution for $(\tau_1^2,\ldots,\tau_P^2)$ under this restriction.
The $[\rho_{pq}] \in \Re^{P\times P}$ and $[r_{pq}] \in \Re^{P\times P}$ are restricted to be 
correlation matrices and we assign apriori independent Barnard et al (2000) distributions for them,
with $\nu_\rho$ and $\nu_r$ degrees of freedom for $[\rho_{pq}]$ and $[r_{pq}]$, respectively.

We assume the indicators $\delta_1,\ldots,\delta_G$ to be apriori independent, given a 
hyper-parameter $\xi$, with
\begin{equation}
\mbox{P}(\delta_g = 1 | \xi ) = \xi, \mbox{~~~~~where~~~~~}
\xi \sim \mbox{Beta}(\alpha_\xi,\beta_\xi).
\end{equation}
We assume $\sigma^2_{gp}$ in (\ref{Sigma}) to be given from $\sigma^2_{g\psi p}$ in 
(\ref{x}) via the following relations
\begin{equation}
\sigma^2_{g0p} = \sigma^2_{gp} \varphi_{gp} \mbox{~~~~~and~~~~~}
\sigma^2_{g1p} = \frac{\sigma^2_{gp}} {\varphi_{gp}}.
\end{equation}
For $\sigma^2_{gp}$ we assume independent prior distributions, given hyper-parameters,
\begin{equation}
\sigma^2_{gp}|\ldots \sim \mbox{Gamma}\left(\frac{l_p^2}{t_p},\frac{l_p}{t_p}\right),
\end{equation}
where the mean $l_p$ and variance $t_p$ for $p=1,\ldots,P$ are assigned independent (improper) uniform
distributions on $(0,\infty)$.
The $\varphi_{gp}$ are assigned independent gamma priors, given hyper-parameters,
\begin{equation}
\varphi_{gp}|\ldots \sim \mbox{Gamma}\left(\frac{\lambda_p^2}{\theta_p},\frac{\lambda_p}{\theta_p}\right),
\end{equation}
where the mean $\lambda_p$ and the variance $\theta_p$ for $p=1,\ldots,P$ are assigned independent (improper) uniform
distributions on $(0,\infty)$.

\section{\label{sec:MH} Metropolis-Hastings algorithm}

To simulate from the posterior distribution resulting from the above
specified Bayesian model, we use a Metropolis--Hastings algorithm.
Default values for the tuning parameters in this algorithm and how
these tuning parameters may be modified are discussed in Section
\ref{sec:xparamClass}.  The Metropolis--Hastings algorithm uses the
following moves:

\begin{enumerate}
\item The $\nu_{pg}$'s are updated in a Gibbs step.
  
\item The $\Delta_{pg}$'s are updated in a Gibbs step.
  
\item \label{Proposal:a_p}Each $a_p,p=1,\ldots,P$ is updated in turn,
  where a potential new value for $a_p$, $\widetilde{a}_p$, is
  generated as follows. If $a_p = 0$, $\widetilde{a}_p \sim
  \mbox{Uniform}(0,\varepsilon)$, if $a_p = 1$, $\widetilde{a}_p \sim
  \mbox{Uniform}(1-\varepsilon,1)$, and if $a_p\in (0,1)$ we use
\begin{equation}
\mbox{P}(\widetilde{a}_p = 0) = \max\{ -(a_p - \varepsilon),0\} \cdot \mbox{I}(p_a^0 \neq 0),
\end{equation}
\begin{equation}
\mbox{P}(\widetilde{a}_p = 1) = \max\{ a_p + \varepsilon - 1,0\} \cdot \mbox{I}(p_a^1 \neq 0)
\end{equation}
and
\begin{equation}
\widetilde{a}_p |\widetilde{a}_p\in (0,1) \sim \mbox{Uniform}(\max\{a_p-\varepsilon,0\},
\min\{a_p+\varepsilon,1\}).
\end{equation}

\item Each $b_p,p=1,\ldots,P$ is updated in turn, where the proposal
  distribution is of the same type as in \ref{Proposal:a_p}. 
  
\item A block Gibbs update for $c^2$ and $\bDelta_g$ for $g$'s where
  $\delta_g=0$.
  
\item The $\gamma^2$ is updated in a Gibbs step.
  
\item \label{Proposal:r}A block update for the correlation matrix 
$[r_{pq}]$ and the variance $c^2$. First, potential 
new values for $[r_{pq}]$, $[\widetilde{r}_{pq}]$,
is set by
\begin{equation}
\widetilde{r}_{pq} = (1-\varepsilon) r_{pq} + \varepsilon T_{pq},
\end{equation}
where $[T_{pq}]$ is a correlation matrix which with probability a half
is generated from the prior for $[r_{pq}]$, or with probability a half
set equal to unity on the diagonal and with all off diagonal elements
set equal to the same value $b$. In the latter case, the value $b$ is
sampled from a uniform distribution on $(-1/(P-1),1)$. Second, the
potential new value for $c^2$ is sampled from the corresponding full
conditional (given the potential new values
$[\widetilde{r}_{pq}]$). The $\varepsilon$ is a tuning parameter.

\item A block update for the correlation matrix $[\rho_{pq}]$ and the
  variance $\gamma^2$. The potential new values are generated similar
  to what is done in \ref{Proposal:r}.  
  
\item For each $g=1,\ldots,G$ in turn, a block update for $\delta_g$
  and $\bDelta_g$. First, the potential new value for $\delta_g$ is
  set equal to $\widetilde{\delta}_g = 1 - \delta_g$. Second, the
  potential new value for $\bDelta_g$ is sampled from the full
  conditional (given the potential new value $\widetilde{\delta}_g$).
  No tuning parameter for this update.
  
\item The $\xi$ is updated in a Gibbs step.
  
\item \label{Proposal:sigma2}Each $\sigma^2_{gp}$ is updated in turn,
  where the potential new value is given as $\widetilde{\sigma}^2_{gp}
  = \sigma_{gp}^2 \cdot u$, where $u\sim
  \mbox{Uniform}(1/(1+\varepsilon),1+\varepsilon)$.  The $\varepsilon$
  is a tuning parameter.

\item \label{Proposal:t}Each $t_p,p=1,\ldots,P$ is updated in
  turn. The potential new value is given as $\widetilde{t}_p = t_p
  \cdot u$, where
  $u\sim\mbox{Uniform}(1/(1+\varepsilon),1+\varepsilon)$.  The
  $\varepsilon$ is a tuning parameter.

\item \label{Proposal:l}Each $l_p,p=1,\ldots,P$ is updated in
  turn. The potential new value is given as $\widetilde{l}_p = l_p
  \cdot u$, where
  $u\sim\mbox{Uniform}(1/(1+\varepsilon),1+\varepsilon)$.  The
  $\varepsilon$ is a tuning parameter.

\item Each $\varphi_{gp}$ is updated in turn, where the proposal
  distribution is of the same type as in \ref{Proposal:sigma2}.

\item Each $\theta_p,p=1,\ldots,P$ is updated in turn, where the
  proposal distribution is of the same type as in
  \ref{Proposal:t}. 

\item Each $\lambda_p,p=1,\ldots,P$ is updated in turn, where the
  proposal distribution is of the same type as in
  \ref{Proposal:l}. 

\item The $(\tau_1^2,\ldots,\tau_P^2)$ is updated by first uniformly
  at random drawing a pair $p,q\in \{1,\ldots,P\}$ so that $p\neq
  q$. Potential new values for $\tau_p^2$ and $\tau_q^2$ are generated
  by setting
\begin{equation}
\widetilde{\tau}_p^2 = \tau_p^2 \cdot u \mbox{~~~~and~~~~}
\widetilde{\tau}_q^2 = \tau_q^2 / u,
\end{equation}
where $u \sim \mbox{Uniform}(1/(1+\varepsilon),1+\varepsilon)$. The
$\varepsilon$ is again a tuning parameter.


\end{enumerate}

\section{\label{sec:xparamClass} The \xparam{} class}

The Bayesian hierarchical model can be tuned and output modified in a
number of ways. The \xparam{} class is an effort to organize these
options and to facilitate tweaking.  In our experience, it is easier
to change and keep track of the parameters in the class than to
provide a function for fitting the model with numerous arguments.  The
\xparam{} class is not a container for the gene expression data (see
\esetList{} in the \xdeVignette{}).

\subsection{Initializing the \xparam{} class}

There are numerous options for customizing the fit of the Bayesian
model as well as the output.  Default values are defined in the
initialization method for the \xparam{} class.  Initialization
requires an object of class \esetList{} and the name of the
classification variable used to define differential expression.  (The
initialization method will produce an error if the supplied
phenotypeLabel is not present in the \Robject{varLabel}s of each
element of the \esetList{}).  Using the example dataset discussed in
the \xdeVignette{}, we have defined the covariate ``adenoVsquamous''
that takes the value 0 for adenocarcinomas and 1 for squamous
carcinomas. The \Rfunction{show} method only lists the first few
parameters in each slot of the \xparam{} object.

<<params>>=
library(XDE)
data(expressionSetList)
xlist <- expressionSetList
params <- new("XdeParameter", esetList=xlist, phenotypeLabel="adenoVsquamous")
params
@

\subsection{Starting values for MCMC chains}

A complete listing of initial values for the MCMC can be obtained by

<<firstMcmc>>=
initialValues <- firstMcmc(params)
str(initialValues)
@ 

The initial values of the MCMC chains stored in \texttt{firstMcmc} are
generated by random sampling from the prior distributions for these
parameters.  One may replace any one of the named elements in this
list with different starting values.  At this time, we do not provide
checks that the replacement vectors are of the appropriate length.
WARNING: providing a replacement vector of the incorrect length may
cause the MCMC algorithm to crash without warning.  Note that
specifiedInitialValues in the \xparam{} object is always
\Robject{TRUE} as the values created here are the initial values used
to run the MCMC, regardless of the starting values were explicitly
defined or simulated from the priors.

<<specifiedInitialValues>>=
params@specifiedInitialValues
@ 
\noindent If one were to change \Robject{specifiedInitialValues} to
\Robject{FALSE}, the MCMC would begin at a different set of initial
values drawn from the prior and not the values provided in the
\xparam{} class.

\subsection{Hyper-parameters}

When initializing \xparam for three studies as we are here, the
default values for the hyper-parameters are as follows:

<<hyperparameters>>=
hyperparameters(params)
@ 

The names used in the software implementation that correspond to the
notation used in Section \ref{sec:model} are as follows:

\[
\begin{array}{rl}
  \mbox{hyperparameter} & \mbox{\xde{} name} \\  \hline 
  \alpha_a & \mbox{alpha.a} \\
  \beta_a  & \mbox{beta.a} \\
  p^0_a    & \mbox{p0.a} \\
  p^1_a    & \mbox{p1.a} \\
  \alpha_b & \mbox{alpha.b} \\
  \beta_b  & \mbox{beta.b}  \\ 
  p^0_b    & \mbox{p0.b} \\
  p^1_b    & \mbox{p1.b} \\
  \nu_r    & \mbox{nu.r} \\
  \nu_{\rho} & \mbox{nu.rho} \\
  \alpha_{\xi} & \mbox{alpha.xi} \\
  \beta_{\xi}  & \mbox{beta.xi} \\
  c^2_{\mbox{max}} & \mbox{c2max}
\end{array}
\]

In situations in which there is no signal (all noise), the
$c^2_{\mbox{max}}$ is provided as a precaution to avoid sampling from
infinity. However, in simulations of complete noise, the
$c^2_{\mbox{max}}$ parameter was not generally needed and remains in
the present model primarily for debugging purposes.  Modification of
any of the above hyperparameters can be performed in the usual way:

<<hyperparamReplace, eval=FALSE>>=
hyperparameters(params)["alpha.a"] <- 1
@ 

\subsection{Tuning parameters for Metropolis-Hastings proposals}

A default $\epsilon$ for each of the Metropolis-Hastings proposals
discussed in Section \ref{sec:MH} is created when initializing the
\xparam{} class.  See

<<tuning>>=
tuning(params)
@ 

for a named vector of the default values. A replacement method has
been defined to facilitate the tuning of the proposals.  To
illustrate, the $\epsilon$ used in the proposal for the parameter $a$
(the power conjugate parameter for $\nu$) could be adjusted by the
following command:

<<changeEpsilon>>=
tuning(params)["a"] <- tuning(params)["a"]*0.5
@ 

\subsection{\label{sec:updates} Frequency of updates for each MCMC iteration}

One may control the frequency at which any of the parameters described
in Section \ref{sec:MH} are updated at each iteration of the MCMC
through the method \Robject{updates}.  See

<<updates>>=
updates(params)
@ 

Specifying zero updates forces a parameter to remain at its initial
value.  For instance, one may impose conjugacy between location and
scale by initializing the power conjugate parameter, $b$, to 1 and
changing the number of updates per MCMC iteration to zero:

<<conjugacy, eval=FALSE>>=
firstMcmc(params)$B <- rep(1,3)
updates(params)["b"] <- 0
@ 

Alternatively, one could force independence of location and scale by
setting $b$ to zero:

<<independence, eval=FALSE>>=
firstMcmc(params)$B <- rep(0, 3)
updates(params)["b"] <- 0
@ 

By default, $b$ is allowed to vary between zero and 1.  Block updates
are denoted by 'And'.  For instance, $r$ and $c^2$ are updated as a
block (as described above).  Therefore, to update the $r$ parameter 3
times per MCMC iteration, one would use the command
<<blockUpdates, eval=FALSE>>=
updates(params)["rAndC2"] <- 3
@ 

\subsection{MCMC output}

\xde{} provides options to save all, some, or none of the chains
produced by MCMC.  Options for writing MCMC chains to file are
provided in the \Robject{output} slot of the \xparam class.

<<output>>=
output(params)
@ 

The first value, thin, tells the MCMC algorithm how often to write the
chain to file.  For instance, if thin is two every other iteration is
written to file.  The remaining numbers in the output vector are
either zero (nothing is written to file) or one.  If the output is
one, the simulated value from the current iteration is added to the
log file.  The log files are plain text files and are by default
stored in the current working directory.  One may change the location
of where to store the log files by providing a different path

<<differentPath, eval=FALSE>>=
directory(params) <- "logFiles"
@ 

If the directory ``logFiles'' does not exist, the above replacement
method for directory will automatically create the directory. In
general, directory should provide the path relative to the current
working directory or the complete path to the desired directory.

An additional slot in the \xparam class that may be useful is
\texttt{burnin}.  By default, \texttt{burnin} is \texttt{TRUE} and no
chains are written to file.  One reason for this setting as a default
is to easily check whether the \xde{} model will run with the default
values without producing voluminous output in the MCMC chains.  For
instance, we often set

<<burnin>>=
burnin(params) <- TRUE
iterations(params) <- 5
@ 

Note the following behavior of the replacement method for burnin:
<<burnin2>>=
output(params)[2:22] <- rep(1, 21)
output(params)
burnin(params) <- TRUE
output(params)
@ 
Hence, when setting burnin to \texttt{TRUE} we assume that none of the
iterations are to be saved.  Similarly, when setting \texttt{burnin}
to FALSE, we assume that one wishes to save all of the parameters:
<<burnin3>>=
##Specify a thin of 1 and save none of the parameters
output(params)[2:22] <- rep(0, 21)
output(params)
burnin(params) <- FALSE
output(params)
@ 

To save a subset of the parameters, we recommend setting the \texttt{burnin} argument to \texttt{FALSE} and turning off the parameters that one does not wish to save.  Warning: the parameters $\Delta_{gp}, \delta_{g}, \mbox{probDelta}_g, \sigma_{gp}^2, \nu_{gp}, \phi_{gp}$ are all indexed by genes and/or study and may therefore require a large amount of memory to save.  Use the following commands  to avoid writing these chains to file:

<<doNotSaveHugeChains>>=
burnin(params) <- FALSE
output(params)[c("nu", "DDelta", "delta", "probDelta", "sigma2", "phi")] <- 0
output(params)
@ 

\section{Session Information}

The version number of \R{} and packages loaded for generating the
vignette were:

<<echo=FALSE, results=tex>>=
toLatex(sessionInfo())
@ 

\bibliography{genomics}
\bibliographystyle{plain}

\end{document}

\name{lastMcmc}
\alias{lastMcmc}
\alias{lastMcmc<-}
\title{MCMC values for the last iteration}
\description{
  MCMC values for the last iteration.  Useful if more iterations are needed. 
}

\usage{
  lastMcmc(object)
}

\arguments{
  \item{object}{Object of class \code{XdeMcmc}}
}

\value{
  An environment.
}

\author{R. Scharpf}

\seealso{\code{\link{firstMcmc}}}

\examples{
  \dontrun{
    data(expressionSetList)
    xparam <- new("XdeParameter", phenotypeLabel="adenoVsquamous",
                  esetList=expressionSetList)
    iterations(xparam) <- 10  
    fit <- xde(xparam, esetList=expressionSetList)
    ##Do more iterations and use a different seed
    firstMcmc(xparam) <- lastMcmc(fit)
    seed(xparam) <- 97814
    fit2 <- xde(xparam, esetList=expressionSetList)

    ##Or
    fit2 <- xde(xparam, esetList=expressionSetList, outputMcmc=fit)
  }
}
\keyword{methods}

\name{XdeParameter-class}
\docType{class}
\alias{XdeParameter-class}
\alias{burnin,XdeParameter-method}
\alias{burnin<-,XdeParameter,logical-method}
\alias{coerce,XdeParameter,Params-method}
\alias{directory,XdeParameter-method}
\alias{directory<-}
\alias{directory<-,XdeParameter-method}
\alias{firstMcmc,XdeParameter-method}
\alias{firstMcmc<-,XdeParameter,environment-method}
\alias{firstMcmc<-,XdeParameter,list-method}
\alias{hyperparameters,XdeParameter-method}
\alias{hyperparameters<-,XdeParameter-method}
\alias{initialize,XdeParameter-method}
\alias{iterations,XdeParameter-method}
\alias{iterations<-,XdeParameter,numeric-method}
\alias{iterations<-,XdeParameter,integer-method}
\alias{output,XdeParameter-method}
\alias{output<-,XdeParameter-method}
\alias{phenotypeLabel}
\alias{phenotypeLabel<-}
\alias{phenotypeLabel,XdeParameter-method}
\alias{phenotypeLabel<-,XdeParameter,character-method}
\alias{savedIterations}
\alias{savedIterations,XdeParameter-method}
\alias{seed,XdeParameter-method}
\alias{seed<-,XdeParameter,integer-method}
\alias{seed<-,XdeParameter,numeric-method}
\alias{show,XdeParameter-method}
\alias{showIterations}
\alias{showIterations<-}
\alias{showIterations,XdeParameter-method}
\alias{showIterations<-,XdeParameter-method}
\alias{studyNames}
\alias{studyNames<-}
\alias{studyNames,XdeParameter-method}
\alias{studyNames<-,XdeParameter-method}
\alias{thin,XdeParameter-method}
\alias{thin<-,XdeParameter,numeric-method}
\alias{tuning,XdeParameter-method}
\alias{tuning<-,XdeParameter-method}
\alias{updates,XdeParameter-method}
\alias{updates<-,XdeParameter-method}

\title{Container class for storing options of the Bayesian hierarchical model}
\description{This class contains initial values for the first iteration
  of the MCMC, options for saving MCMC chains, options for changing the
  tuning parameters of the Metropolis-Hastings algorithm, options for
  changing hyperparameters from their defaults, etc.}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("XdeParameter",
  esetList, updates, tuning, hyperparameters, output, iterations,
  burnin, seed, randomSeed, genes, studies, firstMcmc,
  specifiedInitialValues, directory, phenotypeLabel, seed, showIterations,
  verbose, studyNames, one.delta)}.
}
\section{Slots}{
	 \describe{
    \item{\code{updates}:}{Object of class \code{numeric}. The frequency
    of  updates for each iteration of the chain.}
    \item{\code{tuning}:}{Object of class \code{numeric}.  Tuning
      parameters for the Metropolis-Hastings proposals }
    \item{\code{hyperparameters}:}{Object of class
      \code{numeric}. Hyperparameters for the Bayesian hierarchical model}
    \item{\code{output}:}{Object of class \code{numeric}. Indicator for
      whether to save the MCMC chain to file.  If the value is zero, the
    chain is not saved.}
    \item{\code{iterations}:}{Object of class \code{numeric}.  The total
    number of MCMC iterations.}
    \item{\code{burnin}:}{Object of class \code{logical}.  If set to
      FALSE, by default none of the chains will be saved (called for its
      side-effect of setting the output to zero for each parameter).}

    \item{\code{notes}:}{Object of class \code{character}. }
    \item{\code{firstMcmc}:}{Object of class \code{environment}. Values
      for the first iteration of the MCMC }
    \item{\code{seed}:}{Object of class \code{integer}.  Seed used for
    simulating random numbers.}
    \item{\code{showIterations}:}{Object of class \code{logical}.
      Whether to show the MCMC iteration when fitting the model}
    \item{\code{specifiedInitialValues}:}{Object of class
      \code{logical}.  If TRUE (the default), the values stored in
      \code{firstMcmc} will be used for the first iteration of the MCMC. }
    \item{\code{directory}:}{Object of class \code{character}. Specifies
    where to write the log files}
    \item{\code{phenotypeLabel}:}{Object of class \code{character}. The
      name of the binary covariate used for differential expression }
    \item{\code{verbose}:}{Object of class \code{logical} }
    \item{\code{studyNames}:}{Object of class \code{character}. Names of
      the datasets}
    \item{\code{one.delta}:}{Logical.  If TRUE, a gene is assumed to be
      differentially in all studies or none of the studies.}
  }
}
\section{Methods}{
  \describe{
    \item{burnin}{\code{signature(object = "XdeParameter")} logical.
      See \code{\link{burnin}}}
    \item{burnin<-}{\code{signature(object = "XdeParameter", value =
	"logical")} logical. See \code{\link{burnin}}}
    \item{directory}{\code{signature(object = "XdeParameter")} character
    string giving the path or relative path to store log files from the
    MCMC chain}
    \item{directory<-}{\code{signature(object = "XdeParameter")}Path to
      store log files. }
    \item{firstMcmc}{\code{signature(object = "XdeParameter")} See \code{\link{firstMcmc}}}
    \item{firstMcmc<-}{\code{signature(object = "XdeParameter", value = "environment")} }
    \item{firstMcmc<-}{\code{signature(object = "XdeParameter", value = "list")} }
    \item{hyperparameters}{\code{signature(object = "XdeParameter")} See
    the XdeParameterClass vignette}
    \item{hyperparameters<-}{\code{signature(object = "XdeParameter")} See
    the XdeParameterClass vignette}
    \item{initialize}{\code{signature(.Object = "XdeParameter")} Method
      for initializing an instance of the class.  The default values
      provided work well in most cases.}
    \item{iterations}{\code{signature(object = "XdeParameter")} Accessor
      for the total number of MCMC iterations to run}
    \item{iterations<-}{\code{signature(object = "XdeParameter", value =
	numeric)} The replacement method is useful for setting a
      different number of iterations.}
    \item{iterations<-}{\code{signature(object = "XdeParameter", value = "integer")} }
    \item{output}{\code{signature(object = "XdeParameter")} See also
      \code{\link{output}}. This method is also defined for class \code{XdeMcmc}}
    \item{output<-}{\code{signature(object = "XdeParameter")} See also \code{\link{output}} }
    \item{phenotypeLabel}{\code{signature(object = "XdeParameter")}
      The name of a binary covariate present in each study}
    \item{phenotypeLabel<-}{\code{signature(object = "XdeParameter", value = "character")} }
    \item{savedIterations}{\code{signature(object = "XdeParameter")} The
    number of MCMC iterations written to file.  It is the value of the
    total number of iterations divided by the thinning parameter.  See
    also \code{\link{output}}}
    \item{seed}{\code{signature(object = "XdeParameter")} See
      \code{\link{seed}}}
    \item{seed<-}{\code{signature(object = "XdeParameter",
    value="integer")} Replacement method. See also \code{\link{seed}}.}
    \item{show}{\code{signature(object = "XdeParameter")} Produces a
      short summary of objects that are instances of the
      \code{XdeParameter} class}
    \item{showIterations}{\code{signature(object = "XdeParameter")} logical}
    \item{showIterations<-}{\code{signature(object = "XdeParameter")} }
    \item{studyNames}{\code{signature(object = "XdeParameter")} Names of
    the high-throughput gene expression studies}
    \item{studyNames<-}{\code{signature(object = "XdeParameter")} }
    \item{thin}{\code{signature(x = "XdeParameter")} See
      \code{\link{output}} and \code{\link{thin}}}
    \item{thin<-}{\code{signature(x = "XdeParameter", value = numeric)}
      See \code{\link{thin}}}
    \item{tuning}{\code{signature(object = "XdeParameter")} See also \code{\link{tuning}}}
    \item{tuning<-}{\code{signature(object = "XdeParameter")} }
    \item{updates}{\code{signature(object = "XdeParameter")} See also \code{\link{updates}}}
    \item{updates<-}{\code{signature(object = "XdeParameter")} }
  }
}
\references{R. Scharpf}
\author{R. Scharpf}

\seealso{
  \code{\link{ExpressionSetList-class}}
}
\examples{
showClass("XdeParameter")
##See the XdeParameterClass vignette
}
\keyword{classes}

\name{symbolsInteresting}
\alias{symbolsInteresting}
\title{Useful for changing the look of pairs plots to emphasize
  concordant or discordant genes}
\description{

  This function can be used to order genes in a matrix by the rank of a
  statistic and provide different plotting symbols and colors for genes
  that exceed a certain threshold of the ranking statistic.
  
}

\usage{
symbolsInteresting(rankingStatistic, percentile = 0.9,
                   colors = c("grey50", "royalblue"),
                   symbols = c(".", "o"), size = c(3, 1),
                   background = c("white", "grey70"))
}
\arguments{
  \item{rankingStatistic}{ Any numerical vector }
  \item{percentile}{A percentile of the rankingStatistic -- above which
    a gene would be classified as 'interesting'}
  \item{colors}{character string of length 2: a color for genes not exceeding the
    percentile and a color for genes exceeding the thresold}
  \item{symbols}{two plotting symbols (numeric or character): symbol for
  genes not exceeding percentile and symbol for genes exceeding percentile}
  \item{size}{numeric vector of length 2: size of plotting symbol for genes not exceeding
    percentile and size of plotting symbol for genes exceeding percentile }
  \item{background}{character vector of length 2: background color of
    plotting symbols for gene not exceeding percentile and for genes
    exceeding the percentile}
}
\value{
  \item{order}{the order of the rankingStatistic}
  \item{pch}{plotting symbols (same length as rankingStatistic)}
  \item{col}{color of plotting symbols (same length as
    rankingStatistic)}
  \item{bg}{background color of plotting symbols (same length as
    rankingStatistic)}
  \item{cex}{size of plotting symbols (same length as
    rankingStatistic)}  
}
\author{R. Scharpf}
\examples{

  data(expressionSetList)
  data(xmcmc)
  pathToLogFiles <- system.file("logFiles", package="XDE")
  load(file.path(pathToLogFiles, "BES.rda"))
  load(file.path(pathToLogFiles, "postAvg.rda"))
  op.conc <- symbolsInteresting(rankingStatistic=postAvg[, "concordant"])
  graphics:::pairs(BES[op.conc$order, ], pch=op.conc$pch, col=op.conc$col, 
                   bg=op.conc$bg, upper.panel=NULL, cex=op.conc$cex)  

}
\keyword{dplot}

\name{burnin}
\alias{burnin}
\alias{burnin<-}
\title{Indicator for running a MCMC burnin}
\description{
  When \code{TRUE}, log files from MCMC chains are not written to file.
  When \code{FALSE}, log files are written for every parameter by default.
}
\usage{
burnin(object)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{ An object of class \code{XdeParameter} }
}

\value{
  logical
}
\author{R. Scharpf}
\seealso{\code{\link{XdeParameter-class}}}
\examples{
\dontrun{
data(expressionSetList)
params <- new("XdeParameter", phenotypeLabel="adenoVsquamous",
              esetList=expressionSetList)

##the replacement method for burnin is called for its side effect of
##providing default values of storing MCMC chains
output(params)[2:22]
burnin(params) <- FALSE
output(params)[2:22]
burnin(params) <- TRUE
output(params)[2:22]
}
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{methods}

\name{xmcmc}
\alias{xmcmc}
\docType{data}
\title{Object of class XdeMcmc}
\description{
  An object of class XdeMcmc is created by fitting the Bayesian
  hierarchical model to the \code{expressionSetList} example data.
}
\usage{data(xmcmc)}

\details{
  The \code{xmcmc} data example was obtained as described in the
  XDE vignette.
}

\examples{

data(xmcmc)
xmcmc

##ordinarily, one should not need to change the directory in an object
##of class XdeMcmc -- therefore, a replacment method is not defined
pathToLogFiles <- system.file("logFiles", package="XDE")
xmcmc@directory <- pathToLogFiles

##The $ operator can be used to extract chains. For instance, here we
##extract the c2 chain
c2 <- xmcmc$c2
plot.ts(c2)
}
\keyword{datasets}

\name{seed}
\alias{seed}
\alias{seed<-}
\title{Seed for the MCMC}
\description{
  Setting a seed is useful for reproducing MCMC chains
}
\usage{
seed(object)
seed(object) <- value
}
\arguments{
  \item{object}{ An object of \code{XdeParameter} or \code{XdeMcmc} }
  \item{value}{Numeric or integer}
}
\details{
  
  The seed stored in the slot of an object of class \code{XdeParameter}
  and an object of class \code{XdeMcmc} are useful in different ways.
  For the \code{XdeParameter} class, the seed indicates what seed was
  used to initialize an MCMC chain.  By contrast, an object of class
  \code{XdeMcmc} contains a seed that would be useful for running
  additional iterations -- the seed here is guaranteed to be different
  from the seed that was used to initiate the MCMC.
  
}
\value{
  An integer
}
\author{R. Scharpf}
\keyword{methods}

\name{geneCenter}
\alias{geneCenter}
\title{Center the expression values for each gene in a study to zero}
\description{
  Mean centers the genes for each study in a list
}
\usage{
geneCenter(object)
}
\arguments{
  \item{object}{ Object of class \code{ExpressionSetList}}
}
\value{
  Object of class \code{ExpressionSetList}
}
\author{R. Scharpf}
\seealso{ \code{\link{studyCenter}}, \code{\link{ExpressionSetList-class}}}

\examples{
  data(expressionSetList)
  centered <- geneCenter(expressionSetList)
}
\keyword{methods}

\name{empiricalStart}
\alias{empiricalStart}
\title{Empirical starting values for the MCMC}
\description{
  Empirical starting values for the MCMC are based on data in objects of
  class \code{ExpressionSetList} 
}
\usage{
empiricalStart(object, zeroNu = FALSE, phenotypeLabel, one.delta=FALSE, T_THRESH=4)
}
\arguments{
  \item{object}{An object of class \code{ExpressionSetList}}
  \item{zeroNu}{Logical: if TRUE, the nu in the Bayesian model are not
    modeled -- set to zero and not updated in the MCMC.  Setting zeroNu
    to TRUE should be regarded as experimental}
  \item{phenotypeLabel}{character: binary phenotype.  phenotypeLabel
    must be in the varLabels of each ExpressionSet object}
  
  \item{one.delta}{delta in the Bayesian model is a gene-specific
    indicator for differential expression.  If one.delta is FALSE, we
    assume that a gene can be differentially expressed in a subset of
    studies.  When TRUE, we assume that a gene is differentially
    expressed in all studies or in none.}
  
  \item{T_THRESH}{A threshold of t-statistics (calculated row-wise for
    each study) for determining starting values of the differential
    expression indicator, delta.}
}

\value{

  A list containing starting values for the MCMC that are derived from
  empirical estimates of the data.  
  
}
\author{R. Scharpf}

\seealso{ \code{\link{zeroNu}}, \code{\link{XdeParameter-class}},
  \code{\link{ExpressionSetList-class}}}

\examples{
library(XDE)
data(expressionSetList)
eList <- studyCenter(expressionSetList)
empirical <- empiricalStart(eList, phenotypeLabel="adenoVsquamous", T_THRESH=3)
##By default, initial values for the MCMC are sampled from the prior
##when initializing an object of class XdeParamater
params <- new("XdeParameter", esetList=eList,
	      phenotypeLabel="adenoVsquamous", one.delta=FALSE, burnin=TRUE)
##The initial values can be replaced by empirical values as follows:
firstMcmc(params) <- empirical
}


\keyword{methods}

\name{xsScores}
\alias{xsScores}
\title{Alternative cross-study scores of differential expression}

\description{
  Alternative cross-study scores of differential expression
}

\usage{
xsScores(statistic, N)
}

\arguments{
  \item{statistic}{a matrix of study-specific estimates of effect size.
  Rows are genes and columns are studies.}
  \item{N}{numerical vector: the number of samples in each study (the
    length should be the number of columns in \code{statistic})}
}

\value{

  A matrix of cross-study scores for differential expression
  ("diffExpressed"), concordant differential expression, and discordant
  differential expression.
  
}

\references{

  J.K. Choi, U. Yu, S. Kim, and O.J. Yoo (2003), Combining multiple
  microarray studies and modeling interstudy variation, Bioinformatics,
  19(1) I84-I90.  

  E. Garrett-Mayer, G. Parmigiani, X. Zhong, L. Cope, and E. Gabrielson
	(2007), Cross-study validation and combined analysis of gene
	expression microarray data, Biostatistics, September

  R. Scharpf et al., A Bayesian Model for Cross-Study Differential Gene
  Expression, Technical Report 158, Johns Hopkins University, Department
  of Biostatistics, 2007

}

\author{R. Scharpf}

\seealso{the GeneMeta package, \code{\link{ssStatistic}}}

\examples{
  data(expressionSetList)
  t <- ssStatistic(statistic="t", phenotypeLabel="adenoVsquamous", esetList=expressionSetList)
  tScores <- xsScores(t, N=nSamples(expressionSetList))
}
  
\keyword{htest}
\keyword{models}

\name{tuning}
\alias{tuning}
\alias{tuning<-}
\title{Tuning parameters for Metropolis-Hastings proposals}
\description{
  Accessor and replacement methods for tuning the Metropolis-Hastings
  proposal parameters.
}
\usage{
tuning(object)
}
\arguments{
  \item{object}{ Object of class \code{XdeParameter} }
}
\details{
  See the XdeParameterClass vignette
}
\value{
  A numerical vector
}
\author{R. Scharpf}
\keyword{methods}

\name{calculatePosteriorAvg}
\alias{calculatePosteriorAvg}
\title{Calculate the posterior average for indicators of concordant and
  discordant differential expression}

\description{
  
  This function calculates the posterior average for indicators of concordant and
  discordant differential expression from the saved log files. See details.  
  
}

\usage{
calculatePosteriorAvg(object, NCONC=2, NDIFF=1, burnin=0)
}

\arguments{
  \item{object}{ Object of class \code{XdeMcmc}}
  \item{NCONC}{Integer: number of studies for which the gene must be
    differentially expressed (in the same direction) to be classified as
  concordant differential expression}
  \item{NDIFF}{Integer: number of studies for which a gene must be
    up- or down-regulated to be classified as differentially expressed.
    It is the union of concordant and discordant differential
    expression.}
  \item{burnin}{Integer: number of MCMC iterations for the burnin. Posterior means
  are computed from the MCMC samples following burnin.}
}
\details{

 For each iteration,

1.  calculate the sign of delta * Delta
 
2.  For each gene, compute the number of positive signs (P) and the
number of negative signs (N) (a G x 2 matrix, where G is the number of
genes in common across all studies).  P + N is <= S, where S is the
number of studies.

3.  for a given gene, the discordant indicator is simply when P * N
is nonzero.

4.  The concordant indicator requires P * N = 0 AND P + N >=
NCONC, where NCONC is specified by the user.

5.  differential expression is simply   | P | + | N |  >= NDIFF.  By
default, NDIFF is 1 but can be user-specified.

The posterior average is then computed from the mean over all MCMC iterations.

}

\value{
  
  A G x 3 matrix.
  
}

\author{RS}
\seealso{\code{\link{posteriorAvg}}}
\keyword{manip}

\name{updates}
\alias{updates}
\alias{updates<-}
\title{Frequency of updating a parameter per MCMC iteration}
\description{
  
  Accessor and replacement methods for the class \code{XdeParameter} are
  available.  Specifying an update of integer N for a
  Metropolis-Hastings parameter means that N values are proposed for
  that parameter for each MCMC iteration.
}
\usage{
updates(object)
}

\arguments{
  \item{object}{ An object of class \code{XdeParameter} }
}
\details{
  See the XdeParameterClass vignette
}
\value{
  A numerical vector
}
\author{R. Scharpf}
\keyword{methods}

\name{posteriorAvg}
\alias{posteriorAvg}
\alias{posteriorAvg<-}
\title{Accessor and replacement methods for posterior averages of
  differential expression}
\description{

  Accessor and replacement methods for objects of class \code{XdeMcmc}
  for posterior averages of differential expression

}
\usage{
posteriorAvg(object)
posteriorAvg(object) <- value
}
\arguments{
  \item{object}{Object of class \code{XdeMcmc}}
  \item{value}{A matrix of dimension G x 3, where G is the number of
    genes and 3 are different ways of quantifying differential
    expression in the context of multiple studies (concordant,
    discordant, or the union).}
}
  
\value{

  A matrix of dimension G x 3, where G is the number of genes and 3 are
    different ways of quantifying differential expression in the context
    of multiple studies (concordant, discordant, or the union).
  
}
\author{RS}
\seealso{\code{\link{calculatePosteriorAvg}}}
\keyword{methods}

\name{zeroNu}
\alias{zeroNu}
\title{Option for not modeling Nu}

\description{
  Nu is the average expression value in each study.
}

\usage{
zeroNu(object, ...)
}

\arguments{
  \item{object}{object of class \code{ExpressionSetList}}
  \item{\dots}{ Not implemented}
}

\details{

  This function should be regarded as experimental.

  The nu parameter models the average expression value in each
  study. Modeling nu allows one to estimate differential expression
  across studies that may differ in location and scale (as often occurs
  when multiple platforms are used).  The price to pay for modeling nu
  are additional assumptions (the nu\'s are assumed Gaussian) and a more
  heavily parameterized model.

  The method zeroNu allows one to fit the Bayesian model without
  estimating nu:

  - each gene is centered at zero

  - initial values for the first MCMC are chosen on the basis of
  empirical starting values

  - the initial values for a and rho are set to zero.

  - the nu, a, gamma2, and rho parameters are not updated during MCMC

}

\value{

  object of class \code{XdeParameter}
  
}

\references{

    R. Scharpf et al. (2007), A Bayesian Model for Cross-Study Differential
  Gene Expression, Technical Report 158, Johns Hopkins University,
  Department of Biostatistics
  
}

\author{R. Scharpf}
\keyword{methods}

\name{pairs-methods}
\docType{methods}
\alias{pairs-methods}
\alias{pairs,matrix-method}
\alias{pairs,data.frame-method}
\title{pairs function for high-throughput data}

\description{

  A convenient wrapper for pairs that uses smoothScatter to plot the
  density of the points and displays the spearman correlation
  coefficient of the pairwise scatterplots.

}
\section{Methods}{
\describe{

\item{x = "matrix"}{ Typically a matrix of effect size estimates
  obtained in each study.  Rows are genes, columns are studies.}

\item{x = "data.frame"}{Typically a \code{data.frame} of effect size
  estimates obtained in each study.  Rows are genes, columns are studies.}
}
}
\keyword{methods}
\keyword{hplot}

\name{firstMcmc}
\alias{firstMcmc}
\alias{firstMcmc<-}
\title{Values for the first MCMC iteration}
\description{
  Accessor method for the values of the first MCMC iteration
}
\usage{
firstMcmc(object)
}
\arguments{
  \item{object}{ An object of class \code{XdeParameter} }
}
\value{
  Returns a list of the values to be used in the first iteration of the
  MCMC.
}
\author{R. Scharpf}
\seealso{\code{\link{XdeParameter-class}}, \code{\link{lastMcmc}}}
\examples{
data(expressionSetList)
params <- new("XdeParameter", phenotypeLabel="adenoVsquamous",
              esetList=expressionSetList)
str(firstMcmc(params))
}
\keyword{methods}

\name{thin}
\alias{thin}
\alias{thin<-}
\title{How often to write MCMC iterations to file}
\description{
A value greater than one means that not every MCMC iteration is written
to file.
}
\usage{
thin(x, ...)
}
\arguments{
  \item{x}{An object of class \code{XdeParameter}}
  \item{\dots}{not implemented}
}
\details{
  \code{thin} is an accessor for the first element in the vector
  returned by the method \code{output}.

  The replacement method replaces the first element in the \code{output}
  vector.

}

\value{
An integer.
}
\author{R. Scharpf}

\seealso{\code{\link{output}}}
\keyword{methods}

\name{hyperparameters}
\alias{hyperparameters}
\alias{hyperparameters<-}
\title{Accessor for hyperparameters of the Bayesian model}
\description{
  Accessor and replacement methods for hyperparameters of the Bayesian
  model are provided
}
\usage{
hyperparameters(object)
}
\arguments{
  \item{object}{An object of class \code{XdeParameter}}
}
\details{
  See the XdeParameterClass vignette for a more detailed discussion.
  The default values provided when initializing an object of class
  \code{XdeParameter} works well in most instances.
}
\value{
  A numerical vector
}
\references{

  R. Scharpf et al., A Bayesian Model for Cross-Study Differential Gene
  Expression, Technical Report 158, Johns Hopkins University, Department
  of Biostatistics, 2007

}
\author{R. Scharpf}
\examples{

data(expressionSetList)
xlist <- new("XdeParameter", esetList=expressionSetList, phenotypeLabel="adenoVsquamous")
hyperparameters(xlist)

}
\keyword{methods}

\name{expressionSetList}
\alias{expressionSetList}
\docType{data}
\title{Example of ExpressionSetList}
\description{
  Object of class \code{ExpressionSetList} containing three
  studies. Each element in the list is an \code{ExpressionSet}
}
\usage{data(expressionSetList)}

\details{

  Parmigiani et al. (2004) performed a cross-study analysis of three
  lung cancer studies.  The studies used in this analysis were merged by
  UniGene identifiers to obtain a set of 3,171 gene.  The R experiment
  data package \code{lungExpression} that was developed to facilitate
  the reproducibility of this analysis contains the three studies as
  ExpressionSets.  Here, we take a random sample of 500 features from
  one study (the "stanford" study), and split this study into three
  artificial studies that each contain 4 squamous carcinomas and 3
  adenocarcinomas.  The three artificial studies are then used to create
  an instance of the \code{ExpressionSetList} class.

  See Garber et al. (2001) for the raw data and description of the
  \code{stanford} study.
     
}
\source{

  The experiment data package lungExpression (\url{www.bioconductor.org})
  
}
\references{

    Parmigiani et al. (2004) A cross-study comparison of gene expression
  studies for the molecular classification of lung cancer, Clin Cancer
  Res, 10(9): 2922-2927

  Garber et al. (2001) Diversity of gene expression in adenocarcinoma of
  the lung, PNAS, 98:13784-13789

}

\examples{
data(expressionSetList)
}
\keyword{datasets}

\name{Parameters-class}
\Rdversion{1.1}
\docType{class}
\alias{Parameters-class}
\alias{[[<-,Parameters-method}
\alias{[[,Parameters-method}
\alias{$<-,Parameters-method}
\alias{$,Parameters-method}
\alias{coerce,XdeParameter,Parameters-method}
\alias{show,Parameters-method}

\title{Container for XDE parameters}
\description{Container for XDE parameters}

\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("Parameters", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{seed}:}{Object of class \code{"integer"} ~~ }
    \item{\code{data}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{phenodata}:}{Object of class \code{"integer"} ~~ }
    \item{\code{G}:}{Object of class \code{"integer"} ~~ }
    \item{\code{Q}:}{Object of class \code{"integer"} ~~ }
    \item{\code{S}:}{Object of class \code{"integer"} ~~ }
    \item{\code{alphaA}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{alphaB}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{betaA}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{betaB}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{pA0}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{pA1}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{pB0}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{pB1}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{nuR}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{nuRho}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{alphaXi}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{betaXi}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{c2Max}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{alphaEta}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{betaEta}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{pOmega0}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{lambdaOmega}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{lambdaKappa}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{gamma2}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{c2}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{tau2Rho}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{tau2R}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{a}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{b}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{l}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{t}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{lambda}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{theta}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{phi}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{sigma2}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{r}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{rho}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{nu}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{delta}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{Delta}:}{Object of class \code{"numeric"} ~~ }
    \item{\code{xi}:}{Object of class \code{"numeric"} ~~ }
  }
}
\section{Methods}{
  \describe{
    \item{"[[<-"}{\code{signature(x = "Parameters")}: ... }
    \item{"[["}{\code{signature(x = "Parameters")}: ... }
    \item{"$<-"}{\code{signature(x = "Parameters")}: ... }
    \item{$}{\code{signature(x = "Parameters")}: ... }
    \item{coerce}{\code{signature(from = "XdeParameter", to = "Parameters")}: ... }
    \item{show}{\code{signature(object = "Parameters")}: ... }
	 }
}

\examples{
showClass("Parameters")
}
\keyword{classes}

\name{xde}
\alias{xde}
\title{Fit the Bayesian hierarchical model for cross-study differential
  gene expression}

\description{

  Fits the Bayesian hierarchical model for cross-study differential
  gene expression.

}

\usage{

  xde(paramsMcmc, esetList, outputMcmc, batchSize=NULL, NCONC=2,
  center=TRUE, ...)

}


\arguments{
  \item{paramsMcmc}{Object of class \code{XdeParameter}}
  \item{esetList}{Object of class \code{ExpressionSetList}}
  \item{outputMcmc}{Object of class \code{XdeMcmc} (optional)}
  \item{batchSize}{Integer or NULL.  The number of iterations written to
  log files before summarizing the chain and then removing. Experimental.}
  \item{NCONC}{The number of studies for which a gene must be
  differentially expressed in the same direction to be considered as
  concordantly differentially expressed.}
\item{center}{Logical.  If TRUE, each study is centered to have mean
  zero.}
\item{\dots}{Additional arguments passed to \code{xdeFit}.}
}

\details{

  Details for fitting the Bayesian model are discussed elsewhere (see
  citation below and XdeParameterClass vignette)

  If an integer is specified for the batchSize, summary statistics for
  the log-files are calculated for every batchSize iterations.  The log
  files are then removed and the next iteration will start a new log
  file.  This allows one to do many iterations without creating enormous
  log files.  This is only reasonable to do if one has already assessed
  convergence.

}

\value{
  Object of class \code{XdeMcmc}
}

\references{

  R. Scharpf et al., A Bayesian Model for Cross-Study Differential Gene
  Expression, JASA 2009, p1295--1310.

}

\author{R. Scharpf}
\note{

  See the vignettes for XdeParameterClass and XDE.
}

\seealso{\code{\link{XdeMcmc-class}}, \code{\link{XdeParameter-class}}, \code{\link{ExpressionSetList-class}}}

\examples{
\dontrun{
  data(expressionSetList)
  xparam <- new("XdeParameter", phenotypeLabel="adenoVsquamous", esetList=expressionSetList)
  iterations(xparam) <- 10
  fit <- xde(xparam, esetList=expressionSetList)
}
}
\keyword{models}
\keyword{multivariate}

\name{XdeMcmc-class}
\docType{class}
\alias{XdeMcmc-class}
\alias{$}
\alias{$,XdeMcmc-method}
\alias{.standardizedDelta,XdeMcmc-method}
\alias{bayesianEffectSize}
\alias{bayesianEffectSize,XdeMcmc-method}
\alias{bayesianEffectSize<-}
\alias{bayesianEffectSize<-,XdeMcmc,matrix-method}
\alias{calculateBayesianEffectSize}
\alias{calculateBayesianEffectSize,XdeMcmc-method}
\alias{calculatePosteriorAvg,XdeMcmc-method}
\alias{directory}
\alias{directory,XdeMcmc-method}
\alias{featureNames,XdeMcmc-method}
\alias{initialize,XdeMcmc-method}
\alias{iterations,XdeMcmc-method}
\alias{lastMcmc,XdeMcmc-method}
\alias{nrow,XdeMcmc-method}
\alias{output,XdeMcmc-method}
\alias{plot,XdeMcmc-method}
\alias{plot,XdeMcmc,ANY-method}
\alias{posteriorAvg,XdeMcmc-method}
\alias{posteriorAvg<-,XdeMcmc,matrix-method}
\alias{seed,XdeMcmc-method}
\alias{show,XdeMcmc-method}
\alias{studyNames,XdeMcmc-method}

\title{Class for storing output from the Bayesian model}
\description{Stores output, including the last iteration of the MCMC.}

\section{Objects from the Class}{
  
  Objects can be created by calls of the form \code{new("XdeMcmc",
  studyNames, featureNames, iterations, seed, output, directory,
  lastMcmc, posteriorAvg, bayesianEffectSize)}.

}

\section{Slots}{
  \describe{
    \item{\code{studyNames}:}{Object of class \code{"character"} }
    \item{\code{featureNames}:}{Object of class \code{"character"} }
    \item{\code{iterations}:}{Object of class \code{"numeric"} }
    \item{\code{directory}:}{Object of class \code{"character"} }
    \item{\code{seed}:}{Object of class \code{"integer"} }
    \item{\code{output}:}{Object of class \code{"numeric"} }
    \item{\code{lastMcmc}:}{Object of class \code{"environment"} }
    \item{\code{posteriorAvg}:}{Object of class \code{"NULLorMatrix"} }
    \item{\code{bayesianEffectSize}:}{Object of class \code{"NULLorMatrix"} }
  }
}
\section{Methods}{
  \describe{
    \item{\code{$}}{\code{signature(x = "XdeMcmc")} }
    \item{.standardizedDelta}{\code{signature(object = "XdeMcmc")}}
    \item{bayesianEffectSize}{\code{signature(object = "XdeMcmc")} }
    \item{bayesianEffectSize<-}{\code{signature(object = "XdeMcmc",
	value = "matrix")} }
    \item{calculatePosteriorAvg}{\code{signature(object = "XdeMcmc")}:
  See \code{\link{calculatePosteriorAvg}}}
    \item{directory}{\code{signature(object = "XdeMcmc")} }
    \item{featureNames}{\code{signature(object = "XdeMcmc")} }
    \item{initialize}{\code{signature(.Object = "XdeMcmc")} }
    \item{iterations}{\code{signature(object = "XdeMcmc")} }
    \item{lastMcmc}{\code{signature(object = "XdeMcmc")} }
    \item{nrow}{\code{signature(x = "XdeMcmc")} }
    \item{output}{\code{signature(object = "XdeMcmc")} }
    \item{plot}{\code{signature(x = "XdeMcmc")} }
    \item{posteriorAvg}{\code{signature(object = "XdeMcmc")} }
    \item{seed}{\code{signature(object = "XdeMcmc")} }
    \item{show}{\code{signature(object = "XdeMcmc")} }
    \item{studyNames}{\code{signature(object = "XdeMcmc")} }
  }
}
\author{R. Scharpf}

\seealso{
  The class for storing the data: \code{\link{ExpressionSetList-class}}
  and the class that contains default options for fitting the Bayesian
  model: \code{\link{XdeParameter-class}}
}
      
\examples{
##See XDE vignette:
\dontrun{
openVignette(package="XDE")
}
}
\keyword{classes}

\name{ExpressionSetList-class}
\docType{class}
\alias{ExpressionSetList-class}
\alias{[,ExpressionSetList-method}
\alias{coerce,list,ExpressionSetList-method}
\alias{dim,ExpressionSetList-method}
\alias{featureNames,ExpressionSetList-method}
\alias{geneCenter,ExpressionSetList-method}
\alias{lapply,ExpressionSetList-method}
\alias{nSamples}
\alias{nSamples,ExpressionSetList-method}
\alias{nrow,ExpressionSetList-method}
\alias{pData,ExpressionSetList-method}
\alias{pca,ExpressionSetList-method}
\alias{phenotype,ExpressionSetList,character-method}
\alias{standardizeSamples,ExpressionSetList-method}
\alias{studyCenter,ExpressionSetList-method}
\alias{zeroNu,ExpressionSetList-method}

\title{A class for containing a list of ExpressionSets}

\description{Each element in the list must be a valid
  \code{ExpressionSet}.  The \code{featureNames} must be identical for
  each \code{ExpressionSet}. }
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("ExpressionSetList", ...)}.
}
\section{Slots}{
  \describe{
    \item{\code{.Data}:}{Object of class \code{"list"}}
  }
}
\section{Extends}{

  Class \code{"\linkS4class{list}"}, from data part.
  Class \code{"\linkS4class{vector}"}, by class "list", distance 2.
  Class \code{\link[Biobase]{class.AssayData}}, by class "list", distance 2.

}
\section{Methods}{
  \describe{


\item{"["}{\code{signature(x = "ExpressionSetList")} Subsets each
  \code{ExpressionSet} element in the list.}


\item{coerce}{\code{signature(from = "list", to = "ExpressionSetList")}
  Coerces a list of \code{ExpressionSet} objects to an object of class
  \code{ExpressionSetList}. The \code{validityMethod} for the
  \code{ExpressionSetList} class will return an error if the
  \code{featureNames} for each \code{ExpressionSet} are not identical.}

\item{dim}{\code{signature(x="ExpressionSetList")} applies \code{dim} to each
  element of the list. }

\item{featureNames}{\code{signature(object = "ExpressionSetList")}
  Accessor for the \code{featureNames}}

\item{geneCenter}{\code{signature(object = "ExpressionSetList")} See
  \code{\link{geneCenter}}}

\item{lapply}{\code{signature(object="ExpresssionSetList")} Coerces
  instance of ExpressionSetList to a list and does lapply on the list.
  Returns an object of class ExpressionSetList}

\item{nSamples}{\code{signature(x = "ExpressionSetList")} Numerical
  vector giving the number of samples in each \code{ExpressionSet}}

\item{nrow}{\code{signature(x = "ExpressionSetList")} Numerical: number
  of features or genes}

\item{pData}{\code{signature(object = "ExpressionSetList")} returns a
  list of \code{data.frames}.  The elements of the list correspond to
  the studies in the \code{ExpressionSetList} object.}

%\item{.pca}{\code{signature(object = "ExpressionSetList")} Runs
%  principal components to generate cross-study summary scores of
%  differential expression in multiple studies.  Not meant to be called
%  directly.  See \code{\link{xsScores}}.}
\item{phenotype}{\code{signature(object="ExpressionSetList",
    varLabel="character")}
  Accessor for the clinical variable. Assumes that the clinical variable
  has the same name in each study.
  }

\item{standardizeSamples}{\code{signature(object = "ExpressionSetList")}
  See \code{\link{standardizeSamples}}
}

\item{studyCenter}{\code{signature(object = "ExpressionSetList")}
  See \code{\link{studyCenter}}
}

\item{zeroNu}{\code{signature(object = "ExpressionSetList")}
  See \code{\link{zeroNu}}. }
}
}

\author{R. Scharpf}

\seealso{
  \code{\link{XdeMcmc-class}}, \code{\link{XdeParameter-class}}
}
\examples{
	showClass("ExpressionSetList")
	data(expressionSetList)
}
\keyword{classes}

\name{output}
\alias{output}
\alias{output<-}
\title{Options for storing results of the MCMC chains}
\description{
  A numeric vector indicating which chains to write to file and, for those
  parameters that are written to file, how often the chains should be
  written to file.  
}
\usage{
output(object)
}
\arguments{
  \item{object}{An object of class \code{XdeParameter} or \code{XdeMcmc} }
}
\details{
Replacement methods are only available for objects
  of class \code{XdeParameter}.  Accessor methods are available for
  objects of class \code{XdeParameter} and \code{XdeMcmc}.
}
\value{
  A named numerical vector.  The first element (thin) specifies how often to write
  chains to file.  For instance, if output[1]=2 the chains will be
  written to file every other iteration.  Elements 2 - 22 of the vector
  are indicators for whether to write the write the chains of the
  Bayesian parameters to file. 
}
\author{R. Scharpf}

\note{

  Parameters indexed by gene and study (Delta, Phi, Nu, and sigma2) grow
  very large quickly.

}

\seealso{\code{\link{burnin}}, \code{\link{XdeParameter-class}}, \code{\link{XdeMcmc-class}}}
\examples{
data(xmcmc)
output(xmcmc)
}
\keyword{methods}

\name{ssStatistic}
\alias{ssStatistic}
\title{Calculate single study estimates of effect size}
\description{
  Calculate single study estimates of effect size for lists of \code{ExpressionSets}
}
\usage{
ssStatistic(statistic = c("t", "sam", "z")[1], phenotypeLabel, esetList, ...)
}
\arguments{
  \item{statistic}{Character string indicating Welch t-statistic (t), SAM (sam), or a z-statistic (z)}
  \item{phenotypeLabel}{Character string indicating the name of the binary covariate}
  \item{esetList}{An object of class \code{ExpressionSetList}}
  \item{\dots}{Not implemented. Potentially additional arguments to the
  above methods that are implemented in other packages}
}

\details{

  This function is a wrapper that provides an estimate of effect size
  for each study (element) in an \code{ExpressionSetList} object.

  For Welch t-statistic, this function is a wrapper for mt.teststat in the
  multtest package.
  
  For SAM, this function is a wrapper for the sam function in the
  siggenes package.

  The "z" statistic is a standardized unbiased estimate of effect size
  (Hedges and Olkin, 1985) -- implementation is in the zScores
  function in the R package GeneMeta.

See the complete references below.                  
  
}

\value{
  
  A matrix: rows are genes and columns are studies
  
}

\references{

J.K. Choi, U. Yu, S. Kim, and O.J. Yoo (2003), Combining multiple
  microarray studies and modeling interstudy variation, Bioinformatics,
  19(1) I84-I90.

Y. Ge, S. Dudoit & T. P. Speed (2003), Resampling-based multiple testing
for microarray data hypothesis Test 12(1) : 1-44 (with discussions on
44-77).

L. Lusa R. Gentleman, and M. Ruschhaupt, GeneMeta: MetaAnalysis for High
Throughput Experiments

L.V. Hedges and I. Olkin, Statistical Methods for Meta-analysis
(1985), Academic Press

Tusher, Tibshirani and Chu (2001), Significance analysis of microarrays
applied to the ionizing radiation response, PNAS 2001 98: 5116-5121,
(Apr 24).

}
\author{R. Scharpf}
\examples{

data(expressionSetList)
if(require(siggenes)){
  sam <- ssStatistic("sam", esetList=expressionSetList, phenotypeLabel="adenoVsquamous")
}  
}
\keyword{methods}

\name{standardizeSamples}
\alias{standardizeSamples}
\title{Centers the genes at zero and standardizes the samples to have
  variance 1}

\description{
  
  For each study (element) in an \code{ExpressionSetList} object, this
  function centers the genes to have mean zero (rows) and scales the
  variance of the samples to 1.
  
}

\usage{
standardizeSamples(object, ...)
}

\arguments{
  \item{object}{Object of class \code{ExpressionSetList}}
  \item{\dots}{ Additional arguments not implemented}
}

\value{
  An object of class \code{ExpressionSetList}
}
\author{R. Scharpf}
\note{

  Requires genefilter package
  
}
\keyword{methods}

\name{iterations}
\alias{iterations}
\alias{iterations<-}
\title{Number of MCMC iterations}
\description{
  Number of MCMC iterations
}
\usage{
iterations(object)
}
\arguments{
  \item{object}{ An object of class \code{XdeParameter} or
    \code{XdeMcmc}.}
}

\details{

  For an object of class \code{XdeParameter}, \code{iterations}
  specifies the total number of MCMC iterations. Note that by setting
  the \code{thin} parameter to a value greater than 1, the number of
  MCMC iterations will be greater than the number of saved MCMC
  iterations (saved iterations = iterations / thin).

  For an object of class \code{XdeMcmc} (a class that stores output from
  the MCMC), \code{iterations} specifies the number of iterations that
  were saved.

  The replacement method is only defined for the \code{XdeParameter}
  class.  The class \code{XdeMcmc} is meant to reflect the information
  in an already run chain, whereas \code{XdeParameter} is a class for
  parameterizing the Bayesian model that has not yet been fit.

}

\value{
  An integer
}
\author{R. Scharpf}
\seealso{\code{\link{XdeParameter-class}}, \code{\link{XdeMcmc-class}}}
\keyword{methods}

\name{studyCenter}
\alias{studyCenter}
\title{Center the expression values in a study to zero}
\description{
  Centers each study in a list so that the average expression value of
  each stuy is zero
}
\usage{
studyCenter(object)
}
\arguments{
  \item{object}{ An object of class \code{ExpressionSetList}}
}
\value{
  An object of class \code{ExpressionSetList}
}
\author{R. Scharpf}
\seealso{\code{\link{geneCenter}}, \code{\link{ExpressionSetList-class}}}
\examples{
  data(expressionSetList)
  centered <- studyCenter(expressionSetList)
  lapply(centered, function(object) round(mean(exprs(object)), 4))
}
\keyword{methods}

\name{ExpressionSetList-methods}
%\docType{methods}
\alias{ExpressionSetList-methods}
%\alias{[,ExpressionSetList-method}
%\alias{coerce,list,ExpressionSetList-method}
%\alias{dim,ExpressionSetList-method}
%\alias{lapply,ExpressionSetList-method}
\alias{[,ExpressionSetList,ANY,ANY,ANY-method}
\alias{phenotype}
\title{Methods for ExpressionSetList}
\description{
  Methods for objects of class \code{ExpressionSetList}.
}

\usage{
  phenotype(object, varLabel)
}



\arguments{

  \item{object}{ A \code{ExpressionSetList}.}

  \item{varLabel}{\code{character}.  Name of the clinical variable.}

}


\value{

  \code{phenotype} returns a matrix of the clinical variable where each
  column is a study.  We require that the clinical variable have the
  same name in each study (each element of the \code{ExpressionSetList}
  object) and that the clinical variable is binary with values 1 or 0.


}

\keyword{methods}
\keyword{manip}

\name{Test-package}
\alias{Test-package}
\alias{Test}
\docType{package}
\title{
What the package does (short line)
~~ package title ~~
}
\description{
More about what it does (maybe more than one line)
~~ A concise (1-5 lines) description of the package ~~
}
\details{
\tabular{ll}{
Package: \tab Test\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2012-06-10\cr
License: \tab What license is it under?\cr
}
~~ An overview of how to use the package, including the most important ~~
~~ functions ~~
}
\author{
Who wrote it

Maintainer: Who to complain to <yourfault@somewhere.net>
~~ The author and/or maintainer of the package ~~
}
\references{
~~ Literature or other references for background information ~~
}
~~ Optionally other standard keywords, one per line, from file KEYWORDS in ~~
~~ the R documentation directory ~~
\keyword{ package }
\seealso{
~~ Optional links to other man pages, e.g. ~~
~~ \code{\link[<pkg>:<pkg>-package]{<pkg>}} ~~
}
\examples{
~~ simple examples of the most important functions ~~
}
